//generates a movie of separation of mandelbrot set period 3 bulb of z^3-z+c inner version using DHViewer
//To run this file from terminal put it in a folder, cd to the folder and input
//
//gcc -o mando blowupdend.c -lm && ./mando
//To run successive compiled versions type ./mando

#include <stdio.h>
#import <complex.h>

double pi=3.14159;
int frames = 41; //number of movie frames - normally use 500-1000!
const char base[] = "Params";

void WriteParamFile(int frameno, double param1, double param2);

int main(void)
{
FILE *mf;
char filename [ FILENAME_MAX ];
int filetyp = 3;
int k;
double xstt = 0.690695;
double xend = 0.1;
double xpos; 
double ypos = 0;
sprintf(filename, "%s.txt", base);
mf=fopen(filename,"w");
fprintf(mf,"%f %f \n",(float)filetyp, (float)frames);
fclose(mf);
xpos=xstt;
for(k=0;k<frames;k++)
	{
	xpos=xstt+(xend-xstt)*k/(frames-1);
	WriteParamFile(k, (double)xpos, (double)ypos);
	}
return 0;
}

void WriteParamFile(int frameno, double param1, double param2)
{
FILE *mf;
char filename [ FILENAME_MAX ];
int j;
//if (param1<0) param1=-1-cpow(10,-(10+param1/20));
//if (param1==0) param1=-1;	
//if (param1>0) param1=-1+cpow(10,-(10-param1/20));

double specs[37];
double mandel=1;
double scale=param1;
double screenX=-0.601646;
double screenY=0.684404;
double cx=0;
double cy=0;
double thisfn=3;
double escType=1;
double orbitTrapE=2; // orbittrap + 2*dF 
double escapeOnly=0;
double colorScheme=1;
double escapeBoundExp=1.666667;
double attractorEscBd=-2;
double maxIterations=512;
double kx=3;
double ky=0;
double oldfn=thisfn;

specs[0]=mandel;
specs[1]=scale;
specs[2]=screenX;
specs[3]=screenY;
specs[4]=cx;
specs[5]=cy;
specs[6]=thisfn;
specs[7]=escType; // abs, real, or imag
specs[8]=orbitTrapE; //orbit trap and dF
specs[9]=escapeOnly;
specs[10]=colorScheme;
specs[11]=escapeBoundExp; //escape bound exponent
specs[12]=attractorEscBd; //attractor escape bound 10^-k
specs[13]=maxIterations; //iterations
specs[14]=kx; //real k
specs[15]=ky; //imag k
specs[16]=oldfn; 
specs[17]=987.654321; 
specs[18]=1;
specs[20]=1;
specs[26]=0;
specs[28]=0;
specs[31]=1;
specs[35]=1;
specs[36]=0;

sprintf(filename, "%s%d.txt", base, frameno);
//printf("filename = \"%s\"\n", filename);
mf=fopen(filename,"w");
for (j=0;j<37;j++)
    fprintf(mf,"%f ",specs[j]);
fclose(mf);
}