//generates a blowup of the moduli space of the parameter plane of z^8-z+c
//To run this file from terminal put it in a folder, cd to the folder and input
//
//gcc -o mando moduli8.c -lm && ./mando
//To run successive compiled versions type ./mando

#include <stdio.h>
#import <math.h>

double pi=3.14159;
int frames = 41; //number of movie frames - normally use 500-1000!
const char base[] = "Params";

void WriteParamFile(int frameno, double param1, double param2);

int main(void)
{
FILE *mf;
char filename [ FILENAME_MAX ];
int filetyp = 3;
int k;
double xstt = 50;
double xend = 1e-8;
double xpos,apos; 
double ypos = 0;
sprintf(filename, "%s.txt", base);
mf=fopen(filename,"w");
fprintf(mf,"%f %f \n",(float)filetyp, (float)frames);
fclose(mf);
xpos=xstt;
for(k=0;k<frames;k++)
	{
	//apos=xstt+(xend-xstt)*k/(frames-1);
	apos=xstt*pow((xend/xstt),((double)k/((double)frames-1)));
	//xpos=(-0.7393684387207031)*(1.0-apos)+(-0.4393055737018585)*apos;
	//ypos= 0.9445160627365112*(1.0-apos)+ 1.086462020874023*apos;
	xpos=apos;
	WriteParamFile(k, (double)xpos, (double)ypos);
	}
return 0;
}

void WriteParamFile(int frameno, double param1, double param2)
{
FILE *mf;
char filename [ FILENAME_MAX ];
int j;

double specs[37];
double mandel=1;
double scale=param1;
double screenX=0;
double screenY=0;
double cx=0;
double cy=0;
double thisfn=3;
double escType=0;
double orbitTrapE=1;
double escapeOnly=1;
double colorScheme=3;
double escapeBoundExp=1.666667;
double attractorEscBd=-4;
double maxIterations=128;
double dolog=0;
double kx=8;
double ky=1;
double oldfn=thisfn;

specs[0]=mandel;
specs[1]=scale;
specs[2]=screenX;
specs[3]=screenY;
specs[4]=cx;
specs[5]=cy;
specs[6]=thisfn;
specs[7]=escType; // abs, real, or imag
specs[8]=orbitTrapE; //orbit trap epsilon)
specs[9]=escapeOnly;
specs[10]=colorScheme;
specs[11]=escapeBoundExp; //escape bound exponent
specs[12]=attractorEscBd; //attractor escape bound 10^-k
specs[13]=maxIterations; //iterations
specs[14]=kx; //real k
specs[15]=ky; //imag k
specs[16]=oldfn; 
specs[17]=987.654321; 
specs[18]=1;
specs[20]=1;
specs[26]=0;
specs[28]=0;
specs[31]=1;
specs[35]=1;
specs[36]=0;

sprintf(filename, "%s%d.txt", base, frameno);
//printf("filename = \"%s\"\n", filename);
mf=fopen(filename,"w");
for (j=0;j<37;j++)
    fprintf(mf,"%e ",specs[j]);
fclose(mf);
}