
//generates a movie of Julia sets of z^3+n/z+c 
//The C-script interpolates fact=50 times as many points between, to make a 7*50+1=351 frame movie
//To run this file from terminal put it in a folder, cd to the folder and input
//
//gcc -o mando rational3j.c -lm && ./mando
//To run successive compiled versions type ./mando

#include <stdio.h>

double pi=3.14159;
int pts = 7;
int fact = 50;
int frames; //number of movie frames - normally use 500-1000!
const char base[] = "Params";
double ik=1.00698530673981;
double xpts[7]={0, 0.0877187475562096, 0.32973438501358, 0.37007811665535, 0.36209374666214, 0.281093746423721, 0};
double ypts[7]={0, -0.289750009775162, -0.34018748998642, -0.216921880841255, -0.0790468752384186, -0.00984374992549419, 0};


void WriteParamFile(int frameno, double param1, double param2, double param3);

int main(void)
{
FILE *mf;
char filename [ FILENAME_MAX ];
frames=fact*(pts-1)+1;
int filetyp = 3;
int j,k,f;
//double xstt = 0;
//double xend = 1;
double xpos,apos,m; 
double ypos = 0;
sprintf(filename, "%s.txt", base);
mf=fopen(filename,"w");
fprintf(mf,"%f %f \n",(float)filetyp, (float)frames);
fclose(mf);
//xpos=xstt;
for(k=0;k<frames;k++)
	{
//	apos=xstt+(xend-xstt)*k/(frames-1);
	f=(int)((k)/fact);
	m=1.0*(k-fact*f)/fact;
       	if (k<frames-1) 
		{
            	xpos=(1-m)*xpts[f]+m*xpts[f+1];
           	ypos=(1-m)*ypts[f]+m*ypts[f+1];
		}
        else
 		{
            	xpos=xpts[f];
           	ypos=ypts[f];
		}
	WriteParamFile(k, (double)xpos, (double)ypos, (double)ik);
	}
return 0;
}

void WriteParamFile(int frameno, double param1, double param2, double param3)
{
FILE *mf;
char filename [ FILENAME_MAX ];
int j;

double specs[37];
double mandel=0;
double scale=3.5;
double screenX=0;
double screenY=0;
double cx=param1;
double cy=param2;
double thisfn=29;
double escType=0;
double orbitTrapE=0;
double escapeOnly=0;
double colorScheme=4;
double escapeBoundExp=2.7;
double attractorEscBd=-4;
double maxIterations=256;
double dolog=0;
double kx=3;
double ky=1.00698530673981;
double oldfn=thisfn;

specs[0]=mandel;
specs[1]=scale;
specs[2]=screenX;
specs[3]=screenY;
specs[4]=cx;
specs[5]=cy;
specs[6]=thisfn;
specs[7]=escType; // abs, real, or imag
specs[8]=orbitTrapE; //orbit trap epsilon)
specs[9]=escapeOnly;
specs[10]=colorScheme;
specs[11]=escapeBoundExp; //escape bound exponent
specs[12]=attractorEscBd; //attractor escape bound 10^-k
specs[13]=maxIterations; //iterations
specs[14]=kx; //real k
specs[15]=ky; //imag k
specs[16]=oldfn; 
specs[17]=987.654321; 
specs[18]=1;
specs[20]=1;
specs[26]=0;
specs[28]=0;
specs[31]=1;
specs[35]=1;
specs[36]=0;

sprintf(filename, "%s%d.txt", base, frameno);
//printf("filename = \"%s\"\n", filename);
mf=fopen(filename,"w");
for (j=0;j<37;j++)
    fprintf(mf,"%f ",specs[j]);
fclose(mf);
}