//generates a large Julia set using DHViewer
//To run this file from terminal put it in a folder, cd to the folder and input
//
//gcc -o mando large.c -lm && ./mando
//To run successive compiled versions type ./mando

#include <stdio.h>

double pi=3.14159;
const char base[] = "Params";
int wid=6; //no of frames wide <=hgt
int hgt=10; //no frames vertically used also to make rescaling
double scal=200;

void WriteParamFile(int frameno, double param1, double param2);

int main(void)
{
FILE *mf;
char filename [ FILENAME_MAX ];
int filetyp = 3;

int k;
double xstt = -scal/2/hgt*(wid-1);;
double xend = -xstt;
double xpos; 
double ystt = scal/2/hgt*513/750*(hgt-1);
double yend = -ystt;
double ypos;
sprintf(filename, "%s.txt", base);
mf=fopen(filename,"w");
fprintf(mf,"%f %f \n",(float)filetyp, (float)wid*hgt);
fclose(mf);
xpos=xstt;
for(k=0;k<wid*hgt;k++)
	{
	xpos=xstt+(xend-xstt)*(double)(k%wid)/(wid-1);
	ypos=ystt+(yend-ystt)*(k-k%wid)/wid/(hgt-1);
	WriteParamFile(k, (double)xpos, (double)ypos);
	}
return 0;
}

void WriteParamFile(int frameno, double param1, double param2)
{
FILE *mf;
char filename [ FILENAME_MAX ];
int j;

double specs[37];
double mandel=0;
double scale=scal/hgt;
double screenX=param1;
double screenY=param2;
double cx=-0.995626986026764;
double cy=1.93703699111938;
double thisfn=17;
double escType=0;
double orbitTrapE=0;
double escapeOnly=0;
double colorScheme=3;
double escapeBoundExp=4;
double attractorEscBd=-4;
double maxIterations=4096;
double dolog=0;
double kx=24;
double ky=-3.1;
double oldfn=thisfn;

specs[0]=mandel;
specs[1]=scale;
specs[2]=screenX;
specs[3]=screenY;
specs[4]=cx;
specs[5]=cy;
specs[6]=thisfn;
specs[7]=escType; // abs, real, or imag
specs[8]=orbitTrapE; //orbit trap epsilon)
specs[9]=escapeOnly;
specs[10]=colorScheme;
specs[11]=escapeBoundExp; //escape bound exponent
specs[12]=attractorEscBd; //attractor escape bound 10^-k
specs[13]=maxIterations; //iterations
specs[14]=kx; //real k
specs[15]=ky; //imag k
specs[16]=oldfn; 
specs[17]=987.654321; 
specs[18]=1;
specs[20]=1;
specs[26]=0;
specs[28]=0;
specs[31]=1;
specs[35]=1;
specs[36]=0;

sprintf(filename, "%s%d.txt", base, frameno);
//printf("filename = \"%s\"\n", filename);
mf=fopen(filename,"w");
for (j=0;j<37;j++)
    fprintf(mf,"%f ",specs[j]);
fclose(mf);
}