#import "MyView.h"
#include <unistd.h>
#include "mandel.h"
#import "MTRectTools.h"
#import <complex.h>

#define kCollapseDrag 12.0

@implementation MyView

int stbut=1;
int cval=0;
int mval=0;
double _Complex kk=2.0;
int thrds;
int powr=2;
int frms,thisfrm;
char mychar[100], ldchar[100];
bool movfl=FALSE;
int fltyp;
double critsep;



// randomizerSwitch; has been set to toggle "fill" determining whether the window scope is kept on clicking
// clearSwitch is vacant
// originSwitch toggles orbit trap
// doReportButton sets c vales to the text field's values
// doResetOriginButton sets window centre (x,y) and scale from the test field's values
// ThdZeta is set to determine the escape bounds abs, real imag, or square.

- (NSImage *) transformedImage  // provides the image in its transformed state, in case you want to save it.
  {
  NSSize 
    imageSize = [self bounds].size;
    
  NSImage 
    *newImage = [[NSImage alloc] initWithSize:imageSize];
    
 // NSGraphicsContext
 //   *context;
	
  NSRect currentFrame;
    
  currentFrame = [self bounds];
  
      
  [newImage lockFocus];  
 // context = [NSGraphicsContext currentContext];
		// Must use the CG call here because I'm not drawing in an NSView.
 // CGContextTranslateCTM([context graphicsPort], imageSize.width/2, imageSize.height/2); // Move the origin to the center.
 // [self drawImage]; 
  [myImage drawInRect:currentFrame];
  [newImage unlockFocus];  
  return [newImage autorelease]; 
  }

- (IBAction)doOpen:(id)sender
  {
  [[NSOpenPanel openPanel]  // Get the shared open panel
    beginSheetForDirectory:NSHomeDirectory()	// Point it at the user's home
    file:nil
    modalForWindow:window  // This makes it show up as a sheet, attached to window
    modalDelegate:self		// Tell me when you're done.
    didEndSelector:@selector(openPanelDidEnd:returnCode:contextInfo:)  // Call this method when you're done..
    contextInfo:NULL];  
  }

- (void) openPanelDidEnd:(NSOpenPanel *)sheet returnCode:(int)returnCode contextInfo:(void  *)contextInfo
  {
 // [self setImage:[[[NSImage alloc] initWithContentsOfFile:[sheet filename]]autorelease]];
   //read from the file
	int j,foffset;
    float myf;
    double myar[37];
      

	//NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
	NSString *string = [[NSString alloc] initWithContentsOfFile:[sheet filename]];
    if(string == nil)
    {
        //NSLog(@"Error reading file");
        return ;
    }
	 
    //scan the integers from the file
    NSScanner *scanner = [[NSScanner alloc] initWithString:string];
	j=0;
    while([scanner isAtEnd] == NO)
    {
		[scanner scanFloat:&myf];
		myar[j]=myf;
		j=j+1;
        //NSLog(@"Value : %f", myf);
	}
	mandel=(int)myar[0];
	viewStep = myar[1] / frame.size.width;
	viewX = myar[2]-(double) frame.size.width * viewStep * 0.5;
	viewY = myar[3]+(double) frame.size.height * viewStep * 0.5;
	originX = myar[4];
	originY = myar[5];
	//altnGamma=(int)myar[6];
	thisfn=(int)myar[6];
	dzet=(int)myar[7];
	orbtrap=(BOOL)((int)myar[8]%2);
	dz=(BOOL)(((int)myar[8] / 2) % 2);
	mval=(BOOL)((int)myar[8] / 4);
	esconly=(BOOL)myar[9];
	altcol=(int)myar[10];
	escapeRadius=myar[11];
	//zetaTerms=myar[13];
	attractorTerms=myar[12];
	max_dwells=(int)myar[13];
	kk=myar[14]+myar[15]*I;
	oldfn=(int)myar[16];
	for (j=0;j<=5;j++)	
		coeffs[j]=myar[18+2*j]+I*myar[18+2*j+1];
	for (j=0;j<=6;j++)
		prms[j]=(int)myar[30+j];
		
	  if (thisfn<=3)  foffset=thisfn;
	  if ((thisfn>=4)&&(thisfn<=15)) foffset=thisfn+2;
	  if ((thisfn>=16)&&(thisfn<=17)) foffset=thisfn+5;
	  if (thisfn==18) foffset=4;
	  if (thisfn==19) foffset=18;
	  if (thisfn==20) foffset=5;
	  if (thisfn==21) foffset=19;
	  if (thisfn==22) foffset=20;
	  if (thisfn>=23) foffset=thisfn;
	  
	  //[myFunction selectItemAtIndex:thisfn-1];
	[myFunction selectItemAtIndex:foffset-1];
	[ThdZeta selectItemAtIndex:dzet];
	[Coloring selectItemAtIndex:altcol];
	[dwellMenu selectItemAtIndex:(int)(log(max_dwells)/log(2)-6)];
	[originSwitch setIntValue:orbtrap];
	[escapeOnly setIntValue:esconly];
	[dFn setIntValue:dz];
	[escapeRadiusSlider setFloatValue:escapeRadius];
	[attractorSlider setFloatValue:attractorTerms];
	[RealC setFloatValue:originX];
	[ImagC setFloatValue:originY];
	[RealPart setFloatValue:viewX+(double) frame.size.width * viewStep * 0.5];
	[ImagPart setFloatValue:viewY-(double) frame.size.height * viewStep * 0.5];
	[Scale setFloatValue:viewStep*frame.size.width];	
	//[pool drain];
	//printf("%f\n",originX);
	//if (mandel==1)
		//mval=1;
	[self startButton:nil];
	
}


- (IBAction)doLoad:(id)sender
{
  [[NSOpenPanel openPanel]  // Get the shared open panel
    beginSheetForDirectory:NSHomeDirectory()	// Point it at the user's home
    file:nil
    modalForWindow:window  // This makes it show up as a sheet, attached to window
    modalDelegate:self		// Tell me when you're done.
    didEndSelector:@selector(mopenPanelDidEnd:returnCode:contextInfo:)  // Call this method when you're done..
    contextInfo:NULL];  
}

- (void) mopenPanelDidEnd:(NSOpenPanel *)sheet returnCode:(int)returnCode contextInfo:(void  *)contextInfo
  {
	int j,k;
	float myf;
	float strt[5],fnsh[5];
	char *ldp=NULL;

NSString *string = [[NSString alloc] initWithContentsOfFile:[sheet filename]];
if(string == nil)
    {
        //NSLog(@"Error reading file");
        return ;
    }
	 
	//ldp=malloc(sizeof(char)*(101));
	ldp=[[sheet filename] UTF8String];
//	printf("%s\n",ldp);
	strcpy(ldchar,ldp);
//	for (j=0;j<=99;j++)
//			printf("%d ",ldchar[j]);
//	printf("\n");
	for (j=99;j>=0;j--)
		{
	//	printf("%d %d\n", j, ldchar[j]);
		if ((int)ldchar[j]==46)
			{
			for (k=j;k<=j+3;k++)
				ldchar[k]=0;
		//	printf("**");
			break;
			}
		}
	strcpy(ldp,ldchar);
	//printf("%s\n",ldp);
	//free(ldp);
	//for (j=0;j<=99;j++)
	//		printf("%d ",ldchar[j]);
	//printf("\n");
    //scan the integers from the file
    NSScanner *scanner = [[NSScanner alloc] initWithString:string];
	j=0;
    while([scanner isAtEnd] == NO)
    {
		[scanner scanFloat:&myf];
		movar[j]=myf;
		j=j+1;
        //NSLog(@"Value : %f", myf);
	}
	fltyp=(int)movar[0];
	if ((fltyp<1)||(fltyp>3)) 
		fltyp=1;
	frms=(int)movar[1];
	if ((frms>1000)||(frms<1))
		frms=1;
	//mandel=movar[2];
//	printf("%d\n",fltyp);
	if (fltyp==1)
		{
		for (j=0;j<5;j++)
			{
			strt[j]=movar[j+3];
			fnsh[j]=movar[j+8];
			}
		for (k=0;k<frms;k++)
			for (j=0;j<5;j++)			
				movar[3+j+k*5]=(1-(double)k/(frms-1))*strt[j]+(double)k/(frms-1)*fnsh[j];
		}
//	for (j=0;j<3+5*frms;j++)
//		printf("%d %f\n",j, movar[j]);
	
}

- (IBAction)doMovie:(id)sender
{
 [[NSSavePanel savePanel]
    beginSheetForDirectory:NSHomeDirectory()  // seems like a reasonable place to start..
    file:@"Movie" 	// default filename
    modalForWindow:window   //Run as a sheet, attached to "window"
    modalDelegate:self 	// The save panel should call me when it's done..
    didEndSelector:@selector(msavePanelDidEnd:returnCode:contextInfo:) // ... using this selector
    contextInfo:NULL];			
}	  

-(void) loadframe
	{
	NSString *ms;
	int j,foffset;
    float myf;
    double myar[37];
	char *ldp=NULL;

	//for (j=0;j<=99;j++)
	//		printf("%d ",ldchar[j]);
	//printf("\n");
	ldp=malloc(sizeof(char)*(101));
	strcpy(ldp,ldchar); 
	//printf("%s\n",ldp);
	ms = [NSString stringWithFormat: @"%d", thisfrm];
	ms = [NSString stringWithFormat:@"%@%@.%@", [NSString stringWithUTF8String: ldp], ms, @"txt"];
	free(ldp);
	 // [self setImage:[[[NSImage alloc] initWithContentsOfFile:[sheet filename]]autorelease]];
   //read from the file

	//NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
	NSString *string = [[NSString alloc] initWithContentsOfFile: ms];
    /*NSString *string = [[NSString alloc]initWithContentsOfFile:(NSString *)ms
                                                          encoding:(NSStringEncoding)1
                                                             error:(NSError * _Nullable *)NULL];*/
 if(string == nil)
    {
		//NSLog(@"Error reading file");
        return ;
    }
	 
    //scan the integers from the file
    NSScanner *scanner = [[NSScanner alloc] initWithString:string];
	j=0;
    while([scanner isAtEnd] == NO)
    {
		[scanner scanFloat:&myf];
		myar[j]=myf;
		j=j+1;
        //NSLog(@"Value : %f", myf);
	}
//	for (j=1;j<=37;j++)
//		printf("%f ",myar[j]);
//	printf("\n");	
	mandel=(int)myar[0];
	viewStep = myar[1] / frame.size.width;
	viewX = myar[2]-(double) frame.size.width * viewStep * 0.5;
	viewY = myar[3]+(double) frame.size.height * viewStep * 0.5;
	originX = myar[4];
	originY = myar[5];
	thisfn=(int)myar[6];
	dzet=(int)myar[7];
	orbtrap=(BOOL)((int)myar[8]%2);
	dz=(BOOL)(((int)myar[8] / 2) % 2);
	mval=(BOOL)((int)myar[8] / 4);
	esconly=(BOOL)myar[9];
	altcol=(int)myar[10];
	escapeRadius=myar[11];
	attractorTerms=myar[12];
	max_dwells=(int)myar[13];
	kk=myar[14]+myar[15]*I;
	oldfn=(int)myar[16];
	for (j=0;j<=5;j++)	
		coeffs[j]=myar[18+2*j]+I*myar[18+2*j+1];
	for (j=0;j<=6;j++)
		prms[j]=(int)myar[30+j];

		if (thisfn<=3)  foffset=thisfn;
		if ((thisfn>=4)&&(thisfn<=15)) foffset=thisfn+2;
		if ((thisfn>=16)&&(thisfn<=17)) foffset=thisfn+5;
		if (thisfn==18) foffset=4;
		if (thisfn==19) foffset=18;
		if (thisfn==20) foffset=5;
		if (thisfn==21) foffset=19;
		if (thisfn==22) foffset=20;
		if (thisfn>=23) foffset=thisfn;
		
	[myFunction selectItemAtIndex:foffset-1];
	[ThdZeta selectItemAtIndex:dzet];
	[Coloring selectItemAtIndex:altcol];
	[dwellMenu selectItemAtIndex:(int)(log(max_dwells)/log(2)-6)];
	[originSwitch setIntValue:orbtrap];
	[escapeOnly setIntValue:esconly];
	[dFn setIntValue:dz];
	[escapeRadiusSlider setFloatValue:escapeRadius];
	[attractorSlider setFloatValue:attractorTerms];
	[RealC setFloatValue:originX];
	[ImagC setFloatValue:originY];
	[RealPart setFloatValue:viewX+(double) frame.size.width * viewStep * 0.5];
	[ImagPart setFloatValue:viewY-(double) frame.size.height * viewStep * 0.5];
	[Scale setFloatValue:viewStep*frame.size.width];	
	//[pool drain];
	//[self startButton:nil];
	

	}

- (void) msavePanelDidEnd:(NSSavePanel *)sheet returnCode:(int)returnCode contextInfo:(void  *)contextInfo
  {
  char *flp=NULL;
  
  if (returnCode == NSModalResponseOK)
	{
//	flp=malloc(sizeof(char)*(101));
	flp=[[sheet filename] UTF8String];
	strcpy(mychar,flp);
//	free(flp);
	movfl=TRUE;
	thisfrm=0;
	if (fltyp==3)
		{
		[self loadframe];
		}
	else
	{
	mandel=(int)movar[2];
	[RealPart setFloatValue:movar[3+5*thisfrm]];
	[ImagPart setFloatValue:movar[3+5*thisfrm+1]];
	[Scale setFloatValue:movar[3+5*thisfrm+2]];	
    [RealC setFloatValue:movar[3+5*thisfrm+3]];
	[ImagC setFloatValue:movar[3+5*thisfrm+4]];
	viewStep = [Scale floatValue] / frame.size.width;
	viewX = [RealPart floatValue]-(double) frame.size.width * viewStep * 0.5;
	viewY = [ImagPart floatValue]+(double) frame.size.height * viewStep * 0.5;
	originX = [RealC floatValue];
	originY = [ImagC floatValue];
	} 
	[self startButton:nil];

	myTimer =[NSTimer scheduledTimerWithTimeInterval:1
			target:self selector:@selector(myTimerMethod)
			userInfo:nil repeats:YES];
	}
 }
 
 -(void) myTimerMethod
 
 {
 NSString *ms;
 char *flp=NULL;

// printf("*");
 if (thrds==num_threads)
	{
	flp=malloc(sizeof(char)*(101));
	strcpy(flp,mychar); 
	ms = [NSString stringWithFormat: @"%d", thisfrm];
  [[[self transformedImage] TIFFRepresentationUsingCompression:(NSTIFFCompression)NSTIFFCompressionLZW factor:(float)5]  // Create the contents of a .tiff file
	  writeToFile:[NSString stringWithFormat:@"%@%@.%@", [NSString stringWithUTF8String: flp], ms, @"tif"] // save it at the path we get from the panel.
      atomically:YES];  // That's about all there is to it...
  //  printf("%f %f %f\n", movar[0], movar[1], movar[2]);
    free(flp);
	thisfrm++;
	movfl=TRUE;
if (thisfrm<frms)
	{
	if (fltyp==3)
		{
		[self loadframe];
		}
	else
		{
		mandel=(int)movar[2];
		[RealPart setFloatValue:movar[3+5*thisfrm]];
		[ImagPart setFloatValue:movar[3+5*thisfrm+1]];
		[Scale setFloatValue:movar[3+5*thisfrm+2]];	
		[RealC setFloatValue:movar[3+5*thisfrm+3]];
		[ImagC setFloatValue:movar[3+5*thisfrm+4]];
		viewStep = [Scale floatValue] / frame.size.width;
		viewX = [RealPart floatValue]-(double) frame.size.width * viewStep * 0.5;
		viewY = [ImagPart floatValue]+(double) frame.size.height * viewStep * 0.5;
		originX = [RealC floatValue];
		originY = [ImagC floatValue];
		} 
	[self startButton:nil];
	}
	}
if (thisfrm>=frms)
	{
	[myTimer invalidate];
	thisfrm=0;
	}
}



- (IBAction)doSave:(id)sender
  {
  [[NSSavePanel savePanel]
    beginSheetForDirectory:NSHomeDirectory()  // seems like a reasonable place to start..
    file:@"Image" 	// default filename
    modalForWindow:window   //Run as a sheet, attached to "window"
    modalDelegate:self 	// The save panel should call me when it's done..
    didEndSelector:@selector(savePanelDidEnd:returnCode:contextInfo:) // ... using this selector
    contextInfo:NULL];
  }

- (void) savePanelDidEnd:(NSSavePanel *)sheet returnCode:(int)returnCode contextInfo:(void  *)contextInfo
  {
  NSString *ms;

  
  if (returnCode == NSModalResponseOK)
	{   // NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
   
     double values[37] = {
        (double)mandel,
        viewStep*frame.size.width,
        viewX+(double) frame.size.width * viewStep * 0.5,
        viewY-(double) frame.size.height * viewStep * 0.5,
		originX,
        originY,
		(double)thisfn,
		(double)dzet,
		(double)orbtrap+dz*2+mval*4,
		(double)esconly,
		(double)altcol,
		escapeRadius,
		attractorTerms,
		(double)max_dwells,
		creal(kk), cimag(kk),
		(double)oldfn,
		987.654321,
		creal(coeffs[0]), cimag(coeffs[0]),
		creal(coeffs[1]), cimag(coeffs[1]),
		creal(coeffs[2]), cimag(coeffs[2]),
		creal(coeffs[3]), cimag(coeffs[3]),
		creal(coeffs[4]), cimag(coeffs[4]),
		creal(coeffs[5]), cimag(coeffs[5]),
		(double)prms[0], (double)prms[1], (double)prms[2], (double)prms[3], (double)prms[4], (double)prms[5], (double)prms[6]

    };
    int i;
    NSError *error;
    //store them into a file
    NSMutableString *mutstr = [[NSMutableString alloc] init];
    for(i = 0; i < 37; i++)
        [mutstr appendFormat:@"%f ", values[i]];
		
	
     ms = [NSString stringWithFormat: @"Your age is %d", i];

    //write to file
	[mutstr writeToFile:[NSString stringWithFormat:@"%@.%@", [sheet filename],  @"txt"] atomically:YES encoding:NSUnicodeStringEncoding error:&error];
	
 [[[self transformedImage] TIFFRepresentationUsingCompression:(NSTIFFCompression)NSTIFFCompressionLZW factor:(float)5]  // Create the contents of a .tiff file
   // [[[self transformedImage] TIFFRepresentation]  // Create the contents of a .tiff file
	  writeToFile:[NSString stringWithFormat:@"%@.%@", [sheet filename], @"tif"] // save it at the path we get from the panel.
      atomically:YES];  // That's about all there is to it..

	
	//[pool drain];
	}

  }

- (void)doReportButton:(id)sender
{
originX = [RealC floatValue];
originY = [ImagC floatValue];
if (mandel==2)
	cval=1;
if (mandel==1)
	mval=1;
[self startButton:sender];

/*	int x;
	int firstDrawn = 0;
	
	for (x=0; x < height; x++)
	{
		if(drawnTable[x] == 0)
		{
			if (firstDrawn)
				printf("line %d not drawn!\n", x);
		}
		else
		{
			firstDrawn = 1;
		}
	}*/
}

- (void) doResetOriginButton:(id)sender
{
    //originX = 0.0;
    //originY = 0.0;
	viewStep = [Scale floatValue] / frame.size.width;
	viewX = [RealPart floatValue]-(double) frame.size.width * viewStep * 0.5;
	viewY = [ImagPart floatValue]+(double) frame.size.height * viewStep * 0.5;
	//printf("X=%f Y=%f S=%f\n",viewX, viewY, viewStep);
    [self startButton:sender];
}

-(void) checkfn
{
	char *holdstr;
	int j,k;
	double _Complex c,zk;
	double kh,kh2,kh3;

	c=originX+originY*_Complex_I;
	crits[1]=1.0;
	Zrr=0;
	Zii=0;
	Zii2=0;
	Zrr2=0;
	Zii3=0;
	Zrr3=0;
	holdstr="z^k+c [2]";
	if (strcmp(mystr,holdstr)==0)
		{
		thisfn=1;
		crits[1]=1;
			Zrr=1.2E-308;
		if (thisfn!=oldfn)
			kk=2;
		if ((mandel==2)&&(cval==1))
			{
			kk=c;
			cval=0;
			//printf("did it %f %f\n",creal(kk),cimag(kk));
			}
		//printf("%f\n", kk);
		}
	holdstr="cz^m(1-z)^n [1,1]";
	if (strcmp(mystr,holdstr)==0)
		{
		Zrr=creal(kk)/(creal(kk)+cimag(kk));
		crits[1]=1;
		thisfn=2;
		if (thisfn!=oldfn)
			kk=1+I;
		if ((mandel==2)&&(cval==1))
			{
			kk=c;
			cval=0;
			//printf("did it %f %f\n",creal(kk),cimag(kk));
			}
		//Zrr=creal(kk)/(creal(kk)+cimag(kk));
		crits[2]=1.2E-308;
		crits[3]=1;
		}
	holdstr="z^m-nz+c m=1-10 [3]";
	if (strcmp(mystr,holdstr)==0)
	{
		thisfn=3;
		if (thisfn!=oldfn)
			kk=3+I;
		if ((mandel==2)&&(cval==1))
		{
			kk=c;
			cval=0;
			//printf("did it %f %f\n",creal(kk),cimag(kk));
		}
		powr=(int)creal(kk);
        if (powr>100)
            powr=powr-100;
		critsep=cimag(kk);
		if (powr>10) powr=10;
		if (powr<1) powr=1;		
		Zrr=creal(cpow(powr/critsep,-1.0/(powr-1)));
		Zii=cimag(cpow(powr/critsep,-1.0/(powr-1)));
		crits[1]=powr-1;
		for (j=1;j<=powr-2;j++)
			crits[j+1]=(Zrr+I*Zii)*cexp(2*j*pi/(powr-1)*I);
	}
 	holdstr="z^m-10q/z^p+c n=p.q";
	if (strcmp(mystr,holdstr)==0)
	{
		thisfn=18;
		if (thisfn!=oldfn)
			kk=3-1.1*I;
		if ((mandel==2)&&(cval==1))
		{
			kk=c;
			cval=0;
			//printf("did it %f %f\n",creal(kk),cimag(kk));
		}
		kh=cimag(kk);
		kh=fabs(10*(kh-(int)kh));
		if (kh==0)
		{
			Zrr=0;
			Zii=0;
			crits[1]=1;
		}
		else {
			Zrr=creal(cpow(-kh*(int)cimag(kk)/creal(kk),1.0/(creal(kk)+(int)cimag(kk))));
			Zii=cimag(cpow(-kh*(int)cimag(kk)/creal(kk),1.0/(creal(kk)+(int)cimag(kk))));
			crits[1]=fabs(creal(kk)+(int)cimag(kk));
			if ((creal(kk)>1)&&((int)cimag(kk)<-1))
				crits[1]=crits[1]+1;
			for (j=1;j<=fabs(creal(kk)+(int)cimag(kk))-1;j++)
				crits[j+1]=(Zrr+Zii*I)*cexp(2*j*pi/(creal(kk)+(int)cimag(kk))*I);
			crits[(int)fabs(creal(kk)+(int)cimag(kk))+1]=0;
			
		}		
	}
	holdstr="z^m+10q/z^p+c n=p.q";
	if (strcmp(mystr,holdstr)==0)
	{
		thisfn=29;
		if (thisfn!=oldfn)
			kk=3+1.1*I;
		if ((mandel==2)&&(cval==1))
		{
			kk=c;
			cval=0;
			//printf("did it %f %f\n",creal(kk),cimag(kk));
		}
		kh=cimag(kk);
		kh=fabs(10*(kh-(int)kh));
		if (kh==0)
		{
			Zrr=0;
			Zii=0;
			crits[1]=1;
		}
		else {
			Zrr=creal(cpow(kh*(int)cimag(kk)/creal(kk),1.0/(creal(kk)+(int)cimag(kk))));
			Zii=cimag(cpow(kh*(int)cimag(kk)/creal(kk),1.0/(creal(kk)+(int)cimag(kk))));
			crits[1]=fabs(creal(kk)+(int)cimag(kk));
			if ((creal(kk)>1)&&((int)cimag(kk)<-1))
				crits[1]=crits[1]+1;
			for (j=1;j<=fabs(creal(kk)+(int)cimag(kk))-1;j++)
				crits[j+1]=(Zrr+Zii*I)*cexp(2*j*pi/(creal(kk)+(int)cimag(kk))*I);
			crits[(int)fabs(creal(kk)+(int)cimag(kk))+1]=0;
			
		}
		
		
	}
	holdstr="c(z^3+(k-1)z^2-kz)";
	if (strcmp(mystr,holdstr)==0)
	{
		thisfn=20;
		if (thisfn!=oldfn)
			kk=0.5;
		if ((mandel==2)&&(cval==1))
		{
			kk=c;
			cval=0;
			//printf("did it %f %f\n",creal(kk),cimag(kk));
		}
		Zrr=creal((1-kk)/3+csqrt(kk*kk+kk+1)/3);
		Zii=cimag((1-kk)/3+csqrt(kk*kk+kk+1)/3);
		crits[1]=2;;
		crits[2]=(1-kk)/3-csqrt(kk*kk+kk+1)/3;
        if (kk==-1)
        {
            Zrr=creal((1-kk)/3-csqrt(kk*kk+kk+1)/3);
            Zii=cimag((1-kk)/3-csqrt(kk*kk+kk+1)/3);
            crits[1]=2;;
            crits[2]=(1-kk)/3+csqrt(kk*kk+kk+1)/3;
        }
	}
	
	holdstr="(z^m-n)(z+c) m=1-4 [3]";
	if (strcmp(mystr,holdstr)==0)
		{
		thisfn=4;
		if (thisfn!=oldfn)
		{
			kk=3+I;
			//printf("oldfn %f %f\n",creal(kk),cimag(kk));

		}
		if ((mandel==2)&&(cval==1))
			{
			kk=c;
			cval=0;
			//printf("did it %f %f\n",creal(kk),cimag(kk));
			}
		powr=(int)creal(kk);
		if (powr>4) powr=4;
		if (powr<1) powr=1;
		kk=powr+I*cimag(kk);
		crits[1]=powr;
		//printf("did it %f %f\n",creal(kk),cimag(kk));
		}
	holdstr="Int(z^m-n)(z+c) m=1-8 [2]";
	if (strcmp(mystr,holdstr)==0)
	{
		thisfn=5;
		if (thisfn!=oldfn)
			kk=2+I;
		if ((mandel==2)&&(cval==1))
		{
			kk=c;
			cval=0;
		}
		powr=(int)creal(kk);
		if (powr>8) powr=8;
		if (powr<1) powr=1;
		crits[1]=powr+1;	
		for (j=1;j<=powr;j++)
			crits[j+1]=cexp(2*j*pi/powr*I)/cimag(kk);
		//printf("%f %f\n", creal(crits[2]), cimag(crits[2]));
	} 
	holdstr="z^k+(c-1)z-c k=1-10 [3]";
	if (strcmp(mystr,holdstr)==0)
		{
		thisfn=6;
		if (thisfn!=oldfn)
			kk=3;
		if ((mandel==2)&&(cval==1))
			{
			kk=c;
			cval=0;
			//printf("did it %f %f\n",creal(kk),cimag(kk));
			}
		powr=(int)creal(kk);
		if (powr>10) powr=10;
		if (powr<1) powr=1;		
		crits[1]=powr-1;
		}
	holdstr="Newton z^k+(c-1)z-c [3]";
	if (strcmp(mystr,holdstr)==0)
		{
		thisfn=7;
		if (thisfn!=oldfn)
			kk=3;
		if ((mandel==2)&&(cval==1))
			{
			kk=c;
			cval=0;
			//printf("did it %f %f\n",creal(kk),cimag(kk));
			}
		crits[1]=1;
        if (kk==3-1.0*I)
            crits[1]=4;
		//Zrr=0; others superattracting basins.
		//printf("%s\n",mystr);
		} 
	holdstr="cSin(1/z)";
	if (strcmp(mystr,holdstr)==0)
		{
		thisfn=8;
		Zrr=2.0/pi;
		crits[1]=2;
		crits[2]=2.0/pi/3.0;
		}
	holdstr="c(Cos(z^m))^n m,n [1,1]";
	if (strcmp(mystr,holdstr)==0)
		{
		Zrr=1.2E-308;
		thisfn=9;
		if (thisfn!=oldfn)
			kk=1+I;
		if ((mandel==2)&&(cval==1))
			{
			kk=c;
			cval=0;
			//printf("did it %f %f\n",creal(kk),cimag(kk));
			}
		crits[1]=1;
		if ((int)creal(kk)!=creal(kk))
			{
			crits[1]=2;
			//crits[2]=pi*pi;
			crits[2]=cpow(pi,1.0/creal(kk));
            escapeRadius=4;
			}
        if ((creal(kk)<0)&&(cimag(kk)>0))
        {
            crits[1]=1;
            Zrr=100;
        }
        if ((creal(kk)<0)&&(cimag(kk)<0))
        {
            crits[1]=1;
            if (creal(kk)==-1) Zrr=0.318310409784317;
            if (creal(kk)==-2) Zrr=0.564190089702606;
            if (creal(kk)==-3) Zrr=0.682784557342529;
            if (creal(kk)==-4) Zrr=0.751125752925873;//0.240500003099442;
            
        }
            
		}
	holdstr="Cos(z^m)^n+c [1,1]";
    if (strcmp(mystr,holdstr)==0)
	{
		Zrr=1.2E-308;
		thisfn=10;
		if (thisfn!=oldfn)
			kk=1+I;
		if ((mandel==2)&&(cval==1))
		{
			kk=c;
			cval=0;
			//printf("did it %f %f\n",creal(kk),cimag(kk));
		}
        kh=pi;
        if ((int)cimag(kk)%2==0)
            kh=pi/2;
		crits[1]=2;
		crits[2]=cpow(kh,1.0/creal(kk));
        if ((creal(kk)<0)&&(cimag(kk)>0))
        {
            crits[1]=1;
            Zrr=100;
        }
        if ((creal(kk)<0)&&(cimag(kk)<0))
        {
            crits[1]=1;
            if (creal(kk)==-1) Zrr=0.318310409784317;
            if (creal(kk)==-2) Zrr=0.564190089702606;
            if (creal(kk)==-3) Zrr=0.682784557342529;
            if (creal(kk)==-4) Zrr=0.751125752925873;//0.240500003099442;
            
        }
    }
	holdstr="cSin(z)+(c/2)Sin(2z)";
	if (strcmp(mystr,holdstr)==0)
		{
		thisfn=11;
		crits[1]=2;
        Zrr=1.733363032341;//pi/3;
        crits[2]=4.9084677696228;
        crits[3]=7.65967082977295;
		}
	holdstr="c(Cos(z)+Cos(2z))";
	if (strcmp(mystr,holdstr)==0)
		{
		thisfn=12;
		crits[1]=2;
		crits[2]=pi-acos(1.0/4);
		//crits[2]=1.8235;
		//printf("%f %f %f\n", Zrr, Zii, creal(crits[2]));
		}
	holdstr="cSin(z)/z crits k=1-8 [6]";
	if (strcmp(mystr,holdstr)==0)
	{
		thisfn=13;
		if (thisfn!=oldfn)
			kk=6;
		if ((mandel==2)&&(cval==1))
		{
			kk=c;
			cval=0;
			//printf("did it %f %f\n",creal(kk),cimag(kk));
		}
		powr=(int)creal(kk);
		if (powr>8) powr=8;
		if (powr<1) powr=1;	
		crits[1]=powr;		
		crits[2]=4.493; //first 8 = 0, 4.5, 7.6, 10.9, 14.1, 17.2, 20.37, 23.53
		crits[3]=7.725;
		crits[4]=10.905;
		crits[5]=14.065;
		crits[6]=17.22;
		crits[7]=20.37;
		crits[8]=23.53;
	}
    holdstr="c(z^m)e^(z^n) m,n=-5 +9 [1,1]";
	if (strcmp(mystr,holdstr)==0)
	{
		thisfn=14;
		if (thisfn!=oldfn)
			kk=1+I;
		if ((mandel==2)&&(cval==1))
		{
			kk=c;
			cval=0;
			//printf("did it %f %f\n",creal(kk),cimag(kk));
		}
        if ((creal(kk)!=0)&&(cimag(kk)!=0))
        {
		Zrr=creal(cpow(-creal(kk)/cimag(kk),1/cimag(kk)));
		Zii=cimag(cpow(-creal(kk)/cimag(kk),1/cimag(kk)));
        }
        if (creal(kk)==0)
            Zrr=-100;
		//powr=(int)creal(kk);
		//if (powr>9) powr=9;
		//if (powr<1) powr=1;  //avoids k roots for k<0 which give the same parameter plane
		//powr=1;
		crits[1]=1;
		//for (j=1;j<=abs(powr)-1;j++)
		//	crits[j+1]=cpow(-1/kk,1/kk)*cexp(2*j*pi/powr*I);
        //crits[2]=-1000;
	}
	   holdstr="(z^k)e^z+c k=-5 +9 [1]";
    if (strcmp(mystr,holdstr)==0)
    {
        thisfn=15;
        if (thisfn!=oldfn)
            kk=1;
        if ((mandel==2)&&(cval==1))
        {
            kk=c;
            cval=0;
            //printf("did it %f %f\n",creal(kk),cimag(kk));
        }
        if (creal(kk)==1)
        {
            crits[1]=2;
            Zrr=-creal(kk);
            crits[2]=-1000;
        }
        if (creal(kk)<=-1)
        {
            crits[1]=1;
            Zrr=-creal(kk);
            //	crits[2]=-1000;
        }
        if (creal(kk)>=1)
        {
            crits[1]=2;
            Zrr=-creal(kk);
            crits[2]=0;
        }
        if (creal(kk)==0)
        {
            crits[1]=1;
            Zrr=-1000;
            
        }
    }
holdstr="Transcendental";
	if (strcmp(mystr,holdstr)==0)
	{
		if (thisfn!=oldfn) kk=1+I;
		thisfn=16;
        if (thisfn!=oldfn)
            kk=1+I;
        if ((mandel==2)&&(cval==1))
        {
            kk=c;
            cval=0;
            //printf("did it %f %f\n",creal(kk),cimag(kk));
        }				
        /*if (creal(kk)==1)
		{
			if (cimag(kk)==1) 
				{
					crits[1]=2;
					Zrr=-cimag(kk);
					crits[2]=-1000;
				}
			if (cimag(kk)<=-1) 
			{
				crits[1]=1;
				Zrr=-cimag(kk);
			//	crits[2]=-1000;
			}
			if (cimag(kk)>=1) 
			{
				crits[1]=2;
				Zrr=-cimag(kk);
				crits[2]=0;
			}
			if (cimag(kk)==0)
			{
				crits[1]=1;
				Zrr=-1000;

			}
		}*/
		if ((creal(kk)>=2)&&(creal(kk)<=4))
		{
			crits[1]=1;
			Zrr=1/exp(1);
		}
		if ((creal(kk)>=5)&&(creal(kk)<=6))
		{
			crits[1]=1;
			Zrr=0.567143;
		}
		if ((creal(kk)==7)||(creal(kk)==8))
		{
			crits[1]=1;
			Zrr=1.2E-308;
		}
		if (creal(kk)==9)
		{
			crits[1]=1;
			Zrr=1.2E-308;
			if (cimag(kk)==1) { crits[1]=2; crits[2]=1.570796847343445+I*0.6584696769714355; }
			if (cimag(kk)==2) { crits[1]=3; crits[2]=1.017573237419128+I*0.4760687649250031; crits[3]=conj(crits[2]); }
			if (cimag(kk)==3) { crits[1]=4; crits[2]=0.7554630637168884+I*0.3655786216259003; crits[3]=1.570795774459839+I*0.4087064564228058; crits[4]=conj(crits[2]);}
			if (cimag(kk)==4) { crits[1]=5; crits[2]=0.6015334725379944+I*0.2954587340354919; crits[3]=1.248785734176636+I*0.3431628942489624; crits[4]=conj(crits[2]); crits[5]=conj(crits[3]);}
			
		}
		if (creal(kk)==10)
		{
			crits[1]=1;
			Zrr=1.2E-308;
			if (cimag(kk)==1) { crits[1]=2; crits[2]=0.7854043245315552; }
			if (cimag(kk)==2) { crits[1]=3; crits[2]=0.523597240447998; crits[3]=1.047198057174683; }
			if (cimag(kk)==3) { crits[1]=4; crits[2]=0.3926994502544403; crits[3]=0.7853983640670776; crits[4]=1.178097724914551;}
			if (cimag(kk)==4) { crits[1]=5; crits[2]=0.3141591250896454; crits[3]=0.6283202171325684; crits[4]=0.942478358745575; crits[5]=1.256639122962952;}
		}
		if ((creal(kk)>=11)&&(creal(kk)<=13))
		{
			crits[1]=1;
			Zrr=pi;//1.2E-308;
		}
		if ((creal(kk)==14)||(creal(kk)==15))
		{
			crits[1]=1;
			Zrr=0;
		}
        if ((creal(kk)==16)||(creal(kk)==17))
        {
            crits[1]=1;
            Zrr=-100;
        }
        if (creal(kk)==1)
        {
            crits[1]=1;
            Zrr=-1000;
        }
   	}
	holdstr="Rational";
	if (strcmp(mystr,holdstr)==0)
		{
 /*           kh=round(1000*cimag(kk));
            kh2=round(kh/1000);
            printf("%e ",fabs((int)cimag(kk)));
            kh=kh-kh2*1000;
            kh2=floor(kh/100);
            printf("%e ",kh2);
            kh=fabs((kh-kh2*100)/10);
            printf("%e\n",kh);*/
            thisfn=17;
			if (thisfn!=oldfn) kk=2;
			if (creal(kk)==1)
			{
			crits[1]=1;
			Zrr=creal(cpow(-1.0/cimag(kk),1.0/(cimag(kk)+1)));
			Zii=cimag(cpow(-1.0/cimag(kk),1.0/(cimag(kk)+1)));
					  
			//Zrr=-1.0/cpow((cimag(kk)+1)*2,1.0/3);
	
			//if (kk==6) crits[1]=1; else crits[1]=3;
			//for (j=1;j<=2;j++)
			//	crits[j+1]=Zrr*cexp(2*j*pi/3*I);				
			}
			if ((kk==2)||(kk==5))
			{
			crits[1]=7;
			crits[2]= -0.5961;
			crits[3]=0.2980 + 1.8073*I;
			crits[4]=0.2980 - 1.8073*I;
			crits[5]=1.0;
			crits[6]=cexp(2*pi/3*I);
			crits[7]=cexp(4*pi/3*I);			
			}
			if (kk==3)
			{
			crits[1]=7;
			crits[2]= 0.7721*I;
			crits[3]=1.0319 + 0.8757i;
			crits[4]=1.0319 - 0.8757i;
			crits[5]=-0.7721*I;
			crits[6]=-1.0319 + 0.8757i;
			crits[7]=-1.0319 - 0.8757i;			
			}
			if (kk==4)
			{
			Zrr=1.2E-308;
			crits[1]=3;
			crits[2]=1.0;
			crits[3]=-1.0;			
			}
				if (creal(kk)==6)
			{
				if (cimag(kk)<2)
					kk=creal(kk)+2*I;
				powr=(int)cimag(kk);
				critsep=1;
				if (powr>10) powr=10;
				if (powr<1) powr=1;		
				//Zrr=1/pow(powr,1.0/(powr-1))*critsep;
				Zrr=pow(powr/critsep,-1.0/(powr-1));
				crits[1]=powr-1;
				for (j=1;j<=powr-2;j++)
					crits[j+1]=Zrr*cexp(2*j*pi/(powr-1)*I);
			}
            if (creal(kk)==7)
            {
                crits[1]=5;
                Zrr=0.0;
                crits[2]=-0.5+0.5*I;
                crits[3]=-0.1876766830682755 + 0.4908875524997711*I;
                crits[4]=-0.1876766830682755 - 0.4908875524997711*I;
                crits[5]=0.4284706115722656;
            }
            if (creal(kk)==8)
            {
                {
                    crits[1]=6;
                    Zrr=-1.0;
                    crits[2]=1.0;
                    crits[3]=1.4271439;
                    crits[4]=-1.480257;
                    crits[5]=0;
                    crits[6]=0.42847085;
                }
            }
            if (creal(kk)==9)
                     crits[1]=1;
            if (creal(kk)==10)
            {
                {
                    crits[1]=2;
                    crits[2]=3;
                }
            }
            if (creal(kk)==11)
                    crits[1]=1;
            if (creal(kk)==12)
            {
                //Zrr=creal(-cexp(2*pi*I*cimag(kk))/2);
                //Zii=cimag(-cexp(2*pi*I*cimag(kk))/2);
                crits[1]=1;
            }
            if (creal(kk)==13)
            {
                crits[1]=2;
            }
            if ((creal(kk)==14)||(creal(kk)==16)||(creal(kk)==17))
            {
                crits[1]=1;
            }
            if (creal(kk)==15)
            {
                crits[1]=2;
                if (cimag(kk)==0)
                    kk=creal(kk)+I*(sqrt(5)-1)/2;
            }
            if (creal(kk)==18)
            {
                crits[1]=1;
                Zrr=2.0/3;
            }
            if (creal(kk)==19)
            {
                crits[1]=1;
            }
            if (creal(kk)==20)
            {
                crits[1]=4;
            }
            if (creal(kk)==21)
            {
                crits[1]=1;
            }
            if (creal(kk)==22)
            {
                crits[1]=1;
                Zrr=2.0/3;
            }
            if (creal(kk)==23)
            {
                if (cimag(kk)==0)
                    kk=23+2*I;
                crits[1]=1;
                Zrr=1.0;
                //Zrr=2.0*cimag(kk);
            }
            if (creal(kk)==24)
            {
                if (cimag(kk)==(int)cimag(kk))
                    kk=kk+0.1*I;
                crits[1]=2;
                crits[2]=1.0;
            }
            if (creal(kk)==25)
            {
                Zrr=1.0;
                crits[1]=3;
                crits[2]=sqrt(fabs(10*(cimag(kk)-(int)cimag(kk)))/3);
                crits[3]=-sqrt(fabs(10*(cimag(kk)-(int)cimag(kk)))/3);
            }
            if (creal(kk)==26)
            {
                crits[1]=2;
                crits[2]=1.0;
            }
            if (creal(kk)==27)
            {
          //      Zrr=1.0;
                if (cimag(kk)==(int)cimag(kk))
                    kk=kk+0.1*I;
                crits[1]=2;
                crits[2]=1.0;
            }
            if (creal(kk)==28)
            {
                kh=round(1000*cimag(kk));
                if (kh>0)
                    kh2=floor(kh/1000);
                else
                    kh2=ceil(kh/1000);
                kh=kh-kh2*1000;
                if (kh>0)
                    kh3=floor(kh/100);
                else
                    kh3=ceil(kh/100);
                kh=fabs((kh-kh3*100)/10);
                kh=pow(10,kh);
        //        Zrr=1.0;
     //           if (kh3>0)
                    Zrr=cpow(kh/kh3,1/(kh3-1));
     //           else
     //               Zrr=1.0;
     //           printf("%e %e %e\n",kh,kh3,Zrr);
                if (cimag(kk)==(int)cimag(kk))
                    kk=kk+0.1*I;
                crits[1]=2;
                crits[2]=1.0;
            }
            if ((mandel==2)&&(cval==1))
			{
				kk=c;
				cval=0;
				//printf("did it %f %f\n",creal(kk),cimag(kk));
			}				
			if ((creal(kk)==6)&&(cimag(kk)<2))
				kk=creal(kk)+2*I;
		}
	/*holdstr="czlog(z)";
	if (strcmp(mystr,holdstr)==0)
		{
		thisfn=18;
		crits[1]=1;
		Zrr=1/exp(1);
		}*/
	holdstr="cz^(z+k) [2]";
	if (strcmp(mystr,holdstr)==0)
		{
		thisfn=19;
		if (thisfn!=oldfn)
			kk=2;
		if ((mandel==2)&&(cval==1))
			{
			kk=c;
			cval=0;
			//printf("did it %f %f\n",creal(kk),cimag(kk));
			}
			kh=creal(kk);
/*		zk=1.0/2*cexp(pi*I*creal(kk));
		if (kh>=1.0)
			zk=-1.0/2;
		if( (kh<-0.5)||(fabs(cimag(kk)>0.9)))
			zk=1.0/2;*/
		kh=cabs(kk);
		zk=-kk/kh/10;
		if (kh<=0.316)
			zk=-kk;
	//	printf("%f %f\n", kh, zk);
		if (kk==0)
			zk=1.0/2;
		for (j=1;j<=20;j++)
			zk=zk*(clog(zk)+2*kk/zk)/(kk/zk-1);// Newton on the non-zero root of f'=z^(z+k)(1+k/z+clog(z)) i.e. g=1+k/z+clog(z)
		
		Zrr=creal(zk);
		Zii=cimag(zk);		
		crits[1]=1;
		}
	holdstr="z^z+c";
    if (strcmp(mystr,holdstr)==0)
	{
		thisfn=20;
		crits[1]=1;
		Zrr=1/exp(1);
	}
	holdstr="e^(-z^k)+c k=2-4 [2]";
	if (strcmp(mystr,holdstr)==0)
		{
		thisfn=21;
		if (thisfn!=oldfn)
			kk=2;
		if ((mandel==2)&&(cval==1))
			{
			kk=creal(c);//((int)creal(c));
			cval=0;
			//printf("did it %f %f\n",creal(kk),cimag(kk));
			if ((kk!=4)&&(kk!=3)&&(kk!=-2)&&(kk!=-3)&&(kk!=-4))
				kk=2;
			}
		crits[1]=1;
        }
	holdstr="Quintic";
    if (strcmp(mystr,holdstr)==0)
		{
		thisfn=22;
		for (j=0;j<=4;j++)
			if (coeffs[j]!=0) break;
		crits[1]=4-j;
		}
	holdstr="Herman cz^2(z-k)/(kz-1) [4]";
	if (strcmp(mystr,holdstr)==0)
		{
		thisfn=23;
		if ((thisfn!=oldfn)&&((oldfn!=24)||mandel!=1))
			kk=4;
		if ((mandel==2)&&(cval==1))
			{
			kk=c;
			cval=0;
			//printf("did it %f %f\n",creal(kk),cimag(kk));
			}
		zk=3+kk*kk;
		Zrr=creal((zk+csqrt(zk*zk-16*kk*kk))/4/kk);
		Zii=cimag((zk+csqrt(zk*zk-16*kk*kk))/4/kk);		
		crits[1]=2;
		crits[2]=(zk-csqrt(zk*zk-16*kk*kk))/4/kk;
		} 
	holdstr="Herman kz^2(z-c)/(cz-1) [gm]";
	if (strcmp(mystr,holdstr)==0)
		{
		thisfn=24;
		if (thisfn!=oldfn)
			kk=cexp(I*pi*(sqrt(5)-1)/2);
		if ((mandel==2)&&(cval==1))
			{
			kk=c;
			cval=0;
			//printf("did it %f %f\n",creal(kk),cimag(kk));
			}
		crits[1]=2;
		} 
	holdstr="Collatz";
	if (strcmp(mystr,holdstr)==0)
		{
		thisfn=25;
		if (thisfn!=oldfn)
			kk=1;
		if ((mandel==2)&&(cval==1))
			{
			kk=c;
			cval=0;
			//printf("did it %f %f\n",creal(kk),cimag(kk));
			}
		Zrr=1.130405783653259;
		} 
	holdstr="z^m+cz^-n k=m+in [2,2]";
    if (strcmp(mystr,holdstr)==0)
		{
		thisfn=26;
		if (thisfn!=oldfn)
			kk=2+2*I;
		if ((mandel==2)&&(cval==1))
		{
			kk=c;
			cval=0;
			//printf("did it %f %f\n",creal(kk),cimag(kk));
		}
		//powr=(int)(creal(kk)+cimag(kk));
		crits[1]=1;
		}
	holdstr="cCos(z^m+z^-n)";
	if (strcmp(mystr,holdstr)==0)
	{
		thisfn=27;
		if (thisfn!=oldfn)
			kk=2+2*I;
		if ((mandel==2)&&(cval==1))
		{
			kk=c;
			cval=0;
			//printf("did it %f %f\n",creal(kk),cimag(kk));
		}
		crits[1]=2;
		//Zrr=1.66798;
		for (k=1;k<=1;k++)
		{
			if (creal(kk)<0)
				Zrr=0.9;
			else
				Zrr=0.9*k*pi;
			for (j=1;j<=20;j++)
				Zrr=Zrr-(cpow(Zrr,creal(kk))+cpow(Zrr,-cimag(kk))-pi)/(creal(kk)*cpow(Zrr,creal(kk)-1)-cimag(kk)*cpow(Zrr,-cimag(kk)-1));
			//printf("%f %f %f ",creal(kk),cimag(kk),Zrr);
				crits[k+1]=Zrr;
		}
		Zrr=cpow(cimag(kk)/creal(kk),1.0/(cimag(kk)+creal(kk))); 
		//printf("%f %d\n",creal(crits[k]),k);

	}
	holdstr="Milnor";
	if (strcmp(mystr,holdstr)==0)
	{
		thisfn=28;
		/*if (thisfn!=oldfn)
			kk=0;
		if ((mandel==2)&&(cval==1))
		{
			kk=c;
			cval=0;
		}*/
        Zrr=1.0;
        crits[1]=2;
        crits[2]=-1.0;;
	}
    holdstr="z^3+cz^2+mexp(2pini)z";
    if (strcmp(mystr,holdstr)==0)
    {
        thisfn=30;
        if (thisfn!=oldfn)
            kk=1.0+(sqrt(5.0)-1)/2.0*I;
        if ((mandel==2)&&(cval==1))
        {
            kk=c;
            cval=0;
            //printf("did it %f %f\n",creal(kk),cimag(kk));
        }
        crits[1]=2;
    }
    holdstr="Mating";
    if (strcmp(mystr,holdstr)==0)
    {
        thisfn=31;
        crits[1]=1;
    }
	if (mandel==1)
		{
		if ((mval==0)||(thisfn!=oldfn))
			{
			originX=Zrr;
			originY=Zii;
			}
		}
		//printf("%f\n", kk);
		//printf("%d\n", thisfn);

}

- (void) resetButton:(id)sender
{
    [workLock lock];
	mystr=[[myFunction titleOfSelectedItem] UTF8String];
	[self checkfn];
	//if ((thisfn<=8)||(thisfn==17)||(thisfn==21))
			//{
	if ((fill==0)||(thisfn!=oldfn))
	{
	viewX = -2.5;
	viewStep=5.0/frame.size.width;
	if (thisfn==23)
		viewX=-3.0;
	if (thisfn==6)
			{
			viewX = -11.0;
			viewStep=16.0/frame.size.width;
			}
	if((thisfn==3)||(thisfn==26))
			{
			viewX = -2.0;
			viewStep=4.0/frame.size.width;
			}
	if ((thisfn==12)||(thisfn==30))
	{
		viewX = -5.0;
		viewStep=10.0/frame.size.width;
	}
	if ((thisfn==23)||(thisfn==24))
			{
			viewX = -6.0;
			viewStep=12.0/frame.size.width;
			}
	if ((thisfn==2)||(thisfn==7))
	{
		viewX = -4.0;
		viewStep=8.0/frame.size.width;
	}
	if (thisfn==2)
		viewX = -3.5;	
	if (thisfn==23)
		viewX=-4.0;
	if ((thisfn==9)||(thisfn==11)||(thisfn==10)||(thisfn==20))
			{
			viewX = -8.0;
			viewStep=16.0/frame.size.width;
			}
	if ((thisfn==19)||(thisfn==16))
			{
			viewX = -20.0;
			viewStep=40.0/frame.size.width;
			}
	if ((thisfn==13)||(thisfn==14)||(thisfn==15))
			{
			viewX = -40.0;
			viewStep=80.0/frame.size.width;
			}
	if (thisfn==8)
			{
			viewX = -0.5;
			viewStep=1.0/frame.size.width;
			}
	
	viewXf=viewX;
	viewStepf=viewStep;
 // viewX = -40.0; viewStep = 80.0 / frame.size.width;
    viewY = (double) frame.size.height * viewStep * 0.5;
	viewXj = viewX; 
	viewStepj = viewStep;
	viewYj = viewY; 	
	[RealPart setFloatValue:viewX+(double) frame.size.width * viewStep * 0.5];
	[ImagPart setFloatValue:viewY-(double) frame.size.height * viewStep * 0.5];
	[Scale setFloatValue:viewStep*frame.size.width];
	mval=0;
	originX = 0.0;
    originY = 0.0;
	}
	mandel=2;
	altcol = atoi([[Coloring titleOfSelectedItem] UTF8String]);
	if (altcol==1)
	{
		esconly=0;
		[escapeOnly setIntValue:esconly];
		attractorTerms=-2;
		[attractorSlider setFloatValue:attractorTerms];
	}
	else if (thisfn!=oldfn)
	{
		esconly=1;
		[escapeOnly setIntValue:esconly];
		attractorTerms=-4;
		[attractorSlider setFloatValue:attractorTerms];
		orbtrap=0;
		[originSwitch setIntValue:orbtrap];
	}
	if (thisfn==7)
	{
		esconly=0;
		[escapeOnly setIntValue:esconly];
	}
	else if ((altcol!=1)&&(thisfn!=oldfn))
		{
		esconly=1;
		[escapeOnly setIntValue:esconly];
		}
		

	
	
	
    [workLock unlock];
	
    [self startButton:sender];
}

- (void) startButton:(id)sender
{
 	if (mandelrepeat>0)
		mandelrepeat=mandelrepeat-1;
	//mandelrepeat=0;
	int x;//, randIndex, tmp;
	NSNumber * currentSequence;
	char *holdstr;
    
    // printf ("\n\n\n");
    
    [workLock lock];
    comp_sequence++;
    lastLine = 0;
    total_dwells = 0;
    acc_dwells = 0;
    escapeRadius = [escapeRadiusSlider floatValue];
   // zetaTerms = [zetaSlider floatValue];
	attractorTerms = [attractorSlider floatValue];
    currentSequence = [[NSNumber alloc] initWithInt:comp_sequence];
	mystr=[[myFunction titleOfSelectedItem] UTF8String];
	[self checkfn];
	if (thisfn!=oldfn)
		{
		oldfn=thisfn;
		dzet=0;
		if ((thisfn==9)||(thisfn==11)||(thisfn==12)||(thisfn==15)||(thisfn==13)||(thisfn==10)||(thisfn==8)||(thisfn==25))
			dzet=2;
		if ((thisfn==15)||(thisfn==14)||(thisfn==19)||(thisfn==21)||(thisfn==16))
			dzet=1;
		[ThdZeta selectItemAtIndex:dzet];
		if (thisfn==7)
			[escapeRadiusSlider setFloatValue:4];
		else
			[escapeRadiusSlider setFloatValue:1.7];		
	   /* if ((thisfn==7)&&(altcol!=1))
			{
			oldesc=esconly+1;
			[escapeOnly setIntValue:0];
			}
		else
			{
			[escapeOnly setIntValue:oldesc-1];
			oldesc=0;
			}*/		
		}
	if ((thisfn==16)&&(creal(kk)>=11)&&(creal(kk)<=14))
	{
		dzet=0;
		[ThdZeta selectItemAtIndex:dzet];
	}
	mystr=[[ThdZeta titleOfSelectedItem] UTF8String];
	holdstr="a";
	if (strcmp(mystr,holdstr)==0)
		dzet=0;
	holdstr="r";
	if (strcmp(mystr,holdstr)==0)
		dzet=1;
	holdstr="i";
	if (strcmp(mystr,holdstr)==0)
		dzet=2;
    holdstr="r+";
    if (strcmp(mystr,holdstr)==0)
        dzet=3;
    holdstr="i+";
    if (strcmp(mystr,holdstr)==0)
        dzet=4;
   // altnGamma = atoi([[altGamma titleOfSelectedItem] UTF8String]);
	altcol = atoi([[Coloring titleOfSelectedItem] UTF8String]);
	//dzet = atoi([[ThdZeta titleOfSelectedItem] UTF8String]);
	if ([escapeOnly state] == NSOnState)
		esconly=YES;
	else
		esconly=NO;

	if ( [originSwitch state] == NSOnState )
		orbtrap=YES;
	else
		orbtrap=NO;
		if ([Hold state] == NSOnState)
		chold=YES;
	else
		chold=NO;
	if ([dFn state] == NSOnState)
		dz=YES;
	else
		dz=NO;
	[workLock unlock];

	if ([randomizerSwitch state] == NSOnState) fill=1;
	else fill=0;
	//fill=1;
	if (movfl==FALSE)
	{	
	if (mandel==2)
		{
		originX=creal(kk);
		originY=cimag(kk);
		}
	if (chold==NO)
		{
		[RealC setFloatValue:originX];
		[ImagC setFloatValue:originY];
		}
	[RealPart setFloatValue:viewX+(double) frame.size.width * viewStep * 0.5];
	[ImagPart setFloatValue:viewY-(double) frame.size.height * viewStep * 0.5];
	[Scale setFloatValue:viewStep*frame.size.width];
	}
	movfl=FALSE;
  	//if ([clearSwitch state] == NSOnState)
	// {
		for (x=0; x < (frame.size.width * frame.size.height * 3); x++)
	 {
	 bitmapData[x] = 255;
	 }
	// }
    stbut=1;
	  
    [self displayRect:frame];
    
    for (x = 0; x < height; x++) drawnTable[x] = 0;
    for (x = 0; x < height; x++) lineTable[x] = x;
	
	/*if ([randomizerSwitch state] == NSOnState) {
	for (x = 0; x < height; x++)
	{
	    randIndex = rand() % height;
	    tmp = lineTable[x];
	    lineTable[x] = lineTable[randIndex];
	    lineTable[randIndex] = tmp;
	}
    }*/

	thrds=0;
    for (x = 0; x < num_threads; x++)
        [NSThread detachNewThreadSelector:@selector(threadMain:) toTarget:self withObject:[currentSequence retain]];
    [currentSequence release];
	//[self doSave:sender];
 //   [self setNeedsDisplay:YES];
}

- (void)drawRect:(NSRect)rect
{
    // NSGraphicsContext *currentContext = [NSGraphicsContext currentContext];
    NSRect currentFrame;
    int needsStartButton = 0;
    // NSAffineTransform * myTransform;
    int x;
    
	//printf("Draw stbut=%d\n",stbut);
    currentFrame = [self bounds];
    [workLock lock];
	
    
 
    if ((myImage != nil) && ! (
	( currentFrame.size.width == frame.size.width ) &&
	( currentFrame.size.height == frame.size.height )
    )) // resized!
    {
	comp_sequence++; // invalidate any current work
	[myImage release];
	myImage = nil;
	viewX -= viewStep * ( currentFrame.size.width - frame.size.width ) / 2.0 ;
	viewY += viewStep * ( currentFrame.size.height - frame.size.height ) / 2.0 ;
	height = currentFrame.size.height ;
	needsStartButton = 1;
	stbut=1;
    }

	if (myImage != nil)
	{
		//printf("Release\n");
		[myImage release];
		myImage = nil;
	}

    if (myImage == nil)
		{	
		
		// printf("Init\n");
		frame = currentFrame;
        window = [self window];
		
        myImage = [NSBitmapImageRep alloc];
        [myImage
		 initWithBitmapDataPlanes:NULL
		 pixelsWide:frame.size.width pixelsHigh:frame.size.height
		 bitsPerSample:8 samplesPerPixel:3 hasAlpha:NO isPlanar:NO
		 colorSpaceName:NSCalibratedRGBColorSpace
		 bytesPerRow:(frame.size.width*3) bitsPerPixel:0
		 ];
		macbitmapData = [myImage bitmapData];
		if (stbut==1)
			{
			macbitmapData = [myImage bitmapData];
			stbut=0;
			for (x=0; x < (frame.size.width * frame.size.height * 3); x++)
				{
					macbitmapData[x] = 255;
				}			
			}
		else
			for (x=0; x < (frame.size.width * frame.size.height * 3); x++)
			{
				macbitmapData[x] = bitmapData[x];
			}
		}
    if (rect.size.height < height) // only pay attention to partial drawing
		{
			for(x=0; x < (int)rect.size.height; x++) drawnTable[(int)rect.origin.y + x] = 1;
		}
    //setNeedsDisplay(currentFrame);
	[myImage drawInRect:currentFrame];
    //display();
    if (isDragging)
    {
		[[[NSColor selectedTextBackgroundColor] colorWithAlphaComponent:0.35] set];
		NSRectFillUsingOperation (mouseDragRect, NSCompositingOperationSourceOver);
		[[NSColor selectedTextBackgroundColor] set];
		NSFrameRect (mouseDragRect);
    }
    [workLock unlock];
    
    // [currentContext restoreGraphicsState];
    if (needsStartButton)
		[self startButton:nil];
}

- (BOOL) acceptsFirstMouse:(NSEvent *)theEvent { return NO; }
- (BOOL) acceptsFirstResponder { return YES; }
- (BOOL) isOpaque { return YES; }
- (BOOL) isFlipped { return NO; }


- (void)mouseDown:(NSEvent *)theEvent
{
	mouseDownPoint = [self convertPoint:[theEvent locationInWindow] fromView:nil];
	isSelecting = YES; isDragging = NO;
}

- (void)mouseUp:(NSEvent *)theEvent
{
	double newX, newY;
	int i;

	if (isDragging && mouseDragRect.size.width < kCollapseDrag )
	{
		isSelecting = NO; isDragging = NO;
		return;
	}

	if (isDragging)
	{
		newX = viewX + ( viewStep * mouseDragRect.origin.x );
		newY = viewY - ( viewStep * (frame.size.height - (mouseDragRect.origin.y + mouseDragRect.size.height)));
	}
	else
	{
		newX = viewX + ( viewStep * mouseDownPoint.x );
		newY = viewY - ( viewStep * (frame.size.height - mouseDownPoint.y ));
	}
	
	[workLock lock];
	{
		if (isDragging)
		{
			viewX = newX;
			viewY = newY;
			
			viewStep = viewStep * (mouseDragRect.size.width / frame.size.width);
			[RealPart setFloatValue:viewX+(double) frame.size.width * viewStep * 0.5];
			[ImagPart setFloatValue:viewY-(double) frame.size.height * viewStep * 0.5];
			[Scale setFloatValue:viewStep*frame.size.width];
		}
		else //we just clicked so we are switching mode fn>mandel>julia
		{
			//viewX = newX - ( viewStep * frame.size.width * 0.25 );
			//viewY = newY + ( viewStep * frame.size.height * 0.25 );
			originX=newX; originY=newY;
			//viewX = -2.5; viewStep = 4.0 / frame.size.width;
			//viewY = (double) frame.size.height * viewStep * 0.5;
			if ([randomizerSwitch state] == NSOnState) fill=1;
			else fill=0;
			if (mandel == 2) 
			{
				mandel=1;
				//originX=Zrr; originY=0;
				if (fill==0)
					{
					viewX = viewXf; 
					viewStep = viewStepf;
					viewY = (double) frame.size.height * viewStep * 0.5; 
					}
			}
			else if (mandel == 1) {
				if (thisfn==24)
					{
					mystr=[[myFunction titleOfSelectedItem] UTF8String];
					if (strcmp(mystr,"Herman cz^2(z-k)/(kz-1) [4]")==0)
						{
						cval=0;
						kk=originX+I*originY;
						//printf("%f %f\n",creal(kk),cimag(kk));
						}
					else
						{
						mandel=0;
						if (fill==0)
							{
							viewXj = viewX; 
							viewStepj = viewStep;
							viewYj = viewY; 
							viewX = viewXf; 
							viewStep = viewStepf;
							viewY = (double) frame.size.height * viewStep * 0.5; }
							for(i=1;i<2048*1536*3;i++)
								bitmapDatasav[i]=bitmapData[i];
							}
						}
				else
				{
				mandel=0;
				//if (fill==0)
					//{
					viewXj = viewX; 
					viewStepj = viewStep;
					viewYj = viewY; 
					viewX = viewXf; 
					viewStep = viewStepf;
					viewY = (double) frame.size.height * viewStep * 0.5; }
					for(i=1;i<2048*1536*3;i++)
						bitmapDatasav[i]=bitmapData[i];
					//}
				}
			else if (mandel== 0) //we are going from julia back to mandelbrot
				{
                if ((thisfn==17)&&(creal(kk)==20)&&(cimag(kk)<3)&&(dz==0))
                    kk=creal(kk)+I*(cimag(kk)+1);
                else
                {
                if ((thisfn==17)&&(creal(kk)==20)&&(cimag(kk)==3)&&(dz==0))
                    kk=creal(kk);
				originX=0.0; originY=0.0;
				mandel=1;
				if (fill==0)
					{
					viewX = viewXf; 
					viewStep = viewStepf;
					viewY = (double) frame.size.height * viewStep * 0.5;
					}
				else //switch back to previous mandelbrot view
				{
					viewX = viewXj; 
					viewStep = viewStepj;
					viewY = viewYj;
					mandelrepeat=2;
                }
                }
            }
				//viewStep = viewStep * 0.5 ;
		}
	}
	[workLock unlock];

	[self startButton:nil];
	if ((!isDragging)&&(mandel==1))
		{ 
		originX=Zrr; 
		originY=Zii; 
		if (chold==NO)
			{
			[RealC setFloatValue:originX];
			[ImagC setFloatValue:originY];
			}
	/*	else {
			if (cval==1) 		
			{ 
				kk=originX+originY*_Complex_I;;
				cval=0;
			}

		}*/

		}
	isSelecting = NO; isDragging = NO;
	//[RealC setFloatValue:originX];
	//[ImagC setFloatValue:originY];
	[RealPart setFloatValue:viewX+(double) frame.size.width * viewStep * 0.5];
	[ImagPart setFloatValue:viewY-(double) frame.size.height * viewStep * 0.5];
	[Scale setFloatValue:viewStep*frame.size.width];	

}

- (void)mouseDragged:(NSEvent *)theEvent
{
	if (isDragging)
		[self setNeedsDisplayInRect:mouseDragRect];
	isDragging = YES;
	mouseDragPoint = [self convertPoint:[theEvent locationInWindow] fromView:nil];
	mouseDragRect = [MTRectTools makeRectFromPoint:mouseDownPoint toPoint:mouseDragPoint];
	mouseDragRect = [MTRectTools constrainRect:mouseDragRect toAspect:frame.size collapseAt:kCollapseDrag];
	mouseDragRect = [MTRectTools scaleRect:mouseDragRect toFit:frame];
	mouseDragRect = [MTRectTools normalizeRect:mouseDragRect];
	[self setNeedsDisplayInRect:mouseDragRect];
}

/*- (void)keyDown:(NSEvent *)theEvent
{
    NSBezierPath * myPath;
    NSGraphicsContext *currentContext ;
        
    printf ("keydown\n");
    [self lockFocus];
    currentContext = [NSGraphicsContext currentContext];

    myPath = [NSBezierPath bezierPath];
    [myPath setLineWidth:20];
    [myPath moveToPoint:NSMakePoint(-100.0,-100.0)];
    [myPath lineToPoint:NSMakePoint(200.0,300.0)];
    [myPath stroke];
    [currentContext flushGraphics];
    [self unlockFocus];
    // printf ("keyDown\n");
}*/

/*- (void)keyUp:(NSEvent *)theEvent
{
     printf ("keyUp\n");
}*/

- (void) doThreadMenu:(id)sender
{
    num_threads = atoi([[sender titleOfSelectedItem] UTF8String]);
    // printf ("threads: %d\n", num_threads );
}

- (void) doDwellMenu:(id)sender
{
    max_dwells = atoi([[sender titleOfSelectedItem] UTF8String]);
   // printf ("max dwells: %d\n", max_dwells);
}

- (void)threadMain:(NSNumber *)currentSequence
{
    int w, h;
    double buf[16384]; // BUG!
    int update_dwells;
    double x, y, step, currentY;
    int idx, bitmapIdx;
    int working_sequence;
    int myLine;
    NSRect updateRect;
	double colfac=0.4;
	double colfac2=0.14;
	int idx3;
	//int altcol = 0;
	//const pi=3.1415926535;
	double hold,hold2;
	
	int COLOUR_SPACING = 30;
    int maxValueForColour = 220;
	double iterationsPerSegmentDouble=0;
	int iterationsPerSegment=0;
	int iterationsPerPeriod=0;
	BOOL exceeded = NO;
	int i,iterations;
	int segmentSequenceNo;
	
    x = viewX; y = viewY;
    w = frame.size.width;
    h = frame.size.height;
    
    updateRect.origin.x = 0;
    updateRect.size.width = w;
    updateRect.size.height = 1;
    
    step = viewStep;
    // printf ("viewX: %f  viewY: %f  viewStep: %f\n", x, y, step );

    working_sequence = [currentSequence intValue];
    [currentSequence release];
    
    while (1)
    {
  [workLock lock];
	
		
	if (working_sequence != comp_sequence)
	{
		[workLock unlock];
		return;
	}
	myLine = lastLine++;
	[workLock unlock];
	if (myLine >= h)
		{
		//printf("pic finished");
	    break;
		}

	currentY = y - (step * lineTable[myLine]);
	//crits[1]=1.0;
	//printf("%f\n", kk);
	//printf("* %f\n", crits[1]);
	if (mandelrepeat==0)
	{
	update_dwells = mandelLine (kk, crits, coeffs, prms, dzet, thisfn, esconly, (int)altcol, (int)orbtrap, attractorTerms, mandel, originX, originY, escapeRadius, x, currentY, dz, step, max_dwells, w, buf );
	[workLock lock];
	if (working_sequence != comp_sequence)
	{
	    [workLock unlock];
	    return;
	}
	total_dwells += update_dwells; acc_dwells += update_dwells;
		
        for (idx = 0, bitmapIdx = lineTable[myLine] * w * 3; idx < w; idx++, bitmapIdx += 3 )
        {
 			idx3=idx*3;
			if (mandel == 2) //first the algorithm deals with the function portraits for each color (altcol)
				{
				if ((altcol==2)||(altcol==1)||(altcol==5))
				{
				if (buf[idx3] == -1)
					bitmapData[bitmapIdx    ] = 0;
				else
					bitmapData[bitmapIdx    ] = (int)255*(1+cos(buf[idx3]))/2;
					bitmapData[bitmapIdx + 1] = (int)255*(1-sin(buf[idx3+2]))/2;
					bitmapData[bitmapIdx + 2] = (int)255*(1+cos(buf[idx3+1]))/2;
				}
				if  ((altcol==3)||(altcol>=6))
				{
				//if (buf[idx3] == -1)
				//		bitmapData[bitmapIdx] = 0;
				//else
					bitmapData[bitmapIdx    ] = (int)255*(1-cos(pi*buf[idx3]))/2;
					bitmapData[bitmapIdx + 1] = (int)255*(1-cos(buf[idx3+2]))/2;
					bitmapData[bitmapIdx + 2] = (int)255*(1-cos(pi*buf[idx3+1]))/2;
				}
				if  ((altcol==0)||(altcol==4))
				{
				//if (buf[idx3] == -1)
				//		bitmapData[bitmapIdx] = 0;
				//else
					//hold=log(1+log(1+buf[idx3+1]));
					hold=log(1+buf[idx3+1]);
					bitmapData[bitmapIdx    ] = (int)255*hold/(1+hold);//(1-cos(pi*log(buf[idx3+1])))/2;
					bitmapData[bitmapIdx + 1] = (int)255*(1-sin(buf[idx3+2]))/2;
					//bitmapData[bitmapIdx + 2] = (int)255*(1-(1-hold)*cos(pi*buf[idx3+1]))/(2-hold);
					bitmapData[bitmapIdx + 2] = (int)255*(1-cos(pi*buf[idx3+1]))/2;
				}
				}
		else //the algorithm deals with Mandelbrot and Julia portraits together by color (altcol)
		{
			   
			/*if (altcol==1)
				{
				if (mandel==0)
				{
				if (buf[idx3] == -1)
					bitmapData[bitmapIdx    ] = 0;
				else
				   {
				   hold=pow(buf[idx3],2)/1000;
				   bitmapData[bitmapIdx    ] = (int)255*(hold/(1+hold));
				 // bitmapData[bitmapIdx    ] = (int)(1+254*(1+cos(colfac2*buf[idx3]))/2);
				  }
				if (buf[idx3+1] == -1)
					bitmapData[bitmapIdx + 1] = 0;
				else
				{
					hold=pow(buf[idx3+1],2)/1000;
				   bitmapData[bitmapIdx + 1  ] = (int)255*(hold/(1+hold));						
				  // bitmapData[bitmapIdx + 1] = (int)(1+254*(1+cos(colfac2*buf[idx3+1]))/2);
				   }
				if (buf[idx3+2] == -1)
					bitmapData[bitmapIdx + 2] = 0;
				else if (buf[idx3+2] < -1)
					bitmapData[bitmapIdx + 2    ] = (int)255*(-buf[idx3+2]-1);
				else if (buf[idx3+2] >= 0)
				{
				  // hold=pow(buf[idx3+2],5)/100;
				  // bitmapData[bitmapIdx + 2    ] = (int)255*(hold/(1+hold));
						   bitmapData[bitmapIdx + 2] = (int)(1+254*(1-cos(colfac2*5.7*buf[idx3+2]))/2);
						   }
				}*/
                    //if((mandel==1)||(mandel==0))
                                                      
            if (altcol==1)
            {
                {
					if (buf[idx3] == -1) //bounded no periods
						if ((!esconly)&&(orbtrap)) 
						{
							if (thisfn==23)
								
							{
								bitmapData[bitmapIdx    ] = (int)(255*((cos(pow(10,escapeRadius-0.2)*colfac*buf[idx3+2])+1)/2));
								bitmapData[bitmapIdx + 1] = (int)(255*((cos(pow(10,escapeRadius-0.2)*colfac*buf[idx3+2])+1)/2));
								bitmapData[bitmapIdx + 2] = (int)(255*((cos(pow(10,escapeRadius-0.2)*colfac*buf[idx3+2])+1)/2));
							}
							else
							{
								bitmapData[bitmapIdx    ] = (int)(255*((cos(pow(10,escapeRadius-0.6)*colfac*buf[idx3+2])+1)/2));
								bitmapData[bitmapIdx + 1] = (int)(255*((cos(pow(10,escapeRadius-0.6)*colfac*buf[idx3+2])+1)/2));
								bitmapData[bitmapIdx + 2] = (int)(255*((cos(pow(10,escapeRadius-0.6)*colfac*buf[idx3+2])+1)/2));
							}
						}
					else
					{
						bitmapData[bitmapIdx    ] = 0;
						bitmapData[bitmapIdx + 1] = 0;
						bitmapData[bitmapIdx + 2] = 0;
					}
					if ((buf[idx3] >= 0)||((thisfn==7)&&(buf[idx3] < -1)&&(buf[idx3+1]==1))) //escaping
					{
						//if (dz)
						{
                       // if (thisfn!=7)
                            buf[idx3]=sqrt(fabs(buf[idx3]));
						bitmapData[bitmapIdx    ] = (int)(255*((cos(colfac*buf[idx3])+1)/2));
                        bitmapData[bitmapIdx + 1] = (int)(255*((cos(colfac*buf[idx3])+1)/2));
						bitmapData[bitmapIdx + 2] = (int)(255*((cos(colfac*buf[idx3])+1)/2));
                        }
		/*				else
						{
							bitmapData[bitmapIdx    ] = (int)(255*((sin(colfac*buf[idx3])+1)/2));
							bitmapData[bitmapIdx + 1] = (int)(255*((sin(colfac*buf[idx3])+1)/2));
							bitmapData[bitmapIdx + 2] = (int)(255*((sin(colfac*buf[idx3])+1)/2));
						}*/
					}
					if ((buf[idx3] < -1)&&((thisfn!=7)||(buf[idx3+1]!=1))) //periods
					{
						if (mandel==1)
							hold=((creal(crits[1])*max_dwells+buf[idx3]+2)/creal(crits[1])/max_dwells);//((sin(colfac*buf[idx3])+1)/2);
						else
						{
							if(orbtrap)
							{
							hold=((max_dwells+buf[idx3]+2)/max_dwells);//((sin(colfac*buf[idx3])+1)/2);
							hold=pow((1-cos(pi*hold))/2,4);//pow(hold,2);
							}
							else
							hold=1.0/(1+exp(8*((-buf[idx3]-2)/pow(5,escapeRadius+0.7)-0.5)));
						}
						//printf("%f ",buf[idx3+1]);
						buf[idx3+1]=buf[idx3+1]-1;
						i=0;
						if (buf[idx3+1]>=17)
						{
							buf[idx3+1]=buf[idx3+1]-17;
							i=128;
						}
						if (buf[idx3+1]<3)
						{
							bitmapData[bitmapIdx    ] =	255*hold;
							//bitmapData[bitmapIdx + 1] = (int)(255*hold*(1.0-cos(buf[idx3+1]*pi/3))/2);
							bitmapData[bitmapIdx + 1] = (int)(255*hold*(buf[idx3+1])/3);
							bitmapData[bitmapIdx + 2] = i;							
						}
						if ((buf[idx3+1]>=3)&&(buf[idx3+1]<6))
						{
							//bitmapData[bitmapIdx    ] = (int)(255*hold*(1.0+cos((buf[idx3+1]-3)*pi/3))/2);					    
							bitmapData[bitmapIdx    ] = (int)(255*hold*(6-buf[idx3+1])/3);
							bitmapData[bitmapIdx + 1] = 255*hold;
							bitmapData[bitmapIdx + 2] = i;																																	  
						}
						if ((buf[idx3+1]>=6)&&(buf[idx3+1]<9))
						{
							bitmapData[bitmapIdx    ] =	i;
							bitmapData[bitmapIdx + 1] = 255*hold;
							//bitmapData[bitmapIdx + 2] = (int)(255*hold*(1.0-cos((buf[idx3+1]-6)*pi/3))/2);							
							bitmapData[bitmapIdx + 2] = (int)(255*hold*(buf[idx3+1]-6)/3);							
						}
						if ((buf[idx3+1]>=9)&&(buf[idx3+1]<12))
						{
							bitmapData[bitmapIdx    ] = i;					    
							//bitmapData[bitmapIdx + 1] = (int)(255*hold*(1.0+cos((buf[idx3+1]-9)*pi/3))/2);
							bitmapData[bitmapIdx + 1] = (int)(255*hold*(12-buf[idx3+1])/3);
							bitmapData[bitmapIdx + 2] = 255*hold;																																	  
						}
						if ((buf[idx3+1]>=12)&&(buf[idx3+1]<15))
						{
							//bitmapData[bitmapIdx    ] =	(int)(255*hold*(1.0-cos((buf[idx3+1]-12)*pi/3))/2);
							bitmapData[bitmapIdx    ] =	(int)(255*hold*(buf[idx3+1]-12)/3);
							bitmapData[bitmapIdx + 1] = i;
							bitmapData[bitmapIdx + 2] = 255*hold;							
						}
						if ((buf[idx3+1]>=15)&&(buf[idx3+1]<17))
						{
							bitmapData[bitmapIdx    ] = 255*hold;					    
							bitmapData[bitmapIdx + 1] = i;
							//bitmapData[bitmapIdx + 2] = (int)(255*hold*(1.0+cos((buf[idx3+1]-15)*pi/3))/2);																																  
							bitmapData[bitmapIdx + 2] = (int)(255*hold*(18-buf[idx3+1])/3);																																  
						}
						/*if (buf[idx3+1]==17)
						{
							bitmapData[bitmapIdx    ] = 255*hold;					    
							bitmapData[bitmapIdx + 1] = 128*hold;
							bitmapData[bitmapIdx + 2] = 128*hold;																																  
						}*/
						
					}				
				}
				}
				
			if(altcol==3)
				{
				if (true) //(thisfn!=3) //((mandel==0)||(thisfn==7))
                {
                    //if (buf[idx3] < -1)
                    //    buf[idx3]=-buf[idx3]+2;
                    
                    if (buf[idx3] < 0)
                    {
                        bitmapData[bitmapIdx    ] = 0;
                        bitmapData[bitmapIdx + 1] = 0;
                        bitmapData[bitmapIdx + 2] = 0;
                    }
                    if (buf[idx3] >= 0)
                    {
                        buf[idx3]=sqrt(buf[idx3]);
                        if (thisfn==7)
                        {
                            hold=2.0*pi/creal(kk);
                            hold2=colfac;
                        }
                        else
                        {
                          //  if (mandel==1)
                          //      hold=2.0*pi;
                          //  else
                            if (orbtrap==1)
                            {
                                if (buf[idx3+1]==0)
                                    buf[idx3+1]=-1;
                                hold=2.0*pi/(buf[idx3+1]);
                                hold2=0.26;
                            }
                            else
                            {
                                if (buf[idx3+1]==0)
                                    buf[idx3+1]=-1;
                                hold=2.0*pi/(buf[idx3+1]);
                                hold2=0.22;
                            }
                            //hold=1.7/pi;
                            //hold2=0.22;                          }
                        }
                        hold=(buf[idx3+2])*hold;
                        //hold=(buf[idx3+2]-1)*hold;
                        if (buf[idx3+1]==-1)
                        {
                            bitmapData[bitmapIdx ] = (int)(255*(cos(hold2*buf[idx3])+1)/2);
                            bitmapData[bitmapIdx+1] = (int)(255*(cos(hold2*buf[idx3])+1)/2);
                            bitmapData[bitmapIdx+2] = (int)(255*(cos(hold2*buf[idx3])+1)/2
                                                            );

                        }
                        else
                        {
                        if (orbtrap==1)
                            {
                            bitmapData[bitmapIdx    ] = (int)(255*(0.8*cos(hold2*buf[idx3])+1.2)/2*(sin(hold)+1)/2);
                            bitmapData[bitmapIdx + 1] = (int)(255*(0.8*cos(hold2*buf[idx3])+1.2)/2*(sin(hold+2*pi/3)+1)/2);
                            bitmapData[bitmapIdx + 2] = (int)(255*(0.8*cos(hold2*buf[idx3])+1.2)/2*(sin(hold+4*pi/3)+1)/2);
                            }
                            else
                            {
                            bitmapData[bitmapIdx    ] = (int)(255*(cos(hold2*buf[idx3])+1)/2*(sin(hold)+1)/2);
                            bitmapData[bitmapIdx + 1] = (int)(255*(cos(hold2*buf[idx3])+1)/2*(sin(hold+2*pi/3)+1)/2);
                            bitmapData[bitmapIdx + 2] = (int)(255*(cos(hold2*buf[idx3])+1)/2*(sin(hold+4*pi/3)+1)/2);
                            }
                        }// bitmapData[bitmapIdx    ] = (int)(255*(sin(hold)+1)/2);
                       // bitmapData[bitmapIdx + 1] = (int)(255*(sin(hold+2*pi/3)+1)/2);
                       // bitmapData[bitmapIdx + 2] = (int)(255*(sin(hold+4*pi/3)+1)/2);
                    }
                }
                }
                //else
            if(altcol>=6)
                    {
              if(altcol==6)  buf[idx3]=sqrt(buf[idx3]);
				if (buf[idx3] <= 0)
					{
					bitmapData[bitmapIdx    ] = 0;
					bitmapData[bitmapIdx + 1] = 0;
					bitmapData[bitmapIdx + 2] = 0;
					}
				if (buf[idx3] > 0)
					{
					bitmapData[bitmapIdx    ] = (int)(255*((sin(colfac*buf[idx3])+1)/2));
					bitmapData[bitmapIdx + 1] = (int)(255*((sin(colfac*buf[idx3]+2*pi/3)+1)/2));
					bitmapData[bitmapIdx + 2] = (int)(255*((sin(colfac*buf[idx3]+4*pi/3)+1)/2));
					}
				//}
				}
			if(altcol==2)
				{
				if (buf[idx3] <= -1)
					{
					bitmapData[bitmapIdx    ] = 0;
					bitmapData[bitmapIdx + 1] = 0;
					bitmapData[bitmapIdx + 2] = 0;
					}
				if ((buf[idx3] < -1)&&(buf[idx3+2]!=0))
					buf[idx3]=-buf[idx3]-2+32*((int)buf[idx3+2]-1);	
				if (buf[idx3] > 0)
					{
					bitmapData[bitmapIdx    ] = ((int)(buf[idx3]) % 16) * 16;
					bitmapData[bitmapIdx + 1] = (((int)(buf[idx3]) / 16 ) % 16)  * 16;
					bitmapData[bitmapIdx + 2] = (((int)(buf[idx3]) / 256 ) % 16)  * 16;
					}
				}
			if((altcol==0)||(altcol==4))
				{
				if (buf[idx3] == -1)
					{
					bitmapData[bitmapIdx    ] = 0;
					bitmapData[bitmapIdx + 1] = 0;
					bitmapData[bitmapIdx + 2] = 0;
					}
				if (buf[idx3] < -1)
				{
					if (altcol==4)
						buf[idx3]=-buf[idx3]+2;
					else 
						buf[idx3]=-buf[idx3]-2+20;
				}
				if (buf[idx3] >= 0)
					{
				if (altcol==4)
					{
					bitmapData[bitmapIdx    ] = (int)(255*((sin(colfac*sqrt(buf[idx3]))+1)/2));
					bitmapData[bitmapIdx + 1] = (int)(255*((sin(4.0/3.0*colfac*sqrt(buf[idx3])+pi/4)+1)/2));
					bitmapData[bitmapIdx + 2] = (int)(255*((sin(3.0/2.0*colfac*sqrt(buf[idx3])+pi/2)+1)/2));
					}
				else
					{
					bitmapData[bitmapIdx    ] = (int)(255*((sin(colfac*buf[idx3])+1)/2));
					bitmapData[bitmapIdx + 1] = (int)(255*((sin(4.0/3.0*colfac*buf[idx3]+pi/4)+1)/2));
					bitmapData[bitmapIdx + 2] = (int)(255*((sin(3.0/2.0*colfac*buf[idx3]+pi/2)+1)/2));
					}
					}
				}
			if(altcol==5)
				{
					exceeded = false;
					iterationsPerSegmentDouble = ((double) maxValueForColour) / (double) COLOUR_SPACING;
					iterationsPerSegment = (int) floor(iterationsPerSegmentDouble);
					iterationsPerPeriod = iterationsPerSegment * 6;
					
					//normalise the iteration count to be between 1 and iterationsPerSegment * noOfSegments (i.e. 6)
					iterations=buf[idx3];
					if (iterations<-1)
						iterations=-iterations;
					if (iterations==-1)
						if ((!esconly)&&(orbtrap)) 
							{
							if (thisfn==23)
							
								{
									bitmapData[bitmapIdx    ] = (int)(255*((cos(pow(10,escapeRadius-0.2)*colfac*buf[idx3+2])+1)/2));
									bitmapData[bitmapIdx + 1] = (int)(255*((cos(pow(10,escapeRadius-0.2)*colfac*buf[idx3+2])+1)/2));
									bitmapData[bitmapIdx + 2] = (int)(255*((cos(pow(10,escapeRadius-0.2)*colfac*buf[idx3+2])+1)/2));
								}
							else
								{
									bitmapData[bitmapIdx    ] = (int)(255*((cos(pow(10,escapeRadius-0.6)*colfac*buf[idx3+2])+1)/2));
									bitmapData[bitmapIdx + 1] = (int)(255*((cos(pow(10,escapeRadius-0.6)*colfac*buf[idx3+2])+1)/2));
									bitmapData[bitmapIdx + 2] = (int)(255*((cos(pow(10,escapeRadius-0.6)*colfac*buf[idx3+2])+1)/2));
								}
							}
						else
							 
						{
							bitmapData[bitmapIdx    ] = 255;
							bitmapData[bitmapIdx + 1] = 255;
							bitmapData[bitmapIdx + 2] = 255;
						}
						else {
					
					while (iterations >= iterationsPerPeriod){
						exceeded = true;
						i = iterations / iterationsPerPeriod;
						iterations = iterations - (iterationsPerPeriod * i);
					}
					
					//int m = 0;
						bitmapData[bitmapIdx    ] = 0;
						bitmapData[bitmapIdx + 1] = 0;
						bitmapData[bitmapIdx + 2] = 0;
						
					//1. From Black (0,0,0) to Blue (0,0,255)
					if ((iterations < (iterationsPerSegment)) && !(exceeded)){
						//the colour sequence from within the segment
						segmentSequenceNo = iterations;
						bitmapData[bitmapIdx    ] = 0;
						bitmapData[bitmapIdx + 1] = 0;
						bitmapData[bitmapIdx + 2] = (int) (segmentSequenceNo * COLOUR_SPACING);
					}
					//7. From Magenta (255,0,255) to Blue (0,0,255)
					else if ((iterations < (iterationsPerSegment)) && (exceeded)){
						segmentSequenceNo = iterations;
						bitmapData[bitmapIdx    ] = maxValueForColour - ((int) (segmentSequenceNo * COLOUR_SPACING));
						bitmapData[bitmapIdx + 1] = 0;
						bitmapData[bitmapIdx + 2] = maxValueForColour;
					}
					//2. From Blue (0,0,255) to Cyan (0,255,255)
					else if ((iterations >= iterationsPerSegment) && (iterations < iterationsPerSegment * 2)){
						segmentSequenceNo = iterations - (int) iterationsPerSegment;
						bitmapData[bitmapIdx    ] = 0;
						bitmapData[bitmapIdx + 1] = ((int) (segmentSequenceNo * COLOUR_SPACING));
						bitmapData[bitmapIdx + 2] = maxValueForColour;
					}
					//3. From Cyan (0,255,255) to Green (0,255,0)
					else if ((iterations >= iterationsPerSegment * 2) && (iterations < iterationsPerSegment * 3)){
						segmentSequenceNo = iterations - (int) (iterationsPerSegment * 2);
						bitmapData[bitmapIdx    ] = 0;
						bitmapData[bitmapIdx + 1] = maxValueForColour;
						bitmapData[bitmapIdx + 2] = maxValueForColour - ((int) (segmentSequenceNo * COLOUR_SPACING));
					}
					//4. From Green (0,255,0) to Yellow (255,255,0)
					else if ((iterations >= iterationsPerSegment * 3) && (iterations < iterationsPerSegment * 4)){
						segmentSequenceNo = iterations - (int) (iterationsPerSegment * 3);
						bitmapData[bitmapIdx    ] = ((int) (segmentSequenceNo * COLOUR_SPACING));
						bitmapData[bitmapIdx + 1] = maxValueForColour;
						bitmapData[bitmapIdx + 2] = 0;
					}
					//5. From Yellow (255,255,0) to Red (255,0,0)
					else if ((iterations >= iterationsPerSegment * 4) && (iterations < iterationsPerSegment * 5)){
						segmentSequenceNo = iterations - (int) (iterationsPerSegment * 4);
						bitmapData[bitmapIdx    ] = maxValueForColour;
						bitmapData[bitmapIdx + 1] = maxValueForColour - ((int) (segmentSequenceNo * COLOUR_SPACING));
						bitmapData[bitmapIdx + 2] = 0;
					}
					//6. From Red (255,0,0) to Magenta (255,0,255)
					else if ((iterations >= iterationsPerSegment * 5) && (iterations < iterationsPerSegment * 6)){
						segmentSequenceNo = iterations - (int) (iterationsPerSegment * 5);
						bitmapData[bitmapIdx    ] = maxValueForColour;
						bitmapData[bitmapIdx + 1] = 0;
						bitmapData[bitmapIdx + 2] = ((int) (segmentSequenceNo * COLOUR_SPACING));
					}
					}
					
				}
			
			}
		}
	/*
        if ( acc_dwells > 10000000 )
        {
            [self setNeedsDisplay:YES];
            acc_dwells = 0;
        }
	*/
	}
	else {
		[workLock lock];
		for (idx = 0, bitmapIdx = lineTable[myLine] * w * 3; idx < w; idx++, bitmapIdx += 3 )
		{
			bitmapData[bitmapIdx    ] = bitmapDatasav[bitmapIdx    ];
			bitmapData[bitmapIdx + 1] = bitmapDatasav[bitmapIdx + 1];
			bitmapData[bitmapIdx + 2] = bitmapDatasav[bitmapIdx + 2];	}
	}
	updateRect.origin.y = h - lineTable[myLine];
	[self setNeedsDisplayInRect:updateRect];
	[workLock unlock];
    }
    
    // [workLock lock];
//    [self setNeedsDisplay:YES];
    // [workLock unlock];
//    sleep(1);
    [self setNeedsDisplay:YES];
	thrds++;
    // printf ("exiting thread\n");
    return;
}

// delegate of NSApplication
- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
	//NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];

    // for some reason, app's window doesn't start out being key and front.  :(
    // printf ("applicationDidFinishLaunching\n");
    [window makeKeyAndOrderFront:nil];
    [window setInitialFirstResponder:self];
    num_threads = atoi([[threadMenu titleOfSelectedItem] UTF8String]);
    max_dwells = atoi([[dwellMenu titleOfSelectedItem] UTF8String]);
    lastLine = 0;
    height = frame.size.height;
    comp_sequence = 0;
	coeffs[0]=1;
	coeffs[2]=-3.25;
	coeffs[4]=2.25;
	prms[2]=1;
	prms[6]=1;
    // viewX = -2.5; viewStep = 4.0 / frame.size.width;
    // viewY = (double) frame.size.height * viewStep * 0.5;
   // originX = 0.0;
    //originY = 0.0;
	mandel=2;
    workLock = [[NSLock alloc] init];
    isSelecting = NO; isDragging = NO;
    [self resetButton:nil];
    //    [NSThread detachNewThreadSelector:@selector(threadMain) toTarget:self withObject:nil];
	//[pool drain]; // This one might not strictly speaking be neccessary.
	//[pool release];

}

- (BOOL)applicationShouldTerminateAfterLastWindowClosed:(NSApplication *)theApplication
{
    return YES;
}

@end
