// compute one scan line of mandelbrot set

#include "mandel.h"
#include <complex.h>
#include <math.h>
#include <string.h>
//#include <stdlib.h>

double mystep, escbd; 
int myzt, altgam, thisfn;//, mdz;
const double pi=3.1415926535;
const double tesc=0.001;
double myfrac=1.0/2000;


double _Complex myfn(double _Complex z, double _Complex c, double _Complex k, double _Complex cofs[6])
//double _Complex myfn(double _Complex z, double _Complex c, double _Complex k)
{
int i;
double _Complex zz,zz2,kc,cc;
double kh,kh2,kh3,x,y;
int j;
double _Complex a,d,d2,d3;
//double xh, yh, xhh;
double _Complex ca[20],v1,v2,v3,v4,v5,ca32,ca33;
double p213;

switch (thisfn)
{
case 1:
		{
        if((cimag(k)==0)&&(creal(k)==(int)creal(k))&&(creal(k)>1))
        {
            //if(cimag(k)==100) z=conj(z);
            zz=1;
            for (i=1;i<=(int)creal(k);i++)
                zz=zz*z;
            z=zz+c;
        }
		else z=cpow(z,k)+c;
            //z=(z*z+c)*(z*z+c)+conj(c);
        /*    xh=creal(z);
            yh=cimag(z);
      //      xhh=xh*xh+creal(c)-creal(k)*yh*yh*yh;
      //      yh=cimag(k)*xh+cimag(c);
      //      z=xhh+I*yh;
            z=(fabs(xh)+I*fabs(yh))*(fabs(xh)+I*fabs(yh))+c;*/
		break;
		}
case 2:		
		{ 
		if (k==1+I) z=c*z*(1-z);
		else if (k==2+I) z=c*z*z*(1-z);
		else if (k==3+I) z=c*z*z*z*(1-z);
		else z=c*cpow(z,creal(k))*cpow(1.0-z,cimag(k)); 
		break; 
		}
case 3:
		{
        kc=k;
        if (creal(kc)>100)
        {
            kc=kc-100;
            zz=1;
            for (i=1;i<=(int)creal(kc);i++)
                zz=zz*conj(z);
            z=zz-conj(z)*cimag(kc)+c;
            //printf("%f %f ",creal(k),cimag(k));
        }
        else
        {
		zz=1;
		for (i=1;i<=(int)creal(kc);i++)
			zz=zz*z;
		z=zz-z*cimag(kc)+c;
        }
		break; 
		}
case 4:		
		{
		if (creal(k)==1) 
			z=(z-cimag(k))*(z+c);
		else if (creal(k)==2) 
			z=(z*z-cimag(k))*(z+c);
		else if (creal(k)==3) 
			z=(z*z*z-cimag(k))*(z+c);
		else
			{
			zz=z*z;
			z=(zz*zz-cimag(k))*(z+c);
			}
		break; 
		}
        /*{
        if (creal(k)==1)
            z=(z-c)*(z+cimag(k));
        else if (creal(k)==2)
            z=(z*z-c)*(z+cimag(k));
        else if (creal(k)==3)
            z=(z*z*z-c)*(z+cimag(k));
        else
        {
            zz=z*z;
            z=(zz*zz-c)*(z+cimag(k));
        }
        break; 
         }*/
case 5:
		{
		i=(int)creal(k);
		zz=cpow(z,i+1);
		z=z*zz/(i+2)+c*zz/(i+1)-cimag(k)*(z*z/2+c*z);
		break; 
		}
case 6:
		{ 
		zz=1;
		for (i=1;i<=(int)creal(k);i++)
			zz=zz*z;
		z=zz+(c-1)*z-c;
		break; 
		}
case 7:
		{ 
		zz=1;
		for (i=2;i<=(int)creal(k);i++)
			zz=zz*z;
		if (cimag(k)!=-1)
            z=(((int)creal(k)-1)*z*zz+c)/((int)creal(k)*zz+c-1);
        else
            z=(((int)creal(k)+1)*z*zz+2*(c-1)*z-c)/((int)creal(k)*zz+c-1);
		break; 
		}
case 8:
		{
		if (z==0)
			z=0;
		else
			z=c*csin(1.0/z);
		break;
		}
case 9:
		{
		if ((creal(k)==1)&&(cimag(k)==1))
			z=c*ccos(z);
		else if ((creal(k)==2)&&(cimag(k)==1))
			z=c*ccos(z*z);
		else if ((creal(k)==3)&&(cimag(k)==1))
			z=c*ccos(z*z*z);
		else if ((creal(k)==0.5)&&(cimag(k)==1))
			z=c*ccos(csqrt(z));
		else
			//z=c*ccos(cpow(z,creal(k)));
			z=c*cpow(ccos(cpow(z,creal(k))),cimag(k));


		break; 
		}
case 10:
		{
		if ((creal(k)==1)&&(cimag(k)==1))
			z=ccos(z)+c;
		else if ((creal(k)==2)&&(cimag(k)==1))
			z=ccos(z*z)+c;
		else if ((creal(k)==3)&&(cimag(k)==1))
			z=ccos(z*z*z)+c;
		else if ((creal(k)==0.5)&&(cimag(k)==1))
			z=ccos(csqrt(z))+c;
		else
			z=cpow(ccos(cpow(z,creal(k))),cimag(k))+c;
		break; 
		}
case 11:
		{ z=c*(csin(z)+0.5*csin(z/2)); break; }
case 12:
		{ z=c*(ccos(z)+ccos(2*z)); break; }
case 13:
		{
		if (z==0)
			z=1;
		else
			z=c*csin(z)/z;
		break;
		}
case 14:
		{
		if (k==1+I)
			z=c*z*cexp(z);
		else
			z=c*cpow(z,creal(k))*cexp(cpow(z,cimag(k)));
		break; 
		}
case 15:
		{
        if ((creal(k)>=1)&&(creal(k)<=4))
        {
            zz=1.0;
            for (i=1;i<=creal(k);i++)
                zz=zz*z;
            z=zz*cexp(z)+c;
        }
        //if (cimag(k)==1)
        //	z=z*cexp(z)+c;
        else 
            z=cpow(z,creal(k))*cexp(z)+c;
        break;
		}
		//{ z=c*ccos(csqrt(z)); break; }
		//{ z=ccos(1.0/z)+c; break; }
case 16:
		{
		/*if (creal(k)==1)
			if ((cimag(k)>=1)&&(cimag(k)<=4))
			{
				zz=1.0;
				for (i=1;i<=cimag(k);i++)
					zz=zz*z;
				z=zz*cexp(z)+c;
			}
			//if (cimag(k)==1)
			//	z=z*cexp(z)+c;
			else 
				z=cpow(z,cimag(k))*cexp(z)+c; */
        switch ((int)creal(k))
        {
            case 1:
            {
                    z=c*(cexp(z)-cimag(k));
                break;
            }
            case 2:
            {
                z=z*clog(z)+c;
                break;
            }
            case 3:
            {
                z=c*z*clog(z);
                break;
            }
            case 4:
            {
                z=cpow(z,z)+c;
                break;
            }
            case 5:
            {
                z=z*cexp(cimag(k)*cexp(z))*c;
                break;
            }
            case 6:
            {
                z=z*cexp(-cexp(z))+c;
                break;
            }
            case 7:
            {
                z=((z-2)*z+2)*cexp(z)*c;
                break;
            }
            case 8: z=(z*z*z-3*z*z+6*z-6)*cexp(z)*c;
            case 9:
                
            {
                zz=0;
                for (i=0;i<=cimag(k);i++)
                    zz=zz+ccos((2*i+1)*z)/(2*i+1)/(2*i+1);
                z=zz*c;
                break;
            }
            case 10:
            {
                zz=0;
                for (i=0;i<=cimag(k);i++)
                    zz=zz+cpow(-1,i)*ccos((2*i+1)*z)/(2*i+1);
                z=zz*c;
                break;
            }
            case 11:
            {
                //z=csin(z)/ccos(z)*c;
                z=-clog(ccos(z))*c;
                break;
            }
            case 12:
            {
                //z=-2/(ctan(z/2)*ctan(z/2) - 1)*c;
                z=(ctan(z)-z)*c;break;
            }
            case 13:
            {
                //z=-2/(ctan(z/2)*ctan(z/2) - 1)*c;
                zz=ctan(z);
                z=(z-zz+zz*zz*zz/3)*c;
                break;
            }
            case 14:
            {
                z=z-catan(z)+c;
                break;
            }
            case 15:
            {
                z=c*cexp(c)*(z-(1.0-c))*cexp(z);
                 //z=cimag(k)*cexp(cimag(k))*(z-(1.0-cimag(k)))*cexp(z)+c;
                break;
            }
            case 16:
            {
                zz=z;
                for(i=1;i<=cimag(k);i++)
                    z=cexp(z);
                z=c*zz*z;
                //z=c*z*cexp(z);
                break;
            }
            case 17:
            {
                zz=z;
                for(i=1;i<=cimag(k);i++)
                    z=cexp(z);
                z=c*z;
                //z=c*z*cexp(z);
                break;
            }
        }
  		break;
		}

case 17:
	{
        switch ((int)creal(k))
        {
            case 1:
            {
                z=(cpow(z,cimag(k))-1.0/z)*c;  //z=z*z-1.0/(cimag(k)+1)/z*c;
                break;
            }
            case 2:
            {
                z=(z*z*z-1)/(z*z+1); z=z*z+c;
                break;
            }
            case 3:
            {
                z=z*z+c; z=(z*z*z-1)/(z*z+1);
                break;
            }
            case 4:
            {
                z=cpow(z,7)/7+cpow(z,6)/6-cpow(z,5)/5-cpow(z,4)/4+c;
                break;
            }
            case 5:
            {
                z=(z*z*z-1)/(z*z+1); z=z*z*c;
                break;
            }
            case 6:
            {
                {
                    zz=1;
                    for (i=1;i<=(int)cimag(k);i++)
                        zz=zz*z;
                    z=(zz-z)*c;
                    //break;
                }
                break;
            }
            case 7:
            {
                if (cimag(k)==0)
                    z=-1.0/((cpow((z - 1),4)*cpow((z + 1),5))/((2*z - 1)*cpow((2*z*z - z + 1),5)*cpow((2*z*z + 2*z + 1),4)))+c;
                else
                    z=-1.0/((cpow((z - 1),4)*cpow((z + 1),5))/((2*z - 1)*cpow((2*z*z - z + 1),5)*cpow((2*z*z + 2*z + 1),4)))*c;
                break;
            }
            case 8:
            {
                if (cimag(k)==0)
                    z=-((cpow((z - 1),4)*cpow((z + 1),5))/((2*z - 1)*cpow((2*z*z - z + 1),5)*cpow((2*z*z + 2*z + 1),4)))+c;
                else
                    z=-((cpow((z - 1),4)*cpow((z + 1),5))/((2*z - 1)*cpow((2*z*z - z + 1),5)*cpow((2*z*z + 2*z + 1),4)))*c;
          		//{ z=cpow(1-cpow(z,2),2)*(59049*cpow(z,20) + 98415*cpow(z,18) + 87480*cpow(z,16) - 5832*cpow(z,15) + 52245*cpow(z,14) - 6480*cpow(z,13) + 23355*cpow(z,12) - 3720*cpow(z,11) + 8544*cpow(z,10) - 1240*cpow(z,9) + 2595*cpow(z,8) - 240*cpow(z,7) + 645*cpow(z,6) - 24*cpow(z,5) + 120*cpow(z,4) + 15*cpow(z,2) + 1)*c; break; }
                break;
            }
         case 9:
            {
             z=c+1/(z*z-c*c);
                break;
            }
         case 10:
            {
                z=c+2*z*z*z/27/(2-z);
                break;
            }
         case 11:
         {
             if (cimag(k)==0)
             {
                 c=-8*(c+8)/(c-8);
                 z=1+c/z-c/z/z;
             }
             if (cimag(k)==1)
                 z=z*z+c;
             if (cimag(k)==2)
                 z=c/z/(z+2);
                //z=c/z-c*c/2/z/z;
             if (cimag(k)==2.5)
                 z=(z*z+c)/(z*z-1);
             if (cimag(k)==3)
                 //z=(z-1)*(z-c)/z/z;
                z=(z-1.0)*(z-c/(2.0-c))/z/z;
             if (cimag(k)==3.5)
                 z=(z*z+c*c*c-c-1)/(z*z-c*c);
             if (cimag(k)==4)
                //z=(z-c/(2-c))*(z-(3*c-2)/(2*c-2))/z/z;
                z=(z-4*(-c)/(10*(-c)-1))*(z-(1-2*(-c))/(1-6*(-c)))/z/z; //from above d=c/(8-14*c);
                //z=(z-c)*(z-(2*c-1)/(c-1))/z/z;
             if (cimag(k)==4.5)
             //    z=(z*z-(c*c+c+1)*z+c*(c+1))/(z*z-(c+1+1/c)*z+c+1);
                  //z=1-(c*c+c-1)/(c-1)/z+c*(2*c-1)/(c-1)/z/z;
               {   if(fabs(cimag(c))>=0.8)
                       if (creal(c)<=0.6)
                           kc=((c-1)+csqrt(5*c*c-6*c+5))/2;
                       else
                           kc=((c-1)-csqrt(5*c*c-6*c+5))/2;
                    else
                       if (creal(c)<=0.6+0.15*sqrt(1-cimag(c)*cimag(c)/0.64)) //(creal(c)<=1.0)
                           kc=((c-1)+csqrt(5*c*c-6*c+5))/2;
                       else
                           kc=((c-1)-csqrt(5*c*c-6*c+5))/2;
                   z=(z*z+kc*(1-c*c)-1)/(z*z-c*c);
               }
             if (cimag(k)==4.75)
                 //    z=(z*z-(c*c+c+1)*z+c*(c+1))/(z*z-(c+1+1/c)*z+c+1);
                 //z=1-(c*c+c-1)/(c-1)/z+c*(2*c-1)/(c-1)/z/z;
             {   if(fabs(cimag(c))>=0.8)
                 if (creal(c)<=0.6)
                     kc=((c-1)-csqrt(5*c*c-6*c+5))/2;
                 else
                     kc=((c-1)+csqrt(5*c*c-6*c+5))/2;
                 else
                     if (creal(c)<=0.6+0.15*sqrt(1-cimag(c)*cimag(c)/0.64)) //(creal(c)<=1.0)
                         kc=((c-1)-csqrt(5*c*c-6*c+5))/2;
                     else
                         kc=((c-1)+csqrt(5*c*c-6*c+5))/2;
                 z=(z*z+kc*(1-c*c)-1)/(z*z-c*c);
             }
         //    if (cimag(k)==5)
        
             //z=z*z+c/z/z;
             
             break;
         }
        case 12:
            {
                //z=(cimag(k)*z*z+(1-cimag(k)))/(c*z*z-(1-c));
                z=z*z+cexp(2*pi*I*c)*z;
                break;
            }
        case 13:
            {
                z=z*z*z-3*c*z+csqrt(4*c*(c+0.5)*(c+0.5));
                break;
            }
        case 14:
            {
                z=2*z*z*z/(3*c-2)-3*c*z*z/(3*c-2)+1;
            //z=1.0/c/(1-c)*z*z*(z-1)+c; crit=2/3
                break;
            }
                
        case 15:
            {
                z=z*z*z+c*z*z+z*cexp(2*pi*I*(cimag(k)));
                break;
            }
        case 16:
        {
            z=(c*c*c-c+1)/c/c/(c-1)*z*z*z-(c*c*c*c-c+1)/c/c/(c-1)*z*z+c;
            break;
        }
        case 17:
            {
                z=(c*c-1)/c/c*z*z*z-(c*c*c-1)/c/c*z*z+c;
                break;
            }
        case 18:
            {
                 //z=1.0/c/c*z*z*(1-z)+c; //crit 2/3
                z=(c-z)*z*z+1;  //crit 2c/3
                break;
            }
        case 19:
            {
                cc=c*c;
                zz=z*z;
                v1=csqrt(cc*cc + 4*cc*c - 2*cc + 1);
                if ((cimag(k)==2)||(cimag(k)==0))
                    v1=-v1;
                x=creal(c);
                if((x>0.460817575454712)||(x<-3.31260347366333))
                    if(fabs(cimag(c))<fabs(pow(x*(x + 1)*(x*x + 3*x - 1),1.0/2)/(x + 1)))
                        v1=-v1;
                if((x<=0.460817575454712)&&(x>0.316429))
                    if(fabs(cimag(c))<fabs(sqrt(0.187633-9*(x-0.460817575454712)*(x-0.460817575454712))))
                        v1=-v1;
                if((cimag(k)==2)||(cimag(k)==3))
                {
                     a= (3*cc - 3*c*v1 - 3*c + 3*cc*c + 3*v1 + 3)/(2*cc*(c - 1));
                    kc= (c*v1 - 3*c + cc + cc*c + cc*cc - cc*v1 + 2)/(cc*(c - 1));
                    z=a*zz*z/3-kc*zz/2+c;
                }
                if((cimag(k)==0)||(cimag(k)==1))
                {
                    a= (3*c*v1 - 3*c + 3*cc + 3*cc*c - 3*v1 + 3)/(2*cc*(c - 1));
                    kc= (cc - c*v1 - 3*c + cc*c + cc*cc + cc*v1 + 2)/(cc*(c - 1));
                    z=a*zz*z/3-kc*zz/2+c;
                }
                if(cimag(k)==4)
                    z= ((cc-1))/c/c*z*z*z-(cc*c - 1)/c/c*z*z+c;
                if(cimag(k)==5)
                    z= -1/c/c*z*z*z-(-1/c/c)*z*z+c;
                break;
            }
        case 20:
        {
            ca[1]=c;
            for (j=2;j<20;j++)
                ca[j]=ca[j-1]*c;
            p213=pow(2,1.0/3);
            ca32=(-1+c-2*ca[3])*(-1+c-2*ca[3]);
            ca33=(-1+c-2*ca[3])*ca32;
            
            v1=cpow(2-6*c+6*ca[2]+25*ca[3]-75*ca[4]-3*ca[5]+231*ca[6]-288*ca[7]+114*ca[8]+30*ca[9]-36*ca[10]+2*ca[12]+csqrt(108*ca[3]-648*ca[4]+1188*ca[5]+1161*ca[6]-8910*ca[7]+13419*ca[8]+6264*ca[9]-47817*ca[10]+52002*ca[11]+30861*ca[12]-134352*ca[13]+138024*ca[14]-50544*ca[15]-10044*ca[16]+9828*ca[17]-108*ca[18]-432*ca[19]),1.0/3);
            v2=csqrt(ca32/(4*ca[4])-(2*(1-c+ca[4]))/(3*ca[2])+(p213*(1-2*c+ca[2]+2*ca[4]+10*ca[5]-12*ca[6]+ca[8]))/(3*ca[2]*v1)+(1/(3*p213*ca[2]))*(v1));
            switch ((int)cimag(k))
            {
                case 0:
                case 1:
                {
                    v3=csqrt(ca32/(2*ca[4])-(4*(1-c+ca[4]))/(3*ca[2])-(p213*(1-2*c+ca[2]+2*ca[4]+10*ca[5]-12*ca[6]+ca[8]))/(3*ca[2]*v1)-(1/(3*p213*ca[2]))*(v1)-(-(ca33/ca[6])+(4*(-1+c-2*ca[3])*(1-c+ca[4]))/ca[4])/(4*v2));
                    break;
                }
                case 2:
                case 3:
                {
                    v4=csqrt(ca32/(2*ca[4])-(4*(1-c+ca[4]))/(3*ca[2])-(p213*(1-2*c+ca[2]+2*ca[4]+10*ca[5]-12*ca[6]+ca[8]))/(3*ca[2]*v1)-(1/(3*p213*ca[2]))*(v1)+(-(ca33/ca[6])+(4*(-1+c-2*ca[3])*(1-c+ca[4]))/ca[4])/(4*v2));
                    break;
                }
            }
            v5=(-1+c-2*ca[3])/(4*ca[2]);
            
            switch ((int)cimag(k))
            {
                case 0:
                {
                    a=(1.0/(-ca[2]+ca[3]))*(9*(1-c)/4+(3*ca[3])/2+3.0/2*ca[2]*v2+3.0/2*ca[2]*v3);
                    d=-v5-1.0/2*v2-1.0/2*v3;
                    break;
                }
                case 1:
                {
                    a=(1.0/(-ca[2]+ca[3]))*(9*(1-c)/4+(3*ca[3])/2+3.0/2*ca[2]*v2-3.0/2*ca[2]*v3);
                    d=-v5-1.0/2*v2+1.0/2*v3;
                    break;
                }
                case 2:
                {
                    a=(1.0/(-ca[2]+ca[3]))*(9*(1-c)/4+(3*ca[3])/2-3.0/2*ca[2]*v2+3.0/2*ca[2]*v4);
                    d=-v5+1.0/2*v2-1.0/2*v4;
                    break;
                }
                case 3:
                {
                    a=(1.0/(-ca[2]+ca[3]))*(9*(1-c)/4+(3*ca[3])/2-3.0/2*ca[2]*v2-3.0/2*ca[2]*v4);
                    d=-v5+1.0/2*v2+1.0/2*v4;
                    break;
                }
            }
            d2=d*d;
            d3=d*d2;
            kc=(-2+6*c-6*ca[2]+2*ca[4]+2*ca[5]-2*ca[6]-2*ca[7]-2*ca[2]*d+6*ca[3]*d-6*ca[4]*d+2*ca[5]*d+2*ca[5]*d2-2*ca[6]*d2-2*ca[4]*d3+2*ca[5]*d3)/(-3+9*c-9*ca[2]-3*ca[3]+12*ca[4]-6*ca[5]-3*ca[6]);
            z=a*z*z*z/3-a*kc*z*z/2+c;
            break;
            
            }
            case 21:
            {
                if (cimag(k)==0)
                {
                    a=(3*c - (9*csqrt(-(4*(2*c - 1)*(2*c + 1))/9))/2 + (9*c*csqrt(-(4*(2*c - 1)*(2*c + 1))/9))/2 - 3)/(- 2*c*c*c + 2*c*c);
                    kc=(4*c*c*c - 3*csqrt(-(4*(2*c - 1)*(2*c + 1))/9) - 2*c + 3*c*csqrt(-(4*(2*c - 1)*(2*c + 1))/9) + 2)/(6*c*c);
                }
                else
                {
                    a=(3*c + (9*csqrt(-(4*(2*c - 1)*(2*c + 1))/9))/2 - (9*c*csqrt(-(4*(2*c - 1)*(2*c + 1))/9))/2 - 3)/(- 2*c*c*c + 2*c*c);
                    kc=(3*csqrt(-(4*(2*c - 1)*(2*c + 1))/9) - 2*c + 4*c*c*c - 3*c*csqrt(-(4*(2*c - 1)*(2*c + 1))/9) + 2)/(6*c*c);
                }
                z=a*z*z*z/3-a*kc*z*z/2+c;
                break;
            }
            case 22:
            {
                //z=(2-3*c)/3/c/c/(c-1)*(z*z*z-z*z)+c;
                z=c*c*(2*c-3)/3/(1-c)*(z*z*z-z*z)+1.0/c;
                break;
            }
            case 23:
            {
                //if (cimag(k)==0)
                //    k=creal(k)+2.0*I;
                if (cimag(k)==2)
                    z=c*(z-0.5/z/z);
                else
                    z=c*(z+1.0/cimag(k)/cpow(z,cimag(k)));
                //z=c*(z+cimag(k)/z/z);
                break;
            }
            case 24:
            {
                kh=cimag(k);
                kh=fabs(10*(kh-(int)kh));
                
                if (cimag(k)>0)
                   z=(z*z+kh*cpow(c,fabs((int)cimag(k))))/(z*z+c);
                else
                   z=(z*z-kh*cpow(c,fabs((int)cimag(k))))/(z*z+c);
                break;
            }
            case 25:
            {
                kh=cimag(k);
                kh=fabs(10*(kh-(int)kh));
                
                if (cimag(k)>0)
                    z=(z*z*z-kh*z+cpow(c,fabs((int)cimag(k))))/(z*z*z-kh*z+c);
                else
                    z=(z*z*z-kh*z-cpow(c,fabs((int)cimag(k))))/(z*z*z-kh*z+c);
                break;
            }
            case 26:
            {
                kh=cimag(k);
                kh=fabs(10*(kh-(int)kh));
               if (cimag(k)>0)
                    z=(z*z*z+kh*cpow(c,fabs((int)cimag(k))))/(z*z*z+c*c);
                else
                    z=(z*z*z-kh*cpow(c,fabs((int)cimag(k))))/(z*z*z+c*c);
                break;
           }
            case 27:
            {
                kh=cimag(k);
   //             kh=fabs(10*(kh-(int)kh));
                kh=(10*(kh-(int)kh));

//                if (cimag(k)>0)
                    z=(cpow(z,kh)-cpow(c,fabs((int)cimag(k))))/(cpow(z,kh)+c);
   //              z=(cpow(z,kh)-cpow(c,((int)cimag(k))))/(cpow(z,kh)+c);
//                else
//                    z=(z*z-kh*cpow(c,fabs((int)cimag(k))))/(z*z+c);
                break;
            }
            case 28:
            {
                kh=round(1000*cimag(k));
                if (kh>0)
                    kh2=floor(kh/1000);
                else
                    kh2=ceil(kh/1000);
                kh=kh-kh2*1000;
                if (kh>0)
                    kh3=floor(kh/100);
                else
                    kh3=ceil(kh/100);
                kh=fabs((kh-kh3*100)/10);
                /*kh=cimag(k);
        //        kh=fabs(10*(kh-(int)kh));
                kh=(10*(kh-(int)kh));
                pw=round(kh);
                kh=round(100*(kh-(int)kh))/10;
                   //                if (cimag(k)>0)
               //              z=(cpow(z,kh)-z-cpow(c,fabs((int)cimag(k))))/(cpow(z,kh)-z+c);*/
                z=(cpow(z,kh3)-pow(10,kh)*z-cpow(c,fabs((int)cimag(k))))/(cpow(z,kh3)-pow(10,kh)*z+c);
                //                else
                //                    z=(z*z-kh*cpow(c,fabs((int)cimag(k))))/(z*z+c);
            //    printf("%e %e %e\n",fabs((int)cimag(k)),kh3,kh);
                break;
            }
        }
		break;
	}
        
case 18:
	{
		/*zz=1;
		for (i=1;i<=(int)creal(k);i++)
			zz=zz*z;
		z=(zz-z*cimag(k))/z+c;*/

		//z=cpow(z,creal(k))-1.0*cimag(k)/z+c;
		kh=cimag(k);
		kh=fabs(10*(kh-(int)kh));
		//z=cpow(z,creal(k))-1.0*kh/z+c;
		if (kh==0)
			z=cpow(z,creal(k))+c;
		else if ((creal(k)>0) && (creal(k)<9) && ((int)cimag(k)>-9) && ((int)cimag(k)<9))
				{
				zz=1.0;
				zz2=1.0;
				for (i=1;i<=creal(k);i++)
					zz=zz*z;
				for (i=1;i<=(int)fabs((int)cimag(k));i++)
					zz2=zz2*z;
				if ((int)cimag(k)<0)
					z=zz-kh*zz2+c;
				else
					z=zz-kh/zz2+c;
				}
		else
			z=cpow(z,creal(k))-kh/cpow(z,(int)cimag(k))+c;
			//z=z*z*z-z*z*z*z+c;
		break; 
	}
case 19:
		{ z=c*cpow(z,z+k); break; }
case 20:		
		{ 
			z=z*(z*z+(k-1)*z-k)*c;
			//z=z*z*(z-1)*c;
			break; }
case 21:
		{
		if (creal(k)>0)
		{
		if (k==2)
			 z=cexp(-z*z)+c; 
		else if (k==3) 
			z=cexp(-z*z*z)+c;
		else
			{
			zz=z*z;
			z=cexp(-zz*zz)+c;
			}
		}
		else
		{
		if (k==-2)
			 z=cexp(z*z)+c; 
		else if (k==-3) 
			z=cexp(z*z*z)+c;
		else
			{
			zz=z*z;
			z=cexp(zz*zz)+c;
			}
		}
		/*if (z==0)
			z=0;
		else
			z=-cpow(z,k);
		z=cexp(z)+c;*/
		break; 
		}
case 22:		
		{
		zz=z*z;
		z=cofs[0]*zz*zz*z+cofs[1]*zz*zz+cofs[2]*z*zz+cofs[3]*zz+cofs[4]*z+cofs[5];
		break;
		}
case 23:
		{ z=c*z*z*(z-k)/(1-k*z); break; }
case 24:
		{ z=k*z*z*(z-c)/(1-c*z); break; }
case 25:
		{ zz=(c*z+1)/k; z=(z/2+zz+(z/2-zz)*ccos(pi*z))/2; break; }
case 26:
		{ 
		if ((int)(cimag(k)==0))
			z=cpow(z,creal(k))+c;
		else
			if ((int)(creal(k)==0))
				z=1+c*cpow(z,-cimag(k));
			else
				z=cpow(z,creal(k))+c*cpow(z,-cimag(k));
		break;
		}		
case 27:
		{ z=c*ccos(cpow(z,creal(k))+cpow(z,-cimag(k))); break; }
case 28:
	{
        z=cofs[2]*z+cofs[3]+cofs[4]+cofs[5]/z;
        break;
	}
case 29:
	{
		/*zz=1;
		 for (i=1;i<=(int)creal(k);i++)
		 zz=zz*z;
		 z=(zz-z*cimag(k))/z+c;*/
		
		//z=cpow(z,creal(k))-1.0*cimag(k)/z+c;
		kh=cimag(k);
		kh=fabs(10*(kh-(int)kh));
		//z=cpow(z,creal(k))-1.0*kh/z+c;
		if (kh==0)
			z=cpow(z,creal(k))+c;
		else if ((creal(k)>0) && (creal(k)<9) && ((int)cimag(k)>-9) && ((int)cimag(k)<9))
		{
			zz=1.0;
			zz2=1.0;
			for (i=1;i<=creal(k);i++)
				zz=zz*z;
			for (i=1;i<=(int)fabs((int)cimag(k));i++)
				zz2=zz2*z;
			if ((int)cimag(k)<0)
				z=zz+kh*zz2+c;
			else
				z=zz+kh/zz2+c;
		}
		else
			z=cpow(z,creal(k))+kh/cpow(z,(int)cimag(k))+c;
		//z=z*z*z-z*z*z*z+c;
		break;
	}
    case 30:
    {
        //z=z*z*z-k*z+c;
        z=z*z*z+c*z*z+z*creal(k)*cexp(2*pi*I*cimag(k));
        break;
    }
    case 31:
    {
        if (k!=1)
        z=(cofs[0]*z*z+(1.0-cofs[0]))/(cofs[1]*z*z+(1.0-cofs[1]))*c;
        else
        z=(z*z+cofs[0])/(z*z+cofs[1])*c;
        //printf("%f %f\n", creal(cofs[0]),creal(cofs[1]));
        break;
    }
}
return z;
}
double _Complex poly(double _Complex a, double _Complex b, double _Complex c, double _Complex d, double _Complex e, int m)
{
double _Complex alpha,beta,gamma,P,Q,R,U,y,W,s,n,C,D,x[5],h;
int dim,i,j;
double c3;

if (a!=0)
	{
    dim=4;
    alpha=-3*b*b/8/a/a+c/a;
    beta=b*b*b/8/a/a/a-b*c/2/a/a+d/a;
    gamma=-3*b*b*b*b/256/a/a/a/a+c*b*b/16/a/a/a-b*d/4/a/a+e/a;
 
    if (beta==0)
		{
        x[1]=-b/4/a + csqrt(-alpha/2+csqrt(alpha*alpha-4*gamma)/2);
        x[2]=-b/4/a + csqrt(-alpha/2-csqrt(alpha*alpha-4*gamma)/2);
        x[3]=-b/4/a - csqrt(-alpha/2+csqrt(alpha*alpha-4*gamma)/2);
        x[4]=-b/4/a - csqrt(-alpha/2-csqrt(alpha*alpha-4*gamma)/2);
		}
    else
		{
        P=-alpha*alpha/12-gamma;
        Q=-alpha*alpha*alpha/108+alpha*gamma/3-beta*beta/8;
        R=-Q/2+csqrt(Q*Q/4+P*P*P/27);  //either sign of the csqrt
 
        U=cpow(R,1.0/3);  //any cube root
 
        if (U==0)
            y=-5.0/6*alpha+U-cpow(Q,1.0/3);
        else
            y=-5.0/6*alpha+U-P/3/U;

        W=csqrt(alpha+2*y);
 
        x[1]=-b/4/a + (W/2 + csqrt(-(3*alpha+2*y + 2*beta/W))/2);
        x[2]=-b/4/a - (W/2 + csqrt(-(3*alpha+2*y - 2*beta/W))/2);
        x[3]=-b/4/a + (W/2 - csqrt(-(3*alpha+2*y + 2*beta/W))/2);
        x[4]=-b/4/a - (W/2 - csqrt(-(3*alpha+2*y - 2*beta/W))/2);
		}
	 }
else
	{
    a=b;
    b=c;
    c=d;
    d=e;
    if (a!=0)
		{
        dim=3;
        s=b*b-3*a*c;
        n=2*b*b*b-9*a*b*c+27*a*a*d;
	    Q=csqrt((n*n-4*s*s*s));
	    C=cpow((Q+n)/2,1.0/3);
 
        if ((s==0)&&(Q!=0)&&(C==0))
			{
            Q=-Q;
	        C=cpow((Q+n)/2,1.0/3);
		    }
	    c3=pow(3,1.0/2);
        x[1]=-b/3/a-C/3/a-s/3/a/C;
        x[2]=-b/3/a+C/6/a*(1+I*c3)+s/6/a/C*(1-I*c3);
        x[3]=-b/3/a+C/6/a*(1-I*c3)+s/6/a/C*(1+I*c3);
		}
    else
		{
        a=b;
        b=c;
        c=d;
        if (a!=0)
			{
            dim=2;
            D=csqrt(b*b-4*a*c);
            x[1]=(-b+D)/2/a;
            x[2]=(-b-D)/2/a;
			}
        else
			{
            a=b;
            b=c;
            dim=1;
            x[1]=-b/a;
			}
		}
	}
  /* for (i=1;i<=dim;i++)
        for (j=i+1;j<=dim;j++)
            if (creal(x[i])>creal(x[j]))
            {
                h=x[i];
                x[i]=x[j];
                x[j]=h;
            }
    for (i=1;i<=dim;i++)
        for (j=i+1;j<=dim;j++)
            if (creal(x[i])==creal(x[j]))
                if (cimag(x[i])>cimag(x[j]))
                {
                    h=x[i];
                    x[i]=x[j];
                    x[j]=h;
                }*/
    for (i=1;i<=dim;i++)
        for (j=i+1;j<=dim;j++)
            if (cabs(x[i])>cabs(x[j]))
            {
                h=x[i];
                x[i]=x[j];
                x[j]=h;
            }
    for (i=1;i<=dim;i++)
        for (j=i+1;j<=dim;j++)
            if (cabs(x[i])==cabs(x[j]))
                if (carg(x[i])>carg(x[j]))
                {
                    h=x[i];
                    x[i]=x[j];
                    x[j]=h;
                }
return x[m];
}
	
int mandelLine(double _Complex k,double _Complex crit[10],double _Complex coeffs[6], int prms[6],int dz, int thisfni, int esconly, int mycol, int orbt, double myepsilon, int mandel, double originX, double originY, double escape_radius, double x,double y,int dzz, double step,int maxdwell,int w,double * buf)
{
//const double sfac = 0.02;
	register double Zr, Zi;
	register int dwell;
	register double _Complex z, c;
	int i, i3, j, m,total, myloop, pflag, myflag, pd, dwells[10],orbf, pds[10],stdw;
	double rt=0;
	double _Complex zcrit, zh, h, h2, hh, zo[10],rt1,rt2,orbit[16384+1],c2,c3,h1,cofs[6];
	double psx,psy,ang,x2,y2;
	total = 0;
	//escape_radius=1e2;
	double tiny=0.001;
	double stlk=0.006;
	//printf("%d\n",dz);
	int myloopmax=18;
	//const double pi2 = 2*3.1415926535;
	//int myzti,thisfn;
	const int dwstk=0;
    int jj;
    double _Complex a,d,d2,d3;
    double _Complex ca[20],v1,v2,v3,v4,v5,ca32,ca33;
    double p213;

    mystep=step;
    thisfn=thisfni;
	if (((mycol==1)||(mycol==3)||(mycol==5))&&(orbt==1))
	{
		myloopmax=35;
		orbt=0;
	}
  escape_radius=pow(10,escape_radius);
  tiny=pow(10,myepsilon)*step; //0.001;
    
    //********** Function ********************

    if (mandel == 2)
	{
		if ((thisfn==22)||(thisfn==28)||(thisfn==31))
			{
			c=1;
			for (j=0;j<=5;j++)
				cofs[j]=cpow(c,prms[j])*coeffs[j];
			if (prms[6]!=0)
					cofs[5]=cofs[5]+cpow(c,prms[6]);
			}
			

    for ( i = 0; i < w; x += step, i++ ) 
		{
		i3=3*i;
		z=x+y*_Complex_I;
		c=1;
		if ((thisfn==1)||((thisfn>=3)&&(thisfn<=5))||(thisfn==7)||(thisfn==10)||((thisfn==16)&&((creal(k)!=1)&&(creal(k)!=3)&&(creal(k)!=5)&&(creal(k)!=16)&&(creal(k)!=17)&&((creal(k)<7)||((creal(k)>13))&&(creal(k)<15))))||((thisfn==17)&&(creal(k)!=1)&&(k!=5)&&(creal(k)!=6)&&(creal(k)!=7)&&(creal(k)!=8)&&(creal(k)!=11)&&(creal(k)!=12))||((thisfn==17)&&(cimag(k)!=1)&&((creal(k)==7)||(creal(k)==8)))||((thisfn==17)&&(creal(k)==11)&&(cimag(k)!=2))||((thisfn>=21)&&(thisfn<=22)||(thisfn==18))||(thisfn==29)||(thisfn==30)||(thisfn==15))
            c=0;
        if (thisfn==24)
            c=4;
        if ((thisfn==17)&&((creal(k)>=16)&&(creal(k)<=28)))
            c=2;
        if (dzz)
        {
            h=mystep*myfrac*(1+1*_Complex_I);
            z=(myfn(z+h,c,k,coeffs)-myfn(z,c,k,coeffs))/h;
        }
        else
            z=myfn(z,c,k,coeffs);
            
		if ((mycol==0)||(mycol==2)||(mycol==4))
			{
			buf[i3]=-1;
			buf[i3+1]=cabs(z);
			buf[i3+2]=carg(z);			
			}
		else
			{
			buf[i3]=creal(z);
			buf[i3+1]=cimag(z);
			buf[i3+2]=carg(z);
			}
		}
	}
	
	//******  MANDELBROT  **************************************

    else if (mandel == 1) {
   for ( i = 0; i < w; x += step, i++ ) {
	ang=0;
	orbf=0;
	psx=stlk;
	psy=stlk;
	c=x+y*_Complex_I;
       if (thisfn==3)
           if ((mycol==3)||(mycol>=6))
               if (orbt)
               {
                   if (creal(k)<100)
                       c=cpow(c,1.0/(creal(k)-1));
                   else
                       if(cimag(k-100)==0)
                           c=cpow(c,1.0/(creal(k-100)+1));
                       else
                           c=cpow(c,1.0/2);
                   //printf("*");
               }
       if (thisfn==4)
           if ((mycol==3)||(mycol>=6))
               if (orbt)
                   
                   if (creal(k)==1)
                       c=cpow(c,1.0/2);
                   else
                       c=cpow(c,1.0/(creal(k)));
    Zr=originX;
	Zi=originY;
	if (dzz) crit[1]=1;
       
   // ************ Loop over criticals **************************
       
	for (m=1; m<=(int)creal(crit[1]); m++)
	{	
		if (m==1)
			{	
				Zr=originX;
				Zi=originY;
			}
		else
			{
				Zr=creal(crit[m]);
				Zi=cimag(crit[m]);
			}
        
        if (thisfn==4)
			{
			if ((int)creal(k)==1)
				zcrit=-(c-cimag(k))/2;
			else if ((int)creal(k)==2)
				if (m==1)
					zcrit=(-c+csqrt(c*c+3*cimag(k)))/3;
				else
					zcrit=(-c-csqrt(c*c+3*cimag(k)))/3;
			else if ((int)creal(k)==3)
				{
				zcrit=poly(0, 4, 3*c, 0, -cimag(k), m);
                //zcrit=poly(0, 4, 3*cimag(k), 0, -c, m);
				}
			else
					{
					zcrit=poly(5, 4*c, 0, 0, -cimag(k), m);
                    //zcrit=poly(5, 4*cimag(k), 0, 0, -c, m);
					}
			Zr=creal(zcrit);
			Zi=cimag(zcrit);
			}			
		if (thisfn==5)
			if (m==1)
			{
				c=-c;
				Zr=creal(c);
				Zi=cimag(c);
			}
		if (thisfn==6)
			{
			zcrit=cpow((1.0-c)/k, 1.0/(k-1))*cexp(2*pi*(m-1)*I/(k-1));
			//zcrit=poly(5,0,0,0,c-1,m);
			//zcrit=-csqrt((1-c)/3);
			Zr=creal(zcrit);
			Zi=cimag(zcrit);
			}
        if ((thisfn==7)&&(cimag(k)==-1))
            {
            zcrit=poly(1, 0, (c-1)/2, c/2, (c-1)*(c-1)/6, m);
            Zr=creal(zcrit);
            Zi=cimag(zcrit);

            }
        if ((thisfn==16)&&(creal(k)==15))
        {
            zcrit=c;
            //zcrit=-cimag(k);
            Zr=creal(zcrit);
            Zi=-cimag(zcrit);
            
        }
        if (thisfn==17)
        {
            if (creal(k)==11)
            {
                if (cimag(k)==0)
                    zcrit=2;
                if (cimag(k)==1)
                    zcrit=0;
                if (cimag(k)==2)
                    zcrit=-1;
                    //zcrit=c;
                if (cimag(k)==2.5)
                    zcrit=0;
                if (cimag(k)==3)
                    //zcrit=2*c/(c+1);
                    zcrit=c;
                if (cimag(k)==3.5)
                    zcrit=0;
                if (cimag(k)==4)
                     //zcrit=2*c*(3*c-2)/(-c*c+6*c-4);
                     zcrit=8*(-c)*(1-2*(-c))/(-44*(-c)*(-c)+16*(-c)-1);
                    //zcrit=2*c*(2*c-1)/(c*c+c-1);
                if ((cimag(k)==4.5)||(cimag(k)==4.75))
                     zcrit=0;
                     //zcrit=2*c*(2*c-1)/(c*c+c-1);
               // if (cimag(k)==5)
               //         zcrit=cpow(c,1.0/4);;
                Zr=creal(zcrit);
                Zi=cimag(zcrit);
            }
            if (creal(k)==12)
            {
                zcrit=-cexp(2*pi*I*c)/2;
                Zr=creal(zcrit);
                Zi=cimag(zcrit);
            }
            if (creal(k)==13)
            {
                if (m==1) zcrit=csqrt(c);
                else zcrit=-csqrt(c);
                Zr=creal(zcrit);
                Zi=cimag(zcrit);
                
            }
            if (creal(k)==14)
            {
                zcrit=c;
                Zr=creal(zcrit);
                Zi=cimag(zcrit);
            }
            if (creal(k)==15)
            {
                if (m==1)
                zcrit=(-c+csqrt(c*c-3*cexp(2*pi*I*(cimag(k)))))/3;
                else zcrit=(-c-csqrt(c*c-3*cexp(2*pi*I*(cimag(k)))))/3;
                Zr=creal(zcrit);
                Zi=cimag(zcrit);
            }
            if (creal(k)==16)
            {
                zcrit=2*(c*c*c*c-c+1)/3/(c*c*c-c+1);
                Zr=creal(zcrit);
                Zi=cimag(zcrit);
            }
            if (creal(k)==17)
            {
                zcrit=2*(c*c*c-1)/3/(c*c-1);
                Zr=creal(zcrit);
                Zi=cimag(zcrit);
            }
            if (creal(k)==18)
            {
                zcrit=2*c/3;
                Zr=creal(zcrit);
                Zi=cimag(zcrit);
            }
            if (creal(k)==19)
            {
                c2=c*c;
                h=csqrt(c2*c2 + 4*c*c2 - 2*c2 + 1);
                if ((cimag(k)==2)||(cimag(k)==0))
                     h=-h;
                x2=creal(c);
                if((x2>0.460817575454712)||(x2<-3.31260347366333))
                    if(fabs(cimag(c))<fabs(pow(x2*(x2 + 1)*(x2*x2 + 3*x2 - 1),1.0/2)/(x2 + 1)))
                        h=-h;
                if((x2<=0.460817575454712)&&(x2>0.316429))
                    if(fabs(cimag(c))<fabs(sqrt(0.187633-9*(x-0.460817575454712)*(x-0.460817575454712))))
                        h=-h;
                if((cimag(k)==3)||(cimag(k)==2))
                    //zcrit=(3*c*h - 3*c + 4*c*c - 5*c*c*c*c + 5*c*c*c*c*c - h - 3*c*c*h + c*c*c*h + 1)/(3*c*c*(2*c*c - 2*c + 1));
                    zcrit=(3*c*h - 3*c + 4*c2 - 5*c2*c2 + 5*c2*c2*c - h - 3*c2*h + c2*c*h + 1)/(3*c2*(2*c2 - 2*c + 1));
                
                if((cimag(k)==0)||(cimag(k)==1))
                {
                   // zcrit= (4*c*c - 3*c*h - 3*c - 5*c*c*c*c + 5*c*c*c*c*c + h + 3*c*c*h - c*c*c*h + 1)/(3*c*c*(2*c*c - 2*c + 1));
                    zcrit= (4*c2 - 3*c*h - 3*c - 5*c2*c2 + 5*c2*c2*c + h + 3*c2*h - c2*c*h + 1)/(3*c2*(2*c2 - 2*c + 1));

                }
                if(cimag(k)==4)
                    zcrit=(2*c*c + 2*c + 2)/(3*(c + 1));
                if(cimag(k)==5)
                    zcrit=2.0/3;
                Zr=creal(zcrit);
                Zi=cimag(zcrit);
            }
            if (creal(k)==20)
            {
                ca[1]=c;
                for (jj=2;jj<20;jj++)
                    ca[jj]=ca[jj-1]*c;
                p213=pow(2,1.0/3);
                ca32=(-1+c-2*ca[3])*(-1+c-2*ca[3]);
                ca33=(-1+c-2*ca[3])*ca32;
                
                v1=cpow(2-6*c+6*ca[2]+25*ca[3]-75*ca[4]-3*ca[5]+231*ca[6]-288*ca[7]+114*ca[8]+30*ca[9]-36*ca[10]+2*ca[12]+csqrt(108*ca[3]-648*ca[4]+1188*ca[5]+1161*ca[6]-8910*ca[7]+13419*ca[8]+6264*ca[9]-47817*ca[10]+52002*ca[11]+30861*ca[12]-134352*ca[13]+138024*ca[14]-50544*ca[15]-10044*ca[16]+9828*ca[17]-108*ca[18]-432*ca[19]),1.0/3);
                
                v2=csqrt(ca32/(4*ca[4])-(2*(1-c+ca[4]))/(3*ca[2])+(p213*(1-2*c+ca[2]+2*ca[4]+10*ca[5]-12*ca[6]+ca[8]))/(3*ca[2]*v1)+(1/(3*p213*ca[2]))*(v1));
                
                
                v5=(-1+c-2*ca[3])/(4*ca[2]);
                if(dzz==0)
                    jj=m-1;
                else
                    jj=(int)cimag(k);
                switch (jj)
                {
                    case 0:
                    case 1:
                    {
                        v3=csqrt(ca32/(2*ca[4])-(4*(1-c+ca[4]))/(3*ca[2])-(p213*(1-2*c+ca[2]+2*ca[4]+10*ca[5]-12*ca[6]+ca[8]))/(3*ca[2]*v1)-(1/(3*p213*ca[2]))*(v1)-(-(ca33/ca[6])+(4*(-1+c-2*ca[3])*(1-c+ca[4]))/ca[4])/(4*v2));
                        break;
                    }
                    case 2:
                    case 3:
                    {
                        v4=csqrt(ca32/(2*ca[4])-(4*(1-c+ca[4]))/(3*ca[2])-(p213*(1-2*c+ca[2]+2*ca[4]+10*ca[5]-12*ca[6]+ca[8]))/(3*ca[2]*v1)-(1/(3*p213*ca[2]))*(v1)+(-(ca33/ca[6])+(4*(-1+c-2*ca[3])*(1-c+ca[4]))/ca[4])/(4*v2));
                        break;
                    }
                }
                switch (jj)
                {
                    case 0:
                    {
                        d=-v5-1.0/2*v2-1.0/2*v3;
                    break;
                    }
                    case 1:
                    {
                        d=-v5-1.0/2*v2+1.0/2*v3;
                        break;
                    }
                    case 2:
                    {
                        d=-v5+1.0/2*v2-1.0/2*v4;
                        break;
                    }
                    case 3:
                    {
                        d=-v5+1.0/2*v2+1.0/2*v4;
                        break;
                    }
                }
                d2=d*d;
                d3=d*d2;
                zcrit=(-2+6*c-6*ca[2]+2*ca[4]+2*ca[5]-2*ca[6]-2*ca[7]-2*ca[2]*d+6*ca[3]*d-6*ca[4]*d+2*ca[5]*d+2*ca[5]*d2-2*ca[6]*d2-2*ca[4]*d3+2*ca[5]*d3)/(-3+9*c-9*ca[2]-3*ca[3]+12*ca[4]-6*ca[5]-3*ca[6]);
                Zr=creal(zcrit);
                Zi=cimag(zcrit);
            }
            if (creal(k)==21)
            {
                if (cimag(k)==0)
                    zcrit=(4*c*c*c - 3*csqrt(-(4*(2*c - 1)*(2*c + 1))/9) - 2*c + 3*c*csqrt(-(4*(2*c - 1)*(2*c + 1))/9) + 2)/(6*c*c);
                else
                    zcrit= (3*csqrt(-(4*(2*c - 1)*(2*c + 1))/9) - 2*c + 4*c*c*c - 3*c*csqrt(-(4*(2*c - 1)*(2*c + 1))/9) + 2)/(6*c*c);
                Zr=creal(zcrit);
                Zi=cimag(zcrit);
            }
        }
        if ((thisfn==22)||(thisfn==28)||(thisfn==31))
			{
			
			for (j=0;j<=5;j++)
				{
				cofs[j]=cpow(c,prms[j])*coeffs[j];
				}
			if (prms[6]!=0)
				cofs[5]=cofs[5]+cpow(c,prms[6]);
            }
	    if (thisfn==22)
            {
			zcrit=poly(5*cofs[0],4*cofs[1],3*cofs[2],2*cofs[3],cofs[4],m);
			Zr=creal(zcrit);
			Zi=cimag(zcrit);
			}
		if (thisfn==24)
			{
			zh=3+c*c;
			if (m==1)
				zcrit=(zh+csqrt(zh*zh-16*c*c))/4/c;
			else
				zcrit=(zh-csqrt(zh*zh-16*c*c))/4/c;
			Zr=creal(zcrit);
			Zi=cimag(zcrit);
			}
		if (thisfn==26)
		{
			if (((int)cimag(k)!=0)&&((int)creal(k)!=0))
				zcrit=cpow((c*cimag(k))/creal(k), 1.0/(creal(k)+cimag(k)))*cexp(2*pi*(m-1)*I/(creal(k)+cimag(k)));
			else 
				if ((int)cimag(k)==0) 
					zcrit=0;
				if ((int)creal(k)==0) 
					zcrit=10e120;
			Zr=creal(zcrit);
			Zi=cimag(zcrit);
		}
        if (thisfn==30)
        {
            if(m==1)
                zcrit=(-c+csqrt(c*c-3*creal(k)*cexp(2*pi*I*(cimag(k)))))/3;
            else
                zcrit=(-c-csqrt(c*c-3*creal(k)*cexp(2*pi*I*(cimag(k)))))/3;
            Zr=creal(zcrit);
            Zi=cimag(zcrit);
         
        }
       /* if (thisfn==31)
        {
            if(m==2)
                zcrit=0;
            else
                zcrit=cofs[0]/cofs[1];
            Zr=creal(zcrit);
            Zi=cimag(zcrit);
            
        }*/
        i3=3*i;
		myflag=0;
		pd=0; // set period to 0 (no period)
        rt=0;
        
        //********* Iteration loop **************************
	
        for (dwell = 0; dwell < maxdwell; dwell++) {
		z=Zr+Zi*_Complex_I;
		h2=z;
        if ((thisfn==17)&&(creal(k)==20)&&(dzz==0))
            z=myfn(z,c,creal(k)+(m-1)*I,cofs);
        else
            z=myfn(z,c,k,cofs);
		orbit[dwell]=z;
		Zr=creal(z);
		Zi=cimag(z);
		if (((thisfn==9)||(thisfn==10))&&(k==0.5))
			zh=csqrt(z);
		else
			zh=z;
		if (dz==0)
			escbd=cabs(zh);
		else if (dz==1)
            escbd=fabs(creal(zh));
             else if (dz==2)
			escbd=fabs(cimag(zh));
        else if (dz==3)
            escbd=creal(zh);
        else if (dz==4)
            escbd=cimag(zh);
        if ((escbd > escape_radius)||(fpclassify(creal(z))== FP_NAN)) break;// point escapes to infinity
		if ((thisfn==23)||(thisfn==24)||((thisfn==2)&&(cimag(k)<=0))||((thisfn==16)&&(creal(k)>=11)))
				if (escbd<tiny) break;
		//if (thisfn==7)
		//	if (cabs(cpow(z,k-1)-1+c)<tiny) break;
		if ((dwell>maxdwell-50)&&((mycol==5)||(mycol==1))&&(!esconly))
		{
			hh=cabs(z-h2)*(z-h2);
			ang=ang+hh;
		}
			
		if ((orbt)&&(dwell>dwstk)&&((fabs(Zr)<stlk)||(fabs(Zi)<stlk))) 
				{
				orbf=1;
				if (fabs(Zr)<psx) 
					{
					psx=fabs(Zr);
					stdw=dwell;
					}
				if (fabs(Zi)<psy) 
					{
					psy=fabs(Zi);
					stdw=dwell;	
					}
				}
		if (!esconly) 
				{
				myloop=myloopmax; // periodicity loop
				if (dwell-1<myloop)
					myloop=dwell-1;
				for (j=dwell-1; j>=dwell-myloop; j--)
				  {
					  if (cabs(z-orbit[j])<tiny) // we found a period!
					   {
					   myflag=1;
					   pd=dwell-j;
					   if (thisfn==7)
							{
								rt=1+creal(k)*(carg(z)+pi)/pi/2;
                            }
                        else
                                rt=1+pd*(carg(z)+pi)/pi/2;
					   break; // break out of period test
					   }
					}
				if (myflag==1)
				   break; // break out of dwell loop		   
				}
			} 
			dwells[m]=dwell;
			pds[m]=pd;
			zo[m]=z;
			}
			
			pd=pds[1];
			z=zo[1];
			dwell=dwells[1];
			j=0;
			if (dwell==maxdwell) 
				{
				dwell=0;
				j=j+1;
				}			
			for (m=2; m<=(int)creal(crit[1]); m++)
			{
			if (pds[m]>pds[1])
				pd=pds[m];
			if (cabs(zo[m])>cabs(zo[1]))
				z=zo[m];
			if (dwells[m]==maxdwell)
				{
				dwells[m]=0;
				j=j+1;
				}
            dwell=dwell+dwells[m];
			}
       
       //********* Analyse result ************************
       
			if (j>0)
              if ((thisfn==17)&&(creal(k)==15)&&(mycol==1))
                  dwell=dwell-1;
              else
				  dwell=dwell+32*((int)creal(crit[1])-j)-1;
			buf[i3] = dwell;
			if ((orbt)&&(orbf))
				buf[i3] = dwell+15-7*log(psx)-3*log(psy);
            if ((pd>0)||((thisfn==17)&&(creal(k)==23))||(thisfn==28))
               {
				buf[i3] = -(dwell+2);
				buf[i3+1]=pd;
				buf[i3+2]=rt;
				}
            else
                {
                    buf[i3+1]=0;
                    buf[i3+2]=0;
                }
                if (((mycol==5)||(mycol==1))&&(buf[i3]==-1))
			   {
                   buf[i3+2]=fabs(ang);
			   }
	    if ((mycol==3)||(mycol>=6))
			/*if ((thisfn==1)&&((escbd > escape_radius)||(fpclassify(creal(z))== FP_NAN)))
				buf[i3]=8*log(escbd)/pow(k,dwell);  //potential method mycol 3
		else*/
				buf[i3] = dwell;
			total += dwell;
			}
		}

    //******JULIA*******************************************

    else if (mandel== 0)
	{
    myloopmax=35;
	c=originX+originY*_Complex_I;
    if (thisfn==3)
        if ((mycol==3)||(mycol>=6))
            if (orbt)
            {
                if (creal(k)<100)
                    c=cpow(c,1.0/(creal(k)-1));
                else
                    if(cimag(k-100)==0)
                        c=cpow(c,1.0/(creal(k-100)+1));
                    else
                        c=cpow(c,1.0/2);
                //printf("*");
            }
    if (thisfn==4)
        if ((mycol==3)||(mycol>=6))
            if (orbt)
                if (creal(k)==1)
                    c=cpow(c,1.0/2);
                else
                    c=cpow(c,1.0/(creal(k)));
    if ((thisfn==22)||(thisfn==28)||(thisfn==31))
        {
        for (j=0;j<=5;j++)
            cofs[j]=cpow(c,prms[j])*coeffs[j];
        if (prms[6]!=0)
            cofs[5]=cofs[5]+cpow(c,prms[6]);	
			}
	for ( i = 0; i < w; x += step, i++ )
		{
		orbf=0;
		psx=stlk;
		psy=stlk;
		i3=3*i;
		myflag=0;
		pd=0; // set period to 0 (no period)
        rt=0;
		Zr = x; Zi = y;
		ang=0;
            
            //******* Enter iteration loop ************************
            
		for (dwell = 1; dwell < maxdwell; dwell++) // dwell (iteration) loop
			{
			z=Zr+Zi*_Complex_I;
			h2=z;
			z=myfn(z,c,k,cofs);
			orbit[dwell]=z;
			Zr=creal(z);
			Zi=cimag(z);
			if (((thisfn==9)||(thisfn==10))&&(k==0.5))
				zh=csqrt(z);
			else
				zh=z;
			if (dz==0)
				escbd=cabs(zh);
			else if (dz==1)
				escbd=fabs(creal(zh));
            else if (dz==2)
                    escbd=fabs(cimag(zh));
            else if (dz==3)
                    escbd=creal(zh);
            else if (dz==4)
                escbd=cimag(zh);
             if ((escbd > escape_radius)||(fpclassify(creal(z))== FP_NAN)) // point escapes to infinity
            // if ((!dzz)&&((escbd > escape_radius)||(fpclassify(creal(z))== FP_NAN))) // point escapes to infinity
				break;
			if ((thisfn==23)||(thisfn==24)||((thisfn==2)&&(cimag(k)<=0))||((thisfn==16)&&(creal(k)>=11)))
				if (escbd<tiny) break;
			if ((dwell>maxdwell-50)&&((mycol==5)||(mycol==1))&&(!esconly))
				{
					hh=cabs(z-h2)*(z-h2);
					ang=ang+hh;
				}
			if ((orbt)&&(dwell>dwstk)&&((fabs(Zr)<stlk)||(fabs(Zi)<stlk))) 
				{
				orbf=1;
				if (fabs(Zr)<psx) 
					{
					psx=fabs(Zr);
					stdw=dwell;
					}
				if (fabs(Zi)<psy) 
					{
					psy=fabs(Zi);
					stdw=dwell;	
					}
				}
			if (!esconly) {
				myloop=myloopmax; // periodicity loop
				if (dwell-1<myloop)
					myloop=dwell-1;
				for (j=dwell-1; j>=dwell-myloop; j--)
				  {
				   if (cabs(z-orbit[j])<tiny) // we found a period!
                   //if ((cabs(z-orbit[j])<tiny)||(cabs(1.0/z-1.0/orbit[j])<tiny)) // we found a period!
                       {
					   myflag=1;
					   pd=dwell-j;
                       zh=0;
                       for (jj=j;jj<=dwell;jj++)
                           zh=zh+orbit[jj]/pd;
					   if (thisfn==7)
							{
								rt=1+creal(k)*(carg(z)+pi)/pi/2;
							}
                           else
                               // rt=1+pd*(carg(orbit[dwell-dwell%pd]-zh)+pi)/pi/2;
                                rt=1+pd*(carg(orbit[dwell-dwell%pd]-zh)+pi)/pi/2;
                                //rt=1+pd*(carg(orbit[dwell-dwell%pd]-zh))/pi/2;
                           break; // break out of period test
					   }
                 /*     if (cabs(1.0/z-1.0/orbit[j])<tiny) // we found an external period!
                          //if ((cabs(z-orbit[j])<tiny)||(cabs(1.0/z-1.0/orbit[j])<tiny)) // we found a period!
                      {
                          myflag=1;
                          pd=dwell-j;
                          zh=0;
                          for (jj=j;jj<=dwell;jj++)
                              zh=zh+(1.0/orbit[jj])/pd;
                          zh=1.0/zh;
                          if (thisfn==7)
                          {
                              rt=1+creal(k)*(carg(1.0/z)+pi)/pi/2;
                          }
                          else
                              // rt=1+pd*(carg(orbit[dwell-dwell%pd]-zh)+pi)/pi/2;
                              rt=1+pd*(carg((1.0/orbit[dwell-dwell%pd])-1.0/zh)+pi)/pi/2;
                          break; // break out of period test
                      }*/
                  }
				if (myflag==1)
				   break; // break out of dwell loop		   
				}
		}
            
        //*********** Analyse result **************************
            
		if((mycol==0)||(mycol>=2))
			{
			if (dwell == maxdwell)
				buf[i3] = -1;
			else if ((orbt)&&(orbf)&&(mycol!=3))
				buf[i3] = stdw+15-2*log(psx)-3*log(psy);
			else
				{
				buf[i3] = dwell;
				if ((mycol==2)&&(pd))
					{
					buf[i3+2]=rt;
					buf[i3]=-dwell;
					}
                }
				if ((mycol==3)||(mycol>=6))
					/*if ((thisfn==1)&&(escbd > escape_radius)||(fpclassify(creal(z))== FP_NAN))
							{
							buf[i3]=5*log(cabs(z))/pow(creal(k),dwell);  //potential method mycol 3
							}
					else*/
                    {
                        if (dwell == maxdwell)
                            buf[i3] = -1;
                        else
                            buf[i3]=dwell;
						buf[i3+2]=rt;
                        buf[i3+1]=pd;
					}

				//}
			}
		else //mycol==1
		if (dwell == maxdwell)
				buf[i3] = -1;
		else
		{
			for (j=0; j<=2; j++)
				buf[i3+j]=dwell;
			if ((pd>0)||((thisfn==17)&&(creal(k)==23))||(thisfn==28))
			{
				buf[i3] = -(dwell+2);
				buf[i3+1]=pd;
				buf[i3+2]=rt;
			}
            else
            {
                buf[i3+1]=0;
                buf[i3+2]=0;
            }
            
		}
		if (((mycol==5)||(mycol==1))&&(buf[i3]==-1))
				buf[i3+2]=cabs(ang);
			
			//buf[i3]=dwell;
		total += dwell;
	} }
	return total;
}
