function cruncher(sm,bg,nums,nums2,myfl)
%forms an iterations/period chart for a range of Collatz values
%or a scatterplot of the hailstone diagram of the Collatz
%the function is either iterating n/sm (if mod(n,sm)=0) or bg*n+ad (ad the min factor to make a multiple of sm)
%usually sm=2 bg=3 ad=1 to give n/2 and 3n+1  
%nums and nums2 give start and finish integers
%blue chart shows orbit length to get to first repeat
%green chart shows period length
%if myfl=1 instead does scatter plot of maxima
% examples cruncher(2,3,-20,30,0) cruncher(2,3,-20,3000,1)
newplot
huge=100000000000;
%huge2=10000;
myv=zeros(2,nums2-nums);
%loopv=zeros(1,huge2);
for i=nums:nums2
    iter=i;
    loop=1;
    loopf=0;
    loopv(loop)=iter;
    while loopf==0
        loop=loop+1;
        loopj=0;
        if mod(iter,sm)~=0
            iter=bg*iter+sm-mod(bg*iter,sm);
            if abs(iter)>huge
                loopf=1;
                loopj=1;
            end
        else
            iter=iter/sm;
        end
        loopv(loop)=iter;
        j=1;
        while loopj==0
            if iter~=loopv(j); 
                j=j+1;
            else
                loopf=1;
                loopj=1;
            end
            if j==loop
                loopj=1;
            end
         end
       %iter
    end
    myv(1,i-nums+1)=loop;
%     if (loop-j~=2)&&(loop-j~=18)&&(loop-j~=5)
%         fprintf('%d %d\n',i,loop-j);
%     end
    if iter>huge
        myv(2,i-nums+1)=0;
    else
        myv(2,i-nums+1)=loop-j; 
    end
end
mym=myv';
mym=mym(:,1);
if myfl
    
    scatter(linspace(nums,nums2,length(mym)),mym,1);
else
    s=size(myv);
    plot(linspace(nums,nums2,length(mym)),myv');
end
%myst='';
% for i=1:nums2-nums
%     myst=strcat(myst,'*',num2str(myv(2,nums2-nums-i+1)));
% end
% fprintf('%s\n',myst);
% pds=zeros(1,3);
% for i=1:nums2-nums
%     if myv(2,nums2-nums-i+1)==2
%         pds(1)=pds(1)+1;
%     end
%     if myv(2,nums2-nums-i+1)==5
%         pds(2)=pds(2)+1;
%     end
%     if myv(2,nums2-nums-i+1)==18
%         pds(3)=pds(3)+1;
%     end
%     
% end
% fprintf('%d\n',pds);

