function explicitduality(start,finish,its,xres,sav,prtits)
%e.g. explicitduality(1,50,500,600,0,0);
%plots sum(x^r) over zeta zeros r giving peaks at primes and prime powers
%parameters start = first prime, finish = last prime,
%its = how many zeta zeros to use xres = number of x points in graph
%sav will save the arrays z, x if needed prtits=1 print iterations
%a simplified version of explicitformula%e.g. explicitduality(1,50,500,600,0,0);
zros=textread('zeros1b.txt','%f',its);
if its>length(zros)
    its=length(zros);
end
x=linspace(start,finish,xres);
y=zeros(its,xres);
z=y;
for l=1:its
    for j=1:xres
        p=0.5+zros(l)*i;
         v=x(j)^(p);
        y(l,j)=y(l,j)-v-conj(v); %zeros above and below (conj)
         if l>1
            y(l,j)=y(l,j)+y(l-1,j);
         end
    end
plot(x,y(l,:));
getframe;
if prtits
    fprintf('%d\n',l);
end
end
if sav==1
    save(strcat('primgraphs',num2str(start),'-',num2str(finish)),'z','x');
end