function explicitformula(start,finish,its,xres,sav)
%plots a von-Mangoldt prime distribution based on the zeta zeros
%parameters start = first prime, finish = last prime, 
%its = how many zeta zeros to use xres = number of x points in graph
%sav will save the arrays z, x if needed
zros=textread('zeros1b.txt','%f',its);
if its>length(zros)
    its=length(zros);
end
x=linspace(start,finish,xres);
y=zeros(its,xres);
z=y;
for l=1:its
    for j=1:xres
        p=1/2+zros(l)*i;
        v=x(j)^(p)/p;
        y(l,j)=y(l,j)-v-conj(v);
         if l>1
            y(l,j)=y(l,j)+y(l-1,j);
        end
        z(l,j)=x(j)+y(l,j)-log(2*pi)-log(1-x(j)^(-2))/2;  
    end
plot(x,z(l,:)); 
getframe;
%fprintf('%d\n',l);
end
if sav==1
    save(strcat('primgraphs',num2str(start),'-',num2str(finish)),'z','x');
end