function fint(scale, mymode)
%plots Fourier sin transform of psi prime distribution giving zeta zeros
%if mode=0 saves the additive Mangoldt function psi
%if mode>0 loads psi and plots the graph
%e.g. scale=10^3 or 10^7
if mymode==0
    y=zeros(1,scale);
    for j=2:scale;
        y(j)=y(j-1)+mangoldt(j);
    end
    save('psi','y');
else
    clf;
    X=scale;
    load('psi');
    myspan=80;
    xres=800;
    xx=linspace(1,myspan,xres);
    stpval=10^4;
    F=zeros(1,xres);
    for t=1:xres
        for yy=0:1/stpval:log(X)
            F(t)=F(t)+sin(t*myspan/xres*yy)*(y(floor(exp(yy)))-exp(yy))/exp(yy/2);
        end
    end
    plot(xx,F,'k');
    zros=textread('zeros1b.txt','%f',30);
    hold on
    for j=1:length(zros)
        if zros(j)<myspan           
            line([zros(j) zros(j)], [2000 3000]);
        end
    end
end
