function fintstep(scale,start,finish,its,xres)
%fintstep(10^6,1,50,490,600);
%plots Fourier sin transform of integer step distribution giving minima
%coinciding closely with zeta zeros
%1/log(X) int_0^log(X) sin(ty) (stp(e^y)-e^y)/e^(y/2) dy
%parameters start = first prime, finish = last prime, 
%its = how many zeta zeros to use xres = number of x points in graph
%sav will save the arrays z, x if needed prtits=1 print iterations
    y=zeros(1,scale);
    for j=2:scale;        
        y(j)=y(j-1)+mangoldt(j); %make the additive Mangoldt prime counting function
    end
    clf;
    hold on
    X=scale;
    myspan=800;
    xres=4000;
    xx=linspace(1,myspan,xres);
    stpval=10^4;
    F=zeros(1,xres);
    for t=1:xres
        for yy=0:1/stpval:log(X) 
            F(t)=F(t)+sin(t*myspan/xres*yy)*(y(floor(exp(yy)))-exp(yy))/exp(yy/2);
        end
    end
    F=F/log(X);
    plot(xx(1:xres/10),F(1:xres/10),'g'); %first figure plots Fourier sin transform
    %additive Mangoldt transform in green
    y=zeros(1,scale);
    for j=2:scale;
        y(j)=y(j-1)+1;        
    end
    F=zeros(1,xres);
    for t=1:xres
        for yy=0:1/stpval:log(X)
            F(t)=F(t)+sin(t*myspan/xres*yy)*(y(floor(exp(yy)))-exp(yy))/exp(yy/2);
        end
    end
    F=F/log(X);
    plot(xx(1:xres/10),F(1:xres/10),'k'); %integer step function transform in black
    zros=textread('zeros1b.txt','%f',30);
  
    for j=1:100 %also plot in blue vertical lines at the actual zeta zeros
        if zros(j)>myspan/10
            break;
        else
            line([zros(j) zros(j)], [-500 500]);
        end
    end
    hold off
x=[]; %making a vector out of the local minima of the Fourier transform
for k=2:length(F)-1;
    if F(k)<=F(k-1)&&F(k)<=F(k+1)
        x=[x xx(k)];
    end
end
xzeros=x(2:length(x)); %xzeros becomes the vecotr of minima
figure;
zros=textread('zeros1b.txt','%f',length(xzeros));
plot(zros(1:length(xzeros))-xzeros(1:length(xzeros))')
figure;
plot(xzeros); %plot step zeros in blue compared with zeta zeros in green
hold on
plot(zros,'g');
hold off
figure;
if its>length(zros)
    its=length(zros);
end
x=linspace(start,finish,xres);
y=zeros(its,xres);
z=y;
for l=1:its
    for j=1:xres
        p=0.5+xzeros(l)*i;
        v=x(j)^(p)/p;
        y(l,j)=y(l,j)-v-conj(v); %zeros above and below (conj)
         if l>1
            y(l,j)=y(l,j)+y(l-1,j);
         end
        z(l,j)=x(j)+y(l,j)-log(2*pi)-log(1-x(j)^(-2))/2;  
    end
plot(x,z(l,:),'k');
%getframe;
end
p=primes(finish);
for j=1:length(p)
        if p(j)<finish           
            line([p(j) p(j)], [-10 80]);
        end
end

function o=mangoldt(n)
%von Mangoldt function
%o=log(p) if n=p^k or 0 otherwise
f=factor(n);
if f(1)==f(length(f))
    o=log(f(1));
else
    o=0;
end
