function myrizLSM0()
%level set method for the Julia set of zeta separately plotting basin of
%attraction of infinity and the fixed attractor a
nx = 640;
ny = 640;
ColorMset = zeros(nx,ny,3);
xmin = -40;
xmax = 40;
ymin = -40;
ymax = 40;
maxiter = 100;
wb = waitbar(0,'Please wait...');
for iy = 1:ny
  cy = ymin + iy*(ymax - ymin)/(ny - 1);
  for ix= 1:nx
    cx = xmin + ix*(xmax - xmin)/(nx - 1);
    k = Mlevel(cx,cy,maxiter);
    if k == 0 
        ColorMset(iy,ix,:) = 0;
    else    
        ColorMset(iy,ix,1) = abs(sin(2*k/10));
        ColorMset(iy,ix,2) = abs(sin(2*k/10+pi/4));
        ColorMset(iy,ix,3) = abs(cos(2*k/10));
    end
  end
  waitbar(iy/ny,wb)
end
close(wb);
image(ColorMset);
imwrite(ColorMset,'mand.jpg','jpg','Quality',100);

function [potential] = Mlevel(cx,cy,maxiter)
z = complex(cx,cy);
a=-0.2959050055752;
iter = 0;
huge=1000;
%while (iter < maxiter)&&(real(z)<huge)&&(abs(z-0.4971)>.01)
while (iter < maxiter)&&(real(z)<huge)&&(abs(z-a)>.01)
%while (iter < maxiter)&&(abs(z)<huge)&&(abs(z)>.01)
   z=myzeta(z);
   %z=mygamma(z);
   %z=mygamma(z/2+1)*(z-1)*pi^(-z/2)*myzeta(z);
   iter = iter+1;
end
if iter < maxiter
    if real(z) >= huge
        potential = iter;
    else
        potential = maxiter-iter;
    end
else
    potential = 0;
end