function pnth(n,mode)
%plots prim number theorem distributions
%mode=0 plots distribution of primes and the asymptotic log estimates
%mode=1 plots the fast Fourier transform of the prime distribution to look 
%for correspondences to the zeta zeros.
clf
p=primes(n);
lth=length(p);
a=zeros(1,p(lth));
b=a;
c=b;
for j=2:p(lth-1)+1
    a(j)=mfun('Ei',1,-log(2))-mfun('Ei',1,-log(j));
    b(j)=j/log(j);
%     for k=1:n
%         if p(k)>j
%             break
%         end
%     end
    c(j)=find(p>j,1)-1;
end
hold on
plot(b(1:length(b)-1),'g');
plot(a(1:length(b)-1),'r');
plot(c(1:length(b)-1));
hold off
if mode>0
    d=c-a;
    save('primat','a','b','c');
    d=d(1:length(d));
    Y=fft(d);
    Y(1)=[];
    n=length(Y);
    power = abs(Y(1:floor(n/2))).^2;
    nyquist = 1/2;
    freq = (1:n/2)/(n/2)*nyquist;
    period=1./freq;
    myl=100;
    clf
    %plot(freq,power)
    plot(period,power);
    axis([0 50 0 20*n]);
end