/*this is for c.*/
/*compared with f.gp the different is power() has no power factors,so it is not depended on x.this time, bian() works out a series of taylor coefficeints and order it together with power coefficeints, then output. Maass() calls bian() in our case.*/
/*from 0.5 to 10, pick a point every 1/16,so there are (10-0.5)*16=152 points, every point need 20 terms. the output:h has 3130 elements.as this:A[1]~A[30],B[1]~B[30],C[1]~C[30],then it is taylor coefficeints,D[1][1]~D[1][20],D[2][1]~D[2][20]...D[152][1]~D[152][20]*/

/*run maass() to get the file(name:result). need reset default(format,"f0.50");&\p 180*/

default(realprecision,150);
default(format,"f0.17")

power(r1,r2,r3)=
{local(my_u,my_v,my_uv,cmy_u,cmy_v,cmy_uv,A,B,C,f,u,v,k,M);
u=r2-r1;
v=r3-r2;
my_u=gamma(I*u/2);     cmy_u=conj(my_u);
my_v=gamma(I*v/2);     cmy_v=conj(my_v);
my_uv=gamma(I*(u+v)/2);cmy_uv=conj(my_uv);
A=vector(20);B=vector(20);C=vector(20);
A[1]=Pi^(-(u+v/2)*I)*my_u*my_uv*exp(Pi*(r3-r1)*0.25);
B[1]=Pi^((u-v)/2*I)*cmy_u*my_v*exp(Pi*(r3-r1)*0.25);
C[1]=Pi^((u/2+v)*I)*cmy_uv*cmy_v*exp(Pi*(r3-r1)*0.25);
f=vector(3);
k=0;

for(k=1,19,

	A[k+1]=-A[k]*Pi^3/(k*(k-I*u/2)*(k-I*(u+v)/2));
	B[k+1]=-B[k]*Pi^3/(k*(k-I*v/2)*(k+I*u/2));

	C[k+1]=-C[k]*Pi^3/(k*(k+I*v/2)*(k+I*(u+v)/2));
);

f[1]=A;f[2]=B;f[3]=C;
f
}


tailor(r1,r2,r3,x,L)=
{local(my_u,my_v,my_uv,cmy_u,cmy_v,cmy_uv,A,B,C,TA,TB,i,TC,f,u,v,k,M);
u=r2-r1;
v=r3-r2;
my_u=gamma(I*u/2);     cmy_u=conj(my_u);
my_v=gamma(I*v/2);     cmy_v=conj(my_v);
my_uv=gamma(I*(u+v)/2);cmy_uv=conj(my_uv);
A=Pi^(-(u+v/2)*I)*my_u*my_uv*x^(I*r1)*exp(Pi*(r3-r1)*0.25);
B=Pi^((u-v)/2*I)*cmy_u*my_v*x^(I*r2)*exp(Pi*(r3-r1)*0.25);
C=Pi^((u/2+v)*I)*cmy_uv*cmy_v*x^(I*r3)*exp(Pi*(r3-r1)*0.25);
f=vector(L);
i=0;
M=1;
until(M<1.0e-30,
   TA=A; TB=B; TC=C; M=0;

   for(j=1,L,
      M=vecmax(abs([M,TA,TB,TC]));

      f[j]=f[j]+TA+TB+TC;
      TB*=(2*i+I*r2-j+1)/(j*x);

      TC*=(2*i+I*r3-j+1)/(j*x);

      TA*=(2*i+I*r1-j+1)/(j*x);

    );
   i++;
   A*=-Pi^3*x^2/i/(i-I*u/2)/(i-I*(u+v)/2);
   B*=-Pi^3*x^2/i/(i+I*u/2)/(i-I*v/2);
   C*=-Pi^3*x^2/i/(i+I*v/2)/(i+I*(u+v)/2);
);
f
}

bian(r1,r2,r3)=
{local(g,f,h,s,i,j,M,x0);
g=power(r1,r2,r3);
M=30;
s=floor(16*(M-0.5));
h=vector(20*3+20*s);
for(j=1,3,
	for (i=1,20,
		h[(j-1)*20+i]=g[j][i];
	);
);
x0=0.5;
for (i=1,s,
	f=tailor(r1,r2,r3,x0,20);
	x0+=1/16;
	for(j=1,20,h[60+(i-1)*20+j]=f[j]);
);

h
}

gen(u,v)=
{local(r1,r2,r3,r,t,h,k,tem1,tem2);
	r1=-(u*2+v)/3;
	r2=(u-v)/3;
	r3=(u+v*2)/3;
	h=bian(r1,r2,r3);
	tem1=floor(u*1000+0.5); tem2=floor(v*1000+0.5);
	/*r=Str(tem1","tem2"realc");
	t=Str(tem1","tem2"imagc");*/
	r="/tmp/realc";
	t="/tmp/imagc";
	for(k=1,#h,write(r,real(h[k]));write(t,imag(h[k])););
h
}

compute_f(u,v,x)=
{local(r1,r2,r3,f,g);
	r1=-(u*2+v)/3;
	r2=(u-v)/3;
	r3=(u+v*2)/3;
	f=tailor(r1,r2,r3,x,20);
	g=f[1];
g
}


lots(u1,u2,v1,v2,s)=
{local(i,m,n,j,u,v,h,k,tem1,tem2);

m=floor((u2-u1)/s+0.1);
n=floor((v2-v1)/s+0.1);
u=u1;
for(i=0,m,
	v=v1;	
	for(j=0,n,
		if(u>=v,h=gen(u,v););
		v+=s;		
	);
	u+=s;
);

}



r=2*13.7797513518907389442436732815177125971551325687934870692523882;
r=2*9.533695361353557;
maass()=
{	local(r1,r2,r3,k,h);
	r1=-r;r2=0;r3=r;
	h=bian(r1,r2,r3);
	for(k=1,#h,write("realc9.5.dat",real(h[k]));write("imagc9.5.dat",imag(h[k])););

}






