//Overlays a computel Mellin bitmap onto a larger RZViewer bitmap.
//To run this file from terminal put it in a folder, cd to the folder and input
//gcc -o rzo overlay.c -lm && ./rzo
//To run successive compiled versions type ./rzmovieo
//See: http://www.dhushara.com/DarkHeart/RZV/RZViewer.htm

#include <stdio.h>
#include<complex.h>
#include<math.h>
#include <stdlib.h> 
const char base[] = "overlayed";

int main(void)
{
FILE *mf,*inf;
char filename [ FILENAME_MAX ];
long k,k2;
long ml, ml2;
float w,h,w2,h2=0;
double hold;
double *myv1, *myv2;
float x, y, pos;
double xoffset=0;// an offset if the computer image was generated off centre
double yoffset=0;

/*Scan file1*/
//inf=fopen("a.txt","r"); //You need to generate the bitmap1 as a.txt using RZViewer with the appropriate parameter files first, and bitmap2 as b.txt by using the computel output120 example

inf=fopen("a.txt","r");
fscanf (inf, "%f", &w);
fscanf (inf, "%f", &h);
//printf("%f %f \n",w,h);
ml=(long)(2*w*h);
myv1 = calloc(ml,sizeof(double));
for (k=0;k<ml;k++)
	{
	fscanf (inf, "%lf", &hold);
	*(myv1+k)=hold;
	}
fclose(inf);

/*Scan file2*/
inf=fopen("b.txt","r"); // this is 19
fscanf (inf, "%f", &w2);
fscanf (inf, "%f", &h2);
//printf("%f %f \n",w2,h2);
ml2=(long)(2*w*h);
myv2 = calloc(ml2,sizeof(double));
for (k=0;k<ml2;k++)
	{
	fscanf (inf, "%lf", &hold);
	*(myv2+k)=hold;
	}
fclose(inf);

for (k=0;k<ml;k+=2)
	{
    	y=(int)(k/w/2)-yoffset;
	x=(k/2)%(int)w-xoffset;
	if ((fabs(x-w/2)<w2/2)&&(fabs(y-h/2)<h2/2))
		{
	        k2=2*(x-(w-w2)/2+w2*(y-(h-h2)/2));
	        *(myv1+k)=*(myv2+k2);
	        *(myv1+k+1)=*(myv2+k2+1);
		}
	}

sprintf(filename, "%s.txt", base);
mf=fopen(filename,"w");
fprintf(mf,"%f ",w);
fprintf(mf,"%f ",h);
for (k=0;k<ml;k++)
	fprintf(mf,"%lf ",*(myv1+k));
fclose(mf);
free(myv1);
free(myv2);
return 0;
}