//Combines RZViewer bitmaps to form a new one
//To run this file from terminal put it in a folder, cd to the folder and input
//gcc -o rzo merge5w12b.c -lm && ./rzo
//To run successive compiled versions type ./rzmovieo
//See: http://www.dhushara.com/DarkHeart/RZV/RZViewer.htm

#include <stdio.h>
#include<complex.h>
#include<math.h>
#include <stdlib.h> 
const char base[] = "merge";

int main(void)
{
FILE *mf,*inf;
char filename [ FILENAME_MAX ];
long k;
long ml;
float w,h=0;
double hold;
double *myv1, *myv2, *myv3, *myv4, *myv5;

/*Scan file1*/
//inf=fopen("a.txt","r"); //You need to generate the bitmaps infile.txt by using RZViewer with the appropriate paraeter files first
inf=fopen("a.txt","r");
fscanf (inf, "%f", &w);
fscanf (inf, "%f", &h);
//printf("%f %f \n",w,h);
ml=(long)(2*w*h);
myv1 = calloc(ml,sizeof(double));
for (k=0;k<ml;k++)
	{
	fscanf (inf, "%lf", &hold);
	*(myv1+k)=hold;
	}
fclose(inf);

/*Scan file2*/
inf=fopen("b.txt","r"); 
fscanf (inf, "%f", &w);
fscanf (inf, "%f", &h);
//printf("%f %f \n",w,h);
ml=(long)(2*w*h);
myv2 = calloc(ml,sizeof(double));
for (k=0;k<ml;k++)
	{
	fscanf (inf, "%lf", &hold);
	*(myv2+k)=hold;
	}
fclose(inf);

/*Scan file3*/
inf=fopen("c.txt","r"); // this is m0
//inf=fopen("m1.txt","r"); // this is m0
fscanf (inf, "%f", &w);
fscanf (inf, "%f", &h);
//printf("%f %f \n",w,h);
ml=(long)(2*w*h);
myv3 = calloc(ml,sizeof(double));
for (k=0;k<ml;k++)
	{
	fscanf (inf, "%lf", &hold);
	*(myv3+k)=hold;
	}
fclose(inf);

/*Scan file4*/
inf=fopen("1.txt","r"); // this is m0
//inf=fopen("m1.txt","r"); // this is m0
fscanf (inf, "%f", &w);
fscanf (inf, "%f", &h);
//printf("%f %f \n",w,h);
ml=(long)(2*w*h);
myv4 = calloc(ml,sizeof(double));
for (k=0;k<ml;k++)
	{
	fscanf (inf, "%lf", &hold);
	*(myv4+k)=hold;
	}
fclose(inf);

/*Scan file5*/
inf=fopen("1x5.txt","r"); // this is m0
//inf=fopen("m1.txt","r"); // this is m0
fscanf (inf, "%f", &w);
fscanf (inf, "%f", &h);
//printf("%f %f \n",w,h);
ml=(long)(2*w*h);
myv5 = calloc(ml,sizeof(double));
for (k=0;k<ml;k++)
	{
	fscanf (inf, "%lf", &hold);
	*(myv5+k)=hold;
	}
fclose(inf);

for (k=0;k<ml;k++)
	{
	*(myv1+k)=0.1798620689655173*(*(myv1+k))+0.0940818718501889*(*(myv2+k))+0.2187120212795821*(*(myv3+k))+0.5073440379047118*(*(myv4+k))-2035.059752566465*(*(myv5+k)); // gives m1
	//*(myv1+k)=0.003034482758620690*(*(myv1+k))-0.003916726670102101*(*(myv2+k))+0.006725886975445612*(*(myv3+k))-0.005843643063964202*(*(myv4+k))+104551.0/3799*(*(myv5+k)); // gives m2
	//*(myv1+k)=-0.0008275862068965518*(*(myv1+k))-0.0001620198756699992*(*(myv2+k))+0.0004368290359753427*(*(myv3+k))+0.0005527770465912082*(*(myv4+k))+0.7750723874703869*(*(myv5+k)); // gives m3
	//*(myv1+k)=-0.0000689655172413793*(*(myv1+k))+0.00010003689080421164*(*(myv2+k))+0.0001137035672110556*(*(myv3+k))-0.0001447749407738879*(*(myv4+k))+1.582719136614899*(*(myv5+k)); // gives m4
	//*(myv1+k)=(*(myv5+k)); // gives m5
	}

sprintf(filename, "%s.txt", base);
mf=fopen(filename,"w");
fprintf(mf,"%f ",w);
fprintf(mf,"%f ",h);
for (k=0;k<ml;k++)
	fprintf(mf,"%lf ",*(myv1+k));
fclose(mf);
free(myv1);
free(myv2);
free(myv3);
return 0;
}