//to be processed with RZViewer
//To run this file from terminal put it in a folder, cd to the folder and input
//gcc -o rzmovieo 14.c -lm && ./rzmovieo
//To run successive compiled versions type ./rzmovieo
//See: http://www.dhushara.com/DarkHeart/RZV/RZViewer.htm

#include <stdio.h>
#include<complex.h>
const int terms = 590;
const double pi=3.1415926535;
const int frames = 1; //number of movie frames - use n+1 for circular
const int spcno = 29+2+2*590+6;
const char base[] = "14a";
int ellm[600]={1,-1,-2,1,0,2,1,-1,1,0,0,-2,-4,-1,0,1,6,-1,2,0,-2,0,0,2,-5,4,4,1,-6,0,-4,-1,0,-6,0,1,2,-2,8,0,6,2,8,0,0,0,-12,-2,1,5,-12,-4,6,-4,0,-1,-4,6,-6,0,8,4,1,1,0,0,-4,6,0,0,0,-1,2,-2,10,2,0,-8,8,0,-11,-6,-6,-2,0,-8,12,0,-6,0,-4,0,8,12,0,2,-10,-1,0,-5,0,12,-4,4,0,-6,12,4,2,0,-4,1,6,4,0,-6,-4,6,6,0,-11,-8,-12,-4,0,-1,-16,-1,-16,0,18,0,2,4,0,-6,18,0,14,0,24,0,0,1,0,-2,-2,2,-18,-10,8,-2,6,0,0,8,-4,-8,-12,0,0,11,-16,6,0,6,-12,2,3,0,2,8,-12,-12,-5,0,12,6,-12,0,20,4,-16,0,0,-8,0,-12,4,0,24,-2,14,10,0,1,-18,0,20,5,8,0,-6,-12,0,4,0,-4,0,0,-4,6,0,-12,0,-4,-4,-2,-4,0,-24,4,8,-1,-5,-6,18,-4,-4,0,0,6,-6,4,0,-6,-16,-6,24,0,-10,11,10,8,0,12,-8,4,12,0,-18,1,0,16,0,1,18,16,2,0,-6,-18,0,0,0,-2,12,-4,-12,0,-16,6,8,-18,0,0,-10,-14,-4,0,-6,-24,-22,0,0,0,6,-1,19,0,20,2,24,2,0,-2,0,18,0,10,8,-8,0,2,0,-6,2,0,8,0,-24,-8,-10,4,0,8,6,12,0,0,-24,0,12,-11,20,16,-4,-6,-12,0,8,-6,2,12,0,-2,14,-3,-12,0,0,-2,1,-8,0,12,-24,12,-28,5,-16,0,18,-12,0,-6,-12,12,-24,0,-15,-20,22,-4,0,16,8,0,6,0,6,8,14,0,0,12,24,-4,-16,0,32,-24,36,2,0,-14,8,-10,18,0,0,-1,-36,18,0,0,20,-20,-4,-5,-18,-8,16,0,0,6,0,12,14,0,-36,-4,-6,0,0,4,-28,0,6,0,-10,4,-12,-6,-30,0,8,12,0,0,24,4,-34,4,0,2,0,4,8,0,1,24,-12,-4,0,-8,36,1,18,5,0,6,-16,-18,0,4,-10,4,24,0,12,0,32,-6,0,6,-6,-4,-4,0,8,6,0,16,-10,6,6,-24,-36,0,-8,10,0,-11,0,-10,-16,-8,32,0,-12,-12,-36,8,0,-4,0,-12,-4,0,24,18,0,-1,0,0,-6,-16,36,0,2,-1,8,-18,0,-16,0,-2,24,0,6,6,2,18,10,0,-24,0,-23,0,-6,2,-24,-12,0,4,24,12,0,0,38,16,-40,-6,0,-8,8,18,8,0,-12,0,8,10,0,14,6,4,-32,0,0,6,30,24,0,22,-11,0,6,0,32,0,-48,-6,0,1,2,-19,-28,0,-6,-20,0,-2,0,-24,-42,-2,-8,0,36,2,-6,0,0,-18,-40,0,-24,-10};

void WriteParamFile(int frameno, double param);

int main(void)
{
FILE *mf;
char filename [ FILENAME_MAX ];
int filetyp = 3;
int k;
double xstt = 0.25;
double xend = 1.25;
double xpos;
sprintf(filename, "%s.txt", base);
mf=fopen(filename,"w");
fprintf(mf,"%f %f \n",(float)filetyp, (float)frames);
fclose(mf);
xpos=xstt;
for(k=0;k<frames;k++)
	{
	if(k==0)
		xpos=xstt;
	else
		xpos=xstt+(xend-xstt)*k/(frames-1);
	WriteParamFile(k, (double)xpos);
	}
return 0;
}

void WriteParamFile(int frameno, double param)
{
FILE *mf;
char filename [ FILENAME_MAX ];
int j;

double specs[spcno];

double mandel=2;
double scale=80;
double screenX=0;
double screenY=0;
double cx=0;
double cy=0;
double altgamma=0;
double thisfn=4;
double split=2;
double orbitTrapE=0;
double addc=1;
double escapeonly=0;
double colsch=0;
double zetaterms=100;
double escapeboundExp=1.7;
double attractorEscBd=-2;
double maxIterations=64;
double dolog=0;
double sang=1;
double domoib=0;
double cval=0;
double oldfn=thisfn;
double realk=0;
double imagk=0;
double crval=0;
double fullt=4;
double xm=0;
double xn=2;
double flip=0;

specs[0]=mandel;
specs[1]=scale;
specs[2]=screenX;
specs[3]=screenY;
specs[4]=cx;
specs[5]=cy;
specs[6]=altgamma;
specs[7]=thisfn;
specs[8]=split;
specs[9]=orbitTrapE; //orbit trap epsilon)
specs[10]=addc; //additive c/ mult c
specs[11]=escapeonly;
specs[12]=colsch;
specs[13]=escapeboundExp; //escape bound exponent
specs[14]=zetaterms;
specs[15]=attractorEscBd; //attractor escape bound 10^-k
specs[16]=maxIterations; //iterations
specs[17]=dolog; //take log of the function
specs[18]=sang; //angle ploting
specs[19]=domoib; //mobius
specs[20]=cval; 
specs[21]=oldfn; 
specs[22]=realk; 
specs[23]=imagk; 
specs[24]=crval; 
specs[25]=fullt; 
specs[26]=xm;
specs[27]=xn; 
specs[28]=flip;

specs[29]=terms;
specs[30]=-997;

for (j=0;j<terms;j++)
	{
    specs[31+2*j]=ellm[j];
	specs[32+2*j]=0;
	}
specs[31+2*terms]=2;   //d no. gamma terms
specs[31+2*terms+1]=0; //gamma[0]
specs[31+2*terms+2]=1; //gamma[1]
specs[31+2*terms+3]=14; //N=conductor
specs[31+2*terms+4]=1; //epsilon (sign)
specs[31+2*terms+5]=2;  //weight

sprintf(filename, "%s%d.txt", base, frameno);
//printf("filename = \"%s\"\n", filename);
mf=fopen(filename,"w");
for (j=0;j<spcno;j++)
    fprintf(mf,"%f ",specs[j]);
fclose(mf);
}


