#import "MyView.h"
#include <unistd.h>
#include "mandel.h"   
#import "MTRectTools.h"
#include <stdlib.h> 
#include <complex.h>
//#include <stdio.h>

//#import <Foundation/Foundation.h>

#define kCollapseDrag 12.0

@implementation MyView

int stbut=1;
int cval=0;
double oldzTerms=0;
long *myp;
double _Complex *myv;
int frms,thisfrm, thisfn;
char mychar[100], ldchar[100];
bool movfl=FALSE;
int thrds;
int fltyp;
double _Complex kk=0;
double _Complex *myfl;
int myh,myw=0;
double ibd=55.5; //prev 10.5
double xpos=2.5; // prev 0.25
int intstps=200;
double _Complex gar[2*200-2]; 
double ypos[2*200-1];
//const double pi=3.1415926535;
double tf=5.0;

// randomizerSwitch; has been set to toggle "fill" determining whether the window scope is kept on clicking
// clearSwitch is toggling between f(z)+c and c*f(z)
// originSwitch toggles orbit trap
// doReportButton sets c values to the text field's values
// doResetOriginButton sets window centre (x,y) and scale from the test field's values
//crval=(BOOL)myar[24] % 2;
//usxi=(BOOL)((int)myar[24] / 2);
//fullt=(BOOL)((int)myar[25] % 2);
//dzsw=(BOOL)(((int)myar[25] / 2) % 2);
//mell=(BOOL)((int)myar[25] / 4);


/*- (IBAction)doOpen:(id)sender
{
}



- (IBAction)doSave:(id)sender
{
}*/

double _Complex Vgamma(register double _Complex z)
//complex gamma function using Lanczos approximation to extend to the entire plane. 
{
	double _Complex zz, t, LogofGamma, s, ss, f;
	
	double twopi, fac;
	double c[12];
	int k,g;
	
		
		c[1] = 1.000000000000000174663;
		c[2] = 5716.400188274341379136;
		c[3] = -14815.30426768413909044;
		c[4] = 14291.49277657478554025;
		c[5] = -6348.160217641458813289;
		c[6] = 1301.608286058321874105;
		c[7] = -108.1767053514369634679;
		c[8] = 2.605696505611755827729;
		c[9] = -0.7423452510201416151527e-2;
		c[10] = 0.5384136432509564062961e-7;
		c[11] = -0.4023533141268236372067e-8;
		twopi=pi+pi;
		g=9;
		s=0;
		zz=z;
		if ((round(creal(zz))==creal(zz))&&(cimag(zz)==0)&&(creal(zz)<=0))
		{
			f=1.79e308;
		}
		if ((round(creal(zz))==creal(zz))&&(cimag(zz)==0)&&(creal(zz)>=0))
		{
			fac=1;
			for (k=1; k<=creal(zz)-1; k++)
				fac=fac*k;
			f=fac;
		}
		if ((round(creal(zz))!=zz)||(cimag(zz)!=0))
			//else
		{
			if (creal(z)<0)
				z=-z;
			t=z+g;
			for ( k = g+2; k>=2; k-- ) 
			{
				s=s+c[k]/t;
				t=t-1;
			}
			s=s+c[1];
			ss=(z+g-0.5);
			s=clog(s*sqrt(twopi))+(z-0.5)*clog(ss)-ss;
			LogofGamma = s;
			f = cexp(LogofGamma);
			if (creal(zz)<0)
			{
				f=-pi/(z*f*csin(pi*z));
			}
		 }
	
	return f;
}

double _Complex Tgamma(register double _Complex s) //calculate total gamma factor
{
	int n;
	int k=creal(*(myv));
	int d=(int)fabs(*(myv+k+1));
	double _Complex ga=1;
	for(n=1;n<=d;n++)
		ga=ga*Vgamma((s+*(myv+k+n+1))/2);
	return ga;
}

double psiv(double t) //evaluates phi function by integrating over total gammas
{						//up the critical line xpos+j*I
	int k,h,j,d;		//int t^s*tgamma(xpos*I*j)
	int stps=intstps;
	//double sq;
	double _Complex su=0;
	double _Complex s;
	k=creal(*(myv));
	h=cimag(*(myv));
	d=fabs(*(myv+k+1));
	//if((d==2)&&(*(myv+k+2)==0)&&(*(myv+k+3)==1))
	//   return(exp(-2*t))*2.0*pi;
	//else
	   {
		for(j=0;j<=stps-1;j++)
			{		
			s=xpos+I*(*(ypos+2*j+1));
			su=su+cpow(t,(-s))*gar[2*j]*I*2.0*(*(ypos+2*j+2)-*(ypos+2*j));
			su=su+cpow(t,(-conj(s)))*gar[2*j+1]*I*2.0*(*(ypos+2*j+2)-*(ypos+2*j));			
			}
		su=su/2.0/pi/I;// /4/sq;	
		//printf("%f %f,",t,creal(su));
		return creal(su);
	   }
}
void setphi(int mpos,int tms)
{
	int stps=intstps;
	int j,m,q,stps2;
	double sn,A,ist,ist2;
	int k=creal(*(myv));
	int d=(int)abs(*(myv+k+1));
	int n=*(myv+k+d+2);
	sn=sqrt(n);
	A=sn/pow(pi,0.5*d);
	double b=1.0;
	double t=tf*sn;
	double ys, ya;
	ist=ibd/stps;
	stps2=2*stps-1;
	ist2=ibd/stps2;
	m=tms;
	//printf("%d %d,",mpos,d);
	*ypos=0;
	for(j=1;j<=stps2;j++) //create gamma biased partition (currently linear)
		*(ypos+j)=*(ypos+j-1)+1.0;// /exp(-0.001*j*j*ist2*ist2);//1.0;// /creal(Vgamma(xpos+I*j*ist2));
	for(j=1;j<=stps2;j++)
		*(ypos+j)=ibd*(*(ypos+j))/(*(ypos+stps2));
	//for(j=1;j<=stps2;j++)
	//	printf("%f,",*(ypos+j));
	
	for(j=0;j<=stps-2;j++)
	{	
		gar[2*j]=Tgamma(xpos+I*(*(ypos+2*j+1)));  //interpolate tgamma values betweeon -ibd and ibd
		gar[2*j+1]=Tgamma(xpos-I*(*(ypos+2*j+1)));
	}	
	for(j=1;j<=m-1;j++)
	{
		ya=t/(b+(t-b)*(m-j-0.5)/(m-1)); //harmonic partition running between b=1 and t
		ys=ya/A; 
		for (q=1;q<=m;q++)
		{
			*(myv+mpos+m*(j-1)+q)=psiv(q*ys);  //calculate array of phi values
		}
		
	}

}

int modpwr(int a,int b,int k)
{
int mp,j;
mp=1;
for(j=1;j<=b;j++)
    mp=a*mp % k;
return mp;
}

int getcoefs(int k, int h, double _Complex * vv)
{
	//double _Complex[63] grouptest(int k,int h)
	double pi=3.1415926535;
	int z_zn[189]={1,1,1,1,1,1,2,1,1,3,1,1,2,1,1,5,1,1,3,1,1,7,3,1,2,1,1,3,1,1,2,1,1,5,7,1,2,1,1,3,1,1,14,2,1,15,3,1,3,1,1,5,1,1,2,1,1,19,3,1,20,2,1,7,1,1,5,1,1,5,7,13,2,1,1,7,1,1,2,1,1,13,3,1,2,1,1,11,7,1,3,1,1,31,3,1,10,2,1,3,1,1,6,2,1,19,5,1,2,1,1,3,1,1,38,2,1,39,11,3,6,1,1,13,5,1,3,1,1,43,3,1,44,2,1,5,1,1,5,1,1,47,7,5,3,1,1,3,1,1,50,5,1,51,7,1,2,1,1,5,1,1,21,2,1,3,1,1,20,2,1,3,1,1,2,1,1,11,19,7,2,1,1,3,1,1,2,5,1};
	int g[3],pds[3];
	int j,lv,lg,x,f,m,n;
	for(j=0;j<=k;j++)
		vv[j]=0;
	for(j=0;j<=2;j++)
		g[j]=z_zn[3*(k-1)+j];
	//printf("%d %d %d\n",g[0],g[1],g[2]);
	lv=1; //number of coprimes getting non-zero entries
	lg=3;
	for(j=0;j<=lg-1;j++)
		{
		x=g[j];
		f=0;
		m=0;
		while((!f)||(x!=g[j]))
			{
			x=x*g[j] % k;
			f=1;
			m=m+1;
			}
		pds[j]=m;
		lv=lv*m;
		}
	//printf("%d\n",h);
	if((h>lv)||(h<1))
		h=1;
	h=lv-h+1;
//	for(h=1;h<=lv;h++)
	{
	//printf("%d %d\n",lv,h);
	for(j=1;j<=pds[0];j++)
		for(m=1;m<=pds[1];m++)
			for(n=1;n<=pds[2];n++)
				vv[modpwr(g[0],j,k)*modpwr(g[1],m,k)*modpwr(g[2],n,k) % k - 1]=cexp(2*pi*I*(h-0)*j/pds[0])*cexp(2*pi*I*(int)((h-0)/pds[0])*m/pds[1])*cexp(2*pi*I*((int)((h-0)/pds[0]/pds[1]))*n/pds[2]);
	}
	return lv;
}
	
int chars(int k, int h)
{
int j,p,q,flg,u,lt,m,n,lv;
double _Complex vv[64];
double _Complex vw[63];
for(j=0;j<63;j++)
	{
	vv[j]=0;
	vw[j]=0;
	}
vv[63]=0;
*(myv)=k+I*h;
if (k==1)
	{ 
	*(myv+1)=1;
	return 1;
	}
if(( k<1)||((k>63)&&(h!=1)))
	{
	k=1;
	h=1;
	*(myv)=k+I*h;
//	printf("*");
	return 1;
	}
if ((thisfn==26)||(thisfn==27))
	{
	lv=getcoefs(k, h, vv); //look up factor group list and run generators to select character
	for(j=1;j<=k;j++)
		*(myv+j)=vv[j-1];
	return lv;
	}
if(h==1)
	{
	j=0;
	h=-1;
	p=*(myp+(int)j);
	while ((p>0)&&(p<=k))
		{
		if((int)k % p==0)
			h=h*p;
		j=j+1;
		p=*(myp+(int)j);
		}
		k=1;
	*(myv)=k+I*h;
	//printf("%d %d\n",k,h);
	return 1;
	}
lv=getcoefs(k, h, vv); //look up factor group list and run generators to select character
if((h<1)||(h>lv))
	{
	k=1;
	h=1;
	*(myv)=k+I*h;
	//Beep(523,500);
	return lv;
	}
//for(j=0;j<k;j++)
//	printf("%f %f ",creal(vv[j]),cimag(vv[j]));
	//printf("%d %d   ",(int)(1*creal(vv[j])),(int)(1*cimag(vv[j])));
//printf("\n");
for(j=2;j<=k-1;j++) //look for equivalent lower period characters
if(k % j ==0)
	{
	flg=0;
	//printf("%d\n",j);
	for(p=1;p<k/j;p++)
		for(q=0;q<j;q++)
			if (cabs(vv[p*j+q]-vv[q])>0.001)
				{
				flg=1;
				//printf("%d %d %d %f %d\n",p,p*j+q,q,cabs(vv[p*j+q]-vv[q]),cabs(vv[p*j+q]-vv[q])>0);
				//printf("%f %f %f %f\n",creal(vv[p*j+q]),cimag(vv[p*j+q]),creal(vv[q]),cimag(vv[q]));
				}
	if(flg==0)
		{
		//printf("*%d\n",j);
		k=j;
		break;
		}
	}			
//*(myv)=k+I*(lv-h+1);	
//for(j=0;j<k;j++)
//	printf("%d %d   ",(int)(1*creal(vv[j])),(int)(1*cimag(vv[j])));
	//printf("%f %f ",creal(vv[j]),cimag(vv[j]));
//printf("%d %d\n",k,h);
if(h!=1)
{
flg=0;
u=1;
while(flg==0) //look for conductors and prime factors
	{
	//printf("%d %d\n",j,k);
	for(j=2;j<=k;j++)
		{
		if(j==k)
			{
			flg=1;
			break;
			}
		if(k % j==0)
			{
			lt=getcoefs(j, u, vw);
			for(m=1;m<=lt;m++)
				{
				lt=getcoefs(j, m, vw);
				//for(n=0;n<j;n++)
					//printf("%f %f ",creal(vv[j]),cimag(vv[j]));
					//printf("%d %d   ",(int)(1*creal(vw[n])),(int)(1*cimag(vw[n])));
				//printf("\n");

				flg=0;
				for(n=0;n<k;n++)
					if(cabs(vv[n])>0.01)
						{
						if(cabs(vv[n]-vw[(n % j)])>0.01)
							flg=1;
						//printf("%d %d  flg=%d j=%d k=%d n=%d mod=%d m=%d\n",(int)creal(vv[n]),(int)creal(vw[(n % j)]),flg,j,k,n,(n % j),m);
						}
				 if(flg==0)
					{
					//printf("%d %d %d %d\n",flg,j,k,m);
					u=u*k/j;
					k=j;
					h=-u;
					for(m=0;m<j;m++)
						vv[m]=vw[m];
					break;
					}
				}
			}
		}
	  }
}
//for(j=0;j<k;j++)
//	printf("%d %d   ",(int)(1*creal(vv[j])),(int)(1*cimag(vv[j])));
	//printf("%f %f ",creal(vv[j]),cimag(vv[j]));
//printf("%d %d\n",k,h);
*(myv)=k+I*h;
for(j=1;j<=k;j++)
	*(myv+j)=vv[j-1];
return lv;
}

void prims(double terms, int mode)
	{
	long j,k,pp,pt;
	double q;
	double myzt;
	*myp=2;
	//printf("%d ",*(myp));
	myzt=(long)terms;
	for (k=1;k<=myzt;k++)
		{
		pp=*(myp+k-1)+1;
		pt=0;
		j=1;
		while ((pt<k)&&(*(myp+pt)<=sqrt(pp)))
			{
			j=j+1;
			q=(double)pp/(*(myp+pt));
			if (q!=(long)q)
				pt++;
			else
				{
				pp++;
				pt=0;
				}
			}
		*(myp+k)=pp;
	//	printf("%d ",*(myp+k));
		if ((mode==1)&&(pp>terms))
			{
			//printf("%d ",mode);
			return;	
			}		
		}
	//printf("\n");
	}

- (NSImage *) transformedImage  // provides the image in its transformed state, in case you want to save it.
  {
  NSSize 
    imageSize = [self bounds].size;
    
  NSImage 
    *newImage = [[NSImage alloc] initWithSize:imageSize];
    
 // NSGraphicsContext
//	  *context;
	
  NSRect currentFrame;
    
  currentFrame = [self bounds];
  
      
  [newImage lockFocus];  
 // context = [NSGraphicsContext currentContext];
		// Must use the CG call here because I'm not drawing in an NSView.
 // CGContextTranslateCTM([context graphicsPort], imageSize.width/2, imageSize.height/2); // Move the origin to the center.
 // [self drawImage]; 
  [myImage drawInRect:currentFrame];
  [newImage unlockFocus];  
  return [newImage autorelease]; 
  }
  
  - (IBAction)doBitmap:(id)sender
  {
  [[NSOpenPanel openPanel]  // Get the shared open panel
    beginSheetForDirectory:NSHomeDirectory()	// Point it at the user's home
    file:nil
    modalForWindow:window  // This makes it show up as a sheet, attached to window
    modalDelegate:self		// Tell me when you're done.
    didEndSelector:@selector(bitPanelDidEnd:returnCode:contextInfo:)  // Call this method when you're done..
    contextInfo:NULL];  
  }

- (void) bitPanelDidEnd:(NSOpenPanel *)sheet returnCode:(int)returnCode contextInfo:(void  *)contextInfo
  {
 // [self setImage:[[[NSImage alloc] initWithContentsOfFile:[sheet filename]]autorelease]];
   //read from the file
	int myl,j;
	float myr,myi,mywf,myhf;

	//char *tststr;
	
	//NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
	NSString *string = [[NSString alloc] initWithContentsOfFile:[sheet filename]];
    if(string == nil)
    {
        //NSLog(@"Error reading file");
        return ;
    }
	 
    //scan the integers from the file
    NSScanner *scanner = [[NSScanner alloc] initWithString:string];
	[scanner scanFloat:&mywf];
	[scanner scanFloat:&myhf];
		
//		printf("%f %f\n",myf,myi);
	myw=(int)mywf;
	myh=(int)myhf;
	myl=myw*myh;
	if(myfl!=nil)
		free(myfl);
	myfl = calloc(myl,sizeof(double _Complex)); 	
	j=0;
    while([scanner isAtEnd] == NO)
    {
		[scanner scanFloat:&myr];
		[scanner scanFloat:&myi];
		//printf("%f %f\n",myr,myi);
		*(myfl+j)=myr+I*myi;
		j=j+1;
		if (j==myl)
			break;
//        NSLog(@"Value : %f", myf);
	}
	movfl=TRUE;
	thisfn=17;
	viewStep=1;
	viewX=-(double) frame.size.width * viewStep * 0.5;
	viewY=(double) frame.size.height * viewStep * 0.5;
	[myFunction selectItemAtIndex:thisfn-1];	
	[Scale setFloatValue:frame.size.width];
	[RealPart setFloatValue:viewX+(double) frame.size.width * viewStep * 0.5];
	[ImagPart setFloatValue:viewY-(double) frame.size.height * viewStep * 0.5];
	[self startButton:nil];
}

- (IBAction)doOpen:(id)sender
  {
  [[NSOpenPanel openPanel]  // Get the shared open panel
    beginSheetForDirectory:NSHomeDirectory()	// Point it at the user's home
    file:nil
    modalForWindow:window  // This makes it show up as a sheet, attached to window
    modalDelegate:self		// Tell me when you're done.
    didEndSelector:@selector(openPanelDidEnd:returnCode:contextInfo:)  // Call this method when you're done..
    contextInfo:NULL];  
  }

- (void) openPanelDidEnd:(NSOpenPanel *)sheet returnCode:(int)returnCode contextInfo:(void  *)contextInfo
  {
 // [self setImage:[[[NSImage alloc] initWithContentsOfFile:[sheet filename]]autorelease]];
   //read from the file
	int j,k,d,e,f,dd,ff;
	float myf, myar[2480];
	//char *tststr;

	//NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
	NSString *string = [[NSString alloc] initWithContentsOfFile:[sheet filename]];
    if(string == nil)
    {
        //NSLog(@"Error reading file");
        return ;
    }
	 
    //scan the integers from the file
    NSScanner *scanner = [[NSScanner alloc] initWithString:string];
	j=0;
    while([scanner isAtEnd] == NO)
    {
		[scanner scanFloat:&myf];
		myar[j]=myf;
		j=j+1;
        //NSLog(@"Value : %f", myf);
	}
	mandel=(int)myar[0];
	viewStep = myar[1] / frame.size.width;
	viewX = myar[2]-(double) frame.size.width * viewStep * 0.5;
	viewY = myar[3]+(double) frame.size.height * viewStep * 0.5;
	originX = myar[4];
	originY = myar[5];
	altnGamma=(int)myar[6];
	thisfn=(int)myar[7];
	dzet=(int)myar[8];
	orbtrap=(BOOL)myar[9];
	addc=(BOOL)myar[10];	
	esconly=(BOOL)myar[11];
	altcol=(int)myar[12];
	escapeRadius=myar[13];
	zetaTerms=myar[14];
	attractorTerms=myar[15];
	max_dwells=(int)myar[16];
	dolog=(BOOL)myar[17];
	sang=(BOOL)myar[18];
	domoib=(BOOL)myar[19];
	cval=(int)myar[20];
	oldfn=(int)myar[21];
	if (j>22)
		{
		kk=myar[22]+I*myar[23];
		crval=(BOOL)myar[24] % 2;
		usxi=(BOOL)((int)myar[24] / 2);
		fullt=(BOOL)((int)myar[25] % 2);
		dzsw=(BOOL)(((int)myar[25] / 2) % 2);
		mell=(BOOL)((int)myar[25] / 4);
		xm=(int)myar[26];
		xn=(int)myar[27];
		flip=(BOOL)myar[28];
		[FlipXY setIntValue:flip];
		[Xm setIntValue:xm];
		[Xn setIntValue:xn];
		[crVal setIntValue:crval];
		[useXi setIntValue:usxi];
		[dooTerms setIntValue:fullt];
		[dooMel setIntValue:mell];
		[dZswitch setIntValue:dzsw];		
		}
	if (j>29)
		{
		if(myar[30]==-999)
			d=2;
		else
			d=1;
		e=0;
		if (myar[31+2*(int)myar[29]]<0) {e=e+3; };//printf("%d", e); }//add Mellin window and residue at z=1
		dd=(int)fabs(myar[31+2*(int)myar[29]]);
		if((myar[30]==-997)||(myar[30]==-995))
			e=e+dd+4; //no gammas+4
			//printf("e=%d ",e);
		if(myar[30]==-996)
			{
			e=e+dd+5; //no gammas+5 to allow for shift factor
			}
		if(myv!=nil)
			free(myv);
		if(myar[30]==-995) ff=2; else ff=1;
		if ((mell!=0)&&((dd!=2)||(myar[31+ff+2*(int)myar[29]]!=0)||(myar[31+2*ff+2*(int)myar[29]]!=1)||(myar[31+2*(int)myar[29]+ff*(dd+3)]<2))) f=zetaTerms*(zetaTerms-1); else f=0;

			//if ((fullt!=0)&&((dd!=2)||(myar[32+2*(int)myar[29]]!=0)||(myar[33+2*(int)myar[29]]!=1))) f=zetaTerms*(zetaTerms-1); else f=0;
		//f=zetaTerms*(zetaTerms-1);
	myv = calloc((int)(1+d*myar[29]+e+f),sizeof(double _Complex)); 
		*(myv)=myar[29]+I*myar[30];
		if(j>=31+2*myar[29])
			{
			for(k=0;k<d*myar[29];k++)
				{
				*(myv+k+1)=myar[31+2*k]+I*myar[32+2*k];
				}
			}
		if((myar[30]==-997)||(myar[30]==-996))
			{
			for(k=0;k<e;k++)
				{
				*(myv+k+d*(int)myar[29]+1)=myar[31+k+2*(int)myar[29]];
			//	printf("%f ",*(myv+k+d*(int)myar[29]+1));
				}
			}
		if(myar[30]==-995)
			{
			for(k=0;k<e;k++)
				{
				*(myv+k+d*(int)myar[29]+1)=myar[31+2*k+2*(int)myar[29]]+I*myar[32+2*k+2*(int)myar[29]];
			//	printf("%f ",*(myv+k+d*(int)myar[29]+1));
				}
			}
		if(f!=0) setphi(e+d*(int)myar[29], zetaTerms);
	/*	for(k=0;k<2*13;k++)
			printf("%f ",myar[29+k]);
		printf("\n");
		for(k=0;k<12;k++)
			printf("%f %f  ",creal(*(myv+k)),cimag(*(myv+k)));
		printf("\n");*/
		}
	[altGamma selectItemAtIndex:altnGamma];
	[myFunction selectItemAtIndex:thisfn-1];
	[ThdZeta selectItemAtIndex:dzet+1];
	[Coloring selectItemAtIndex:altcol];
	[dwellMenu selectItemAtIndex:(int)(log(max_dwells)/log(2)-6)];
	[originSwitch setIntValue:orbtrap];
	[clearSwitch setIntValue:addc];
	[escapeOnly setIntValue:esconly];
	[escapeRadiusSlider setFloatValue:escapeRadius];
	[fnTerms setFloatValue:zetaTerms];
	[attractorSlider setFloatValue:attractorTerms];
	[RealC setFloatValue:originX];
	[ImagC setFloatValue:originY];
	[RealPart setFloatValue:viewX+(double) frame.size.width * viewStep * 0.5];
	[ImagPart setFloatValue:viewY-(double) frame.size.height * viewStep * 0.5];
	[Scale setFloatValue:viewStep*frame.size.width];
	[logFn setIntValue:dolog]; 	
	[Mobius setIntValue:domoib]; 	
	[showAngle setIntValue:sang];
	//[pool drain];
	[self startButton:nil];
	
}
  

- (IBAction)doLoad:(id)sender
{
  [[NSOpenPanel openPanel]  // Get the shared open panel
    beginSheetForDirectory:NSHomeDirectory()	// Point it at the user's home
    file:nil
    modalForWindow:window  // This makes it show up as a sheet, attached to window
    modalDelegate:self		// Tell me when you're done.
    didEndSelector:@selector(mopenPanelDidEnd:returnCode:contextInfo:)  // Call this method when you're done..
    contextInfo:NULL];  
}

- (void) mopenPanelDidEnd:(NSOpenPanel *)sheet returnCode:(int)returnCode contextInfo:(void  *)contextInfo
  {
	int j,k;
	float myf;
	float strt[5],fnsh[5];
	char *ldp=NULL;

NSString *string = [[NSString alloc] initWithContentsOfFile:[sheet filename]];
if(string == nil)
    {
        //NSLog(@"Error reading file");
        return ;
    }
	 
	//ldp=malloc(sizeof(char)*(101));
	ldp=[[sheet filename] UTF8String];
//	printf("%s\n",ldp);
	strcpy(ldchar,ldp);
//	for (j=0;j<=99;j++)
//			printf("%d ",ldchar[j]);
//	printf("\n");
	for (j=99;j>=0;j--)
		{
	//	printf("%d %d\n", j, ldchar[j]);
		if ((int)ldchar[j]==46)
			{
			for (k=j;k<=j+3;k++)
				ldchar[k]=0;
		//	printf("**");
			break;
			}
		}
	strcpy(ldp,ldchar);
	//printf("%s\n",ldp);
	//free(ldp);
	//for (j=0;j<=99;j++)
	//		printf("%d ",ldchar[j]);
	//printf("\n");
    //scan the integers from the file
    NSScanner *scanner = [[NSScanner alloc] initWithString:string];
	j=0;
    while([scanner isAtEnd] == NO)
    {
		[scanner scanFloat:&myf];
		movar[j]=myf;
		j=j+1;
        //NSLog(@"Value : %f", myf);
	}
	fltyp=(int)movar[0];
	if ((fltyp<1)||(fltyp>3)) 
		fltyp=1;
	frms=(int)movar[1];
	if ((frms>1000)||(frms<1))
		frms=1;
	//mandel=movar[2];
//	printf("%d\n",fltyp);
	if (fltyp==1)
		{
		for (j=0;j<5;j++)
			{
			strt[j]=movar[j+3];
			fnsh[j]=movar[j+8];
			}
		for (k=0;k<frms;k++)
			for (j=0;j<5;j++)			
				movar[3+j+k*5]=(1-(double)k/(frms-1))*strt[j]+(double)k/(frms-1)*fnsh[j];
		}
//	for (j=0;j<3+5*frms;j++)
//		printf("%d %f\n",j, movar[j]);
	
}

- (IBAction)doMovie:(id)sender
{
 [[NSSavePanel savePanel]
    beginSheetForDirectory:NSHomeDirectory()  // seems like a reasonable place to start..
    file:@"Movie" 	// default filename
    modalForWindow:window   //Run as a sheet, attached to "window"
    modalDelegate:self 	// The save panel should call me when it's done..
    didEndSelector:@selector(msavePanelDidEnd:returnCode:contextInfo:) // ... using this selector
    contextInfo:NULL];			
}	  

-(void) loadframe
	{
	NSString *ms;
	int j,k,d,e;
	float myf,myar[2480];
	char *ldp=NULL;

	//for (j=0;j<=99;j++)
	//		printf("%d ",ldchar[j]);
	//printf("\n");
	ldp=malloc(sizeof(char)*(101));
	strcpy(ldp,ldchar); 
	//printf("%s\n",ldp);
	ms = [NSString stringWithFormat: @"%d", thisfrm];
	ms = [NSString stringWithFormat:@"%@%@.%@", [NSString stringWithUTF8String: ldp], ms, @"txt"];
	free(ldp);
	 // [self setImage:[[[NSImage alloc] initWithContentsOfFile:[sheet filename]]autorelease]];
   //read from the file

	//NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
	NSString *string = [[NSString alloc] initWithContentsOfFile: ms];
    if(string == nil)
    {
		//NSLog(@"Error reading file");
        return ;
    }
	 
    //scan the integers from the file
    NSScanner *scanner = [[NSScanner alloc] initWithString:string];
	j=0;
    while([scanner isAtEnd] == NO)
    {
		[scanner scanFloat:&myf];
		myar[j]=myf;
		j=j+1;
        //NSLog(@"Value : %f", myf);
	}
//	for (j=1;j<=37;j++)
//		printf("%f ",myar[j]);
//	printf("\n");	
	mandel=(int)myar[0];
	viewStep = myar[1] / frame.size.width;
	viewX = myar[2]-(double) frame.size.width * viewStep * 0.5;
	viewY = myar[3]+(double) frame.size.height * viewStep * 0.5;
	originX = myar[4];
	originY = myar[5];
	altnGamma=(int)myar[6];
	thisfn=(int)myar[7];
	dzet=(int)myar[8];
	orbtrap=(BOOL)myar[9];
	addc=(BOOL)myar[10];	
	esconly=(BOOL)myar[11];
	altcol=(int)myar[12];
	escapeRadius=myar[13];
	zetaTerms=myar[14];
	attractorTerms=myar[15];
	max_dwells=(int)myar[16];
	dolog=(BOOL)myar[17];
	sang=(BOOL)myar[18];
	domoib=(BOOL)myar[19];
	cval=(int)myar[20];
	oldfn=(int)myar[21];
	if (j>22)
		{
		kk=myar[22]+I*myar[23];
		crval=(BOOL)myar[24] % 2;
		usxi=(BOOL)((int)myar[24] / 2);
		fullt=(BOOL)((int)myar[25] % 2);
		dzsw=(BOOL)(((int)myar[25] / 2) % 2);
		mell=(BOOL)((int)myar[25] / 4);
		xm=(int)myar[26];
		xn=(int)myar[27];
		flip=(BOOL)myar[28];
		[FlipXY setIntValue:flip];
		[Xm setIntValue:xm];
		[Xn setIntValue:xn];
		[crVal setIntValue:crval];
		[useXi setIntValue:usxi];
		[dooTerms setIntValue:fullt];
		[dooMel setIntValue:mell];
		[dZswitch setIntValue:dzsw];		
		}
	if (j>29)
		{
		if(myar[30]==-999)
			d=2;
		else
			d=1;
		e=0;
		if((myar[30]==-997)||(myar[30]==-995))
			e=myar[31+2*(int)myar[29]]+4;
		if(myar[30]==-996)
			e=myar[31+2*(int)myar[29]]+5;
		if(myv!=nil)
			free(myv);
		myv = calloc((int)(1+d*myar[29]+e),sizeof(double _Complex)); 
		*(myv)=myar[29]+I*myar[30];
		if(j>=31+2*myar[29])
			{
			for(k=0;k<d*myar[29];k++)
				{
				*(myv+k+1)=myar[31+2*k]+I*myar[32+2*k];
				}
			}
		if((myar[30]==-997)||(myar[30]==-996))
			{
			for(k=0;k<e;k++)
				{
				*(myv+k+d*(int)myar[29]+1)=myar[31+k+2*(int)myar[29]];
				}
			}
		if(myar[30]==-995)
			{
			for(k=0;k<e;k++)
				{
				*(myv+k+d*(int)myar[29]+1)=myar[31+2*k+2*(int)myar[29]]+I*myar[32+2*k+2*(int)myar[29]];
			//	printf("%f ",*(myv+k+d*(int)myar[29]+1));
				}
			}
	/*	for(k=0;k<2*13;k++)
			printf("%f ",myar[29+k]);
		printf("\n");
		for(k=0;k<12;k++)
			printf("%f %f  ",creal(*(myv+k)),cimag(*(myv+k)));
		printf("\n");*/
		}
	[altGamma selectItemAtIndex:altnGamma];
	[myFunction selectItemAtIndex:thisfn-1];
	[ThdZeta selectItemAtIndex:dzet+1];
	[Coloring selectItemAtIndex:altcol];
	[dwellMenu selectItemAtIndex:(int)(log(max_dwells)/log(2)-6)];
	[originSwitch setIntValue:orbtrap];
	[clearSwitch setIntValue:addc];
	[escapeOnly setIntValue:esconly];
	[escapeRadiusSlider setFloatValue:escapeRadius];
	[fnTerms setFloatValue:zetaTerms];
	[attractorSlider setFloatValue:attractorTerms];
	[RealC setFloatValue:originX];
	[ImagC setFloatValue:originY];
	[RealPart setFloatValue:viewX+(double) frame.size.width * viewStep * 0.5];
	[ImagPart setFloatValue:viewY-(double) frame.size.height * viewStep * 0.5];
	[Scale setFloatValue:viewStep*frame.size.width];
	[logFn setIntValue:dolog]; 	
	[showAngle setIntValue:sang];
	//[pool drain];
	//[self startButton:nil];
	

	}

- (void) msavePanelDidEnd:(NSSavePanel *)sheet returnCode:(int)returnCode contextInfo:(void  *)contextInfo
  {
  char *flp=NULL;;
  
  if (returnCode == NSOKButton) 
	{
//	flp=malloc(sizeof(char)*(101));
	flp=[[sheet filename] UTF8String];
	strcpy(mychar,flp);
//	free(flp);
	movfl=TRUE;
	thisfrm=0;
	if (fltyp==3)
		{
		[self loadframe];
		}
	else
	{
	mandel=(int)movar[2];
	[RealPart setFloatValue:movar[3+5*thisfrm]];
	[ImagPart setFloatValue:movar[3+5*thisfrm+1]];
	[Scale setFloatValue:movar[3+5*thisfrm+2]];	
    [RealC setFloatValue:movar[3+5*thisfrm+3]];
	[ImagC setFloatValue:movar[3+5*thisfrm+4]];
	viewStep = [Scale floatValue] / frame.size.width;
	viewX = [RealPart floatValue]-(double) frame.size.width * viewStep * 0.5;
	viewY = [ImagPart floatValue]+(double) frame.size.height * viewStep * 0.5;
	originX = [RealC floatValue];
	originY = [ImagC floatValue];
	} 
	[self startButton:nil];

	myTimer =[NSTimer scheduledTimerWithTimeInterval:1
			target:self selector:@selector(myTimerMethod)
			userInfo:nil repeats:YES];
	}
 }
 
 -(void) myTimerMethod
 
 {
 NSString *ms;
 char *flp=NULL;

// printf("*");
 if (thrds==num_threads)
	{
	flp=malloc(sizeof(char)*(101));
	strcpy(flp,mychar); 
	ms = [NSString stringWithFormat: @"%d", thisfrm];
  [[[self transformedImage] TIFFRepresentationUsingCompression:(NSTIFFCompression)NSTIFFCompressionLZW factor:(float)5]  // Create the contents of a .tiff file
	  writeToFile:[NSString stringWithFormat:@"%@%@.%@", [NSString stringWithUTF8String: flp], ms, @"tif"] // save it at the path we get from the panel.
      atomically:YES];  // That's about all there is to it...
  //  printf("%f %f %f\n", movar[0], movar[1], movar[2]);
    free(flp);
	thisfrm++;
	movfl=TRUE;
if (thisfrm<frms)
	{
	if (fltyp==3)
		{
		[self loadframe];
		}
	else
		{
		mandel=(int)movar[2];
		[RealPart setFloatValue:movar[3+5*thisfrm]];
		[ImagPart setFloatValue:movar[3+5*thisfrm+1]];
		[Scale setFloatValue:movar[3+5*thisfrm+2]];	
		[RealC setFloatValue:movar[3+5*thisfrm+3]];
		[ImagC setFloatValue:movar[3+5*thisfrm+4]];
		viewStep = [Scale floatValue] / frame.size.width;
		viewX = [RealPart floatValue]-(double) frame.size.width * viewStep * 0.5;
		viewY = [ImagPart floatValue]+(double) frame.size.height * viewStep * 0.5;
		originX = [RealC floatValue];
		originY = [ImagC floatValue];
		} 
	[self startButton:nil];
	}
	}
if (thisfrm>=frms)
	{
	[myTimer invalidate];
	thisfrm=0;
	}
}
  
- (IBAction)doSave:(id)sender
  {
  [[NSSavePanel savePanel]
    beginSheetForDirectory:NSHomeDirectory()  // seems like a reasonable place to start..
    file:@"Image" 	// default filename
    modalForWindow:window   //Run as a sheet, attached to "window"
    modalDelegate:self 	// The save panel should call me when it's done..
    didEndSelector:@selector(savePanelDidEnd:returnCode:contextInfo:) // ... using this selector
    contextInfo:NULL];
  }

- (void) savePanelDidEnd:(NSSavePanel *)sheet returnCode:(int)returnCode contextInfo:(void  *)contextInfo
  {
  if (returnCode == NSOKButton)  // The user hit "save", so...
   // [[[self transformedImage] TIFFRepresentation]  // Create the contents of a .tiff file
    //  writeToFile:[NSString stringWithFormat:@"%@.%@", [sheet filename], @"tiff"] // save it at the path we get from the panel.
     // atomically:YES];  // That's about all there is to it..
	{   // NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
   
    //the int values
    double values[29] = {
        (double)mandel,
        viewStep*frame.size.width,
        viewX+(double) frame.size.width * viewStep * 0.5,
        viewY-(double) frame.size.height * viewStep * 0.5,
		originX,
        originY,
		(double)altnGamma,
		(double)thisfn,
		(double)dzet,
		(double)orbtrap,
		(double)addc,
		(double)esconly,
		(double)altcol,
		escapeRadius,
		zetaTerms,
		attractorTerms,
		(double)max_dwells,
		(double)dolog,
		(double)sang,
		(double)domoib,
		(double)cval,
		(double)oldfn,
		creal(kk),
		cimag(kk),
		(double)(crval+2*usxi),
		(double)(fullt+2*dzsw+4*mell),
		(double)xm,
		(double)xn,
		(double)flip,
		
    };
    int i;
    NSError *error;
    //store them into a file
    NSMutableString *mutstr = [[NSMutableString alloc] init];
    for(i = 0; i < 29; i++)
        [mutstr appendFormat:@"%f ", values[i]];
    
    //write to file
    [mutstr writeToFile:[NSString stringWithFormat:@"%@.%@", [sheet filename], @"txt"] atomically:YES encoding:NSUnicodeStringEncoding error:&error];
	
	[[[self transformedImage] TIFFRepresentation]  // Create the contents of a .tiff file
      writeToFile:[NSString stringWithFormat:@"%@.%@", [sheet filename], @"tif"] // save it at the path we get from the panel.
      atomically:YES];  // That's about all there is to it..


	//[pool drain];
	}

  }

- (IBAction)doSBitmap:(id)sender
  {
  [[NSSavePanel savePanel]
    beginSheetForDirectory:NSHomeDirectory()  // seems like a reasonable place to start..
    file:@"Image" 	// default filename
    modalForWindow:window   //Run as a sheet, attached to "window"
    modalDelegate:self 	// The save panel should call me when it's done..
    didEndSelector:@selector(saveBitsPanelDidEnd:returnCode:contextInfo:) // ... using this selector
    contextInfo:NULL];
  }

- (void) saveBitsPanelDidEnd:(NSSavePanel *)sheet returnCode:(int)returnCode contextInfo:(void  *)contextInfo
  {
  if (returnCode == NSOKButton)  // The user hit "save", so...
   // [[[self transformedImage] TIFFRepresentation]  // Create the contents of a .tiff file
    //  writeToFile:[NSString stringWithFormat:@"%@.%@", [sheet filename], @"tiff"] // save it at the path we get from the panel.
     // atomically:YES];  // That's about all there is to it..
	{   // NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
    int i;
    NSError *error;
    //store them into a file
    NSMutableString *mutstr = [[NSMutableString alloc] init];
	[mutstr appendFormat:@"%f ", (double)frame.size.width];
	[mutstr appendFormat:@"%f ", (double)frame.size.height];
    for(i = 0; i < frame.size.width*frame.size.height; i++)
		{
        [mutstr appendFormat:@"%f ", creal(zmap[i])];		
        [mutstr appendFormat:@"%f ", cimag(zmap[i])];
		}
    
    //write to file
    //[mutstr writeToFile:[NSString stringWithFormat:@"%@.%@", [sheet filename], @"txt"] atomically:YES encoding:NSUnicodeStringEncoding error:&error];
	[mutstr writeToFile:[NSString stringWithFormat:@"%@.%@", [sheet filename], @"txt"] atomically:YES encoding:NSISOLatin1StringEncoding error:&error];

	//[pool drain];
	}

  }

- (void)doReportButton:(id)sender
{
originX = [RealC floatValue];
originY = [ImagC floatValue];
cval=1;
if (mandel==2)
	kk=originX+I*originY;
[self startButton:sender];

/*	int x;
	int firstDrawn = 0;
	
	for (x=0; x < height; x++)
	{
		if(drawnTable[x] == 0)
		{
			if (firstDrawn)
				printf("line %d not drawn!\n", x);
		}
		else
		{
			firstDrawn = 1;
		}
	}*/
}

- (IBAction)doTerms:(id)sender
{
if ([sender state] == NSOnState)
	fullt=TRUE;
else
	fullt=FALSE;
[dooTerms setIntValue:fullt];
doubsw=fullt+2*dzsw+4*mell;
}

- (IBAction)doMellin:(id)sender 
{    
if ([sender state] == NSOnState)
	mell=TRUE;
else
	mell=FALSE;
[dooMel setIntValue:mell];
doubsw=fullt+2*dzsw+4*mell;
}

- (void) doResetOriginButton:(id)sender
{
    //originX = 0.0;
    //originY = 0.0;
	viewStep = [Scale floatValue] / frame.size.width;
	viewX = [RealPart floatValue]-(double) frame.size.width * viewStep * 0.5;
	viewY = [ImagPart floatValue]+(double) frame.size.height * viewStep * 0.5;
	//printf("X=%f Y=%f S=%f\n",viewX, viewY, viewStep);
    [self startButton:sender];
}

- (void) resetButton:(id)sender
{
    [workLock lock];
	if (fill==0)
	{
    viewX = -40.0; viewStep = 80.0 / frame.size.width;
    viewY = (double) frame.size.height * viewStep * 0.5;
	}
	mystr=[[myFunction titleOfSelectedItem] UTF8String];
		if ((strcmp(mystr,"Fourier")==0)||(strcmp(mystr,"Power Series")==0))
		{
		viewX = -1.5; viewStep = 3.0 / frame.size.width;
		viewY = (double) frame.size.height * viewStep * 0.5;
		}		
	if (strcmp(mystr,"Bitmap")==0)
		{
		viewStep=1;
		viewX=-(double) frame.size.width * viewStep * 0.5;
		viewY=(double) frame.size.height * viewStep * 0.5;
		}	
	[RealPart setFloatValue:viewX+(double) frame.size.width * viewStep * 0.5];
	[ImagPart setFloatValue:viewY-(double) frame.size.height * viewStep * 0.5];
	[Scale setFloatValue:viewStep*frame.size.width];
	mandel=2;
	if (([Mobius state] == NSOnState )||(strcmp(mystr,"moibzeta")==0))
	//if (domoib)
		{
		viewX = -1.8;
		//viewY = 1.2;
		viewStep=3.6/frame.size.width;
		viewY = (double) frame.size.height * viewStep * 0.5;
		}
	originX = 0.0;
    originY = 0.0;
	cval=0;
	kk=0;
    [workLock unlock];
    [self startButton:sender];
}

- (void) startButton:(id)sender
{
    int x,thind;//, randIndex, tmp;
	NSNumber * currentSequence;
	char *holdstr;
	double k=40;
//printf ("threads: %d\n", num_threads );
	if (mandelrepeat>0)
		mandelrepeat=mandelrepeat-1;
    
    //printf ("Start\n");
    [workLock lock];
    comp_sequence++;
    lastLine = 0;
    total_dwells = 0;
    acc_dwells = 0;
    escapeRadius = [escapeRadiusSlider floatValue];
    zetaTerms = [fnTerms floatValue];
	attractorTerms = [attractorSlider floatValue];
    currentSequence = [[NSNumber alloc] initWithInt:comp_sequence];
	mystr=[[myFunction titleOfSelectedItem] UTF8String];
	xm=[Xm floatValue];
	xn=[Xn floatValue];
	flip=[FlipXY floatValue];
	Zrr=1000.0;
	Zii=0;	
	holdstr="Rzeta/eta/Dir L(m,n)";
	if (strcmp(mystr,holdstr)==0)
		{
		thisfn=1;
		if (usxi!=0)
			Zrr=0.5;
		}
	holdstr="Dedekind/Hecke L(m)";
	if (strcmp(mystr,holdstr)==0)
		thisfn=2;
	holdstr="Davenport(m,n)";
	if (strcmp(mystr,holdstr)==0)
		thisfn=3;
	holdstr="Abstract/raw zeta/L";
	if (strcmp(mystr,holdstr)==0)
		thisfn=4;
	holdstr="Hurwitz(m,n)";
	if (strcmp(mystr,holdstr)==0)
	{ thisfn=5; Zrr=-1; }
	holdstr="mu 1/Z(z)";
	if (strcmp(mystr,holdstr)==0)
		thisfn=6; 
	holdstr="sigma Z(z)Z(z-1)";
	if (strcmp(mystr,holdstr)==0)
		thisfn=7;
	holdstr="lambda Z(2z)/Z(z)";
	if (strcmp(mystr,holdstr)==0)
		thisfn=8;
	holdstr="Lambda -Z'(z)/Z(z)";
	if (strcmp(mystr,holdstr)==0)
		thisfn=9;
	holdstr="phi Z(z-1)/Z(z)";
	if (strcmp(mystr,holdstr)==0)
		thisfn=10;
	holdstr="dzeta";
	if (strcmp(mystr,holdstr)==0)
		{
		thisfn=11;
		//Zrr=0;
		}
	holdstr="NewtonZ";
	if (strcmp(mystr,holdstr)==0)
		{
		thisfn=12;
		Zrr=-10;
		}
	holdstr="RepellingNZ";
	if (strcmp(mystr,holdstr)==0)
		{
		thisfn=13;
		Zrr=0.998;	
		}
	holdstr="NewtonX";
	if (strcmp(mystr,holdstr)==0)
		{
		thisfn=14;
		//Zrr=0.5;
		Zrr=5.293351650238037;
		//Zrr=(5.293351650238037-0.5)/2;
		//Zrr2=-4.797651767730713;
		}
	holdstr="zetaprod";
	if (strcmp(mystr,holdstr)==0)
		thisfn=15;
	holdstr="primezeta";
	if (strcmp(mystr,holdstr)==0)
		thisfn=16;
	holdstr="Bitmap";
	if (strcmp(mystr,holdstr)==0)
		thisfn=17;
	holdstr="gamma";
	if (strcmp(mystr,holdstr)==0)
		{
		thisfn=18;
		Zrr=1.465;
		}
	holdstr="dgamma";
	if (strcmp(mystr,holdstr)==0)
		{
		thisfn=19;
		Zrr=1.465;
		} 
	holdstr="psi (digamma)";
	if (strcmp(mystr,holdstr)==0)
		thisfn=20;
	holdstr="theta";
	if (strcmp(mystr,holdstr)==0)
		thisfn=21;
	holdstr="RSZ";
	if (strcmp(mystr,holdstr)==0)
		thisfn=22;
	holdstr="zeta-z";
	if (strcmp(mystr,holdstr)==0)
		{
		thisfn=23;
		Zrr=-2.7172;
		}
	holdstr="zeta*z";
	if (strcmp(mystr,holdstr)==0)
		{
		thisfn=24;
		Zrr=2.13;
		} 
	holdstr="pi^(-z/2)*zeta";
	if (strcmp(mystr,holdstr)==0)
		thisfn=25;
	holdstr="Power Series";
	if (strcmp(mystr,holdstr)==0)
		thisfn=26;
	holdstr="Fourier";
	if (strcmp(mystr,holdstr)==0)
		thisfn=27;
	holdstr="1/(k^z)";
	if (strcmp(mystr,holdstr)==0)
		{
		thisfn=28;
		}
	holdstr="1/(1-k^(-z))";
	if (strcmp(mystr,holdstr)==0)
		{
		thisfn=29;
		}
	holdstr="k^(1-z)/(1-z)";
	if (strcmp(mystr,holdstr)==0)
		thisfn=30;
	holdstr="ze^(-z)";
	if (strcmp(mystr,holdstr)==0)
		{
		thisfn=31;
		Zrr=1;	
		}
	holdstr="Weierstrass";
	if (strcmp(mystr,holdstr)==0)
		thisfn=32;
	if (domoib)
		//Zrr=((k+1/2)*Zrr+(1-k-1/2))/(Zrr+1);
		Zrr=(-Zrr+(1-k-1/2))/(Zrr-(k+1/2));
	if (mandel==1)
		
		if ((cval==0)||(thisfn!=oldfn))
			{
			originX=Zrr;
			originY=Zii;
			}
	if ((mandel==1)||(mandel==2))		
		if (kk!=0)
			{
			originX=creal(kk);
			originY=cimag(kk);	
		//	printf("%f %f\n", originX, originY);		
			}		
	
//printf("%f\n",Zrr);
    altnGamma = atoi([[altGamma titleOfSelectedItem] UTF8String]);
	altcol = atoi([[Coloring titleOfSelectedItem] UTF8String]);
	dzet = atoi([[ThdZeta titleOfSelectedItem] UTF8String]);
	if ([Hold state] == NSOnState)
		chold=YES;
	else
		chold=NO;
	if ([showAngle state] == NSOnState)
		sang=YES;
	else
		sang=NO;
	if ([escapeOnly state] == NSOnState)
		esconly=YES;
	else
		esconly=NO;
	if ([crVal state] == NSOnState)
		crval=YES;
	else
		crval=NO;
	if ([useXi state] == NSOnState)
		usxi=YES;
	else
		usxi=NO;
	if ([dooTerms state] == NSOnState)
		fullt=YES;
	else
		fullt=NO;
	if ([dZswitch state] == NSOnState)
		dzsw=YES;
	else
		dzsw=NO;
	if ([dooMel state] == NSOnState)
		mell=YES;
	else
		mell=NO;
	if ( [logFn state] == NSOnState )
		dolog=YES;
	else
		dolog=NO;
	if ( [Mobius state] == NSOnState )
		domoib=YES;
	else
		domoib=NO;
if ( [originSwitch state] == NSOnState )
		orbtrap=YES;
	else
		orbtrap=NO;
	if ( [clearSwitch state] == NSOnState )
		addc=YES;
	else
		addc=NO;
	if ([randomizerSwitch state] == NSOnState) fill=1;
	else fill=0;
	//fill=1;
  if (movfl==FALSE)
	{
	if (chold==NO)
		{
		[RealC setFloatValue:originX];
		[ImagC setFloatValue:originY];
		}
	[RealPart setFloatValue:viewX+(double) frame.size.width * viewStep * 0.5];
	[ImagPart setFloatValue:viewY-(double) frame.size.height * viewStep * 0.5];
	[Scale setFloatValue:viewStep*frame.size.width];
	}
	movfl=FALSE;
	if ((thisfn>=15)&&(thisfn<=16)&&((thisfn!=oldfn)||(oldzTerms<zetaTerms)))
		{
		//[workLock lock];
		if (myp!=nil)
			free(myp);
		myp = calloc((long)zetaTerms+1,sizeof(long)); 
		//printf("%f\n",zetaTerms);		
		prims(zetaTerms,0);
		oldzTerms=zetaTerms;
		//[workLock unlock];
		}
	if ((xm!=0)&&((thisfn<15)||(thisfn>16))&&(thisfn!=2)&&(thisfn!=3))
		{
		if (myp!=nil)
			free(myp);
		myp = calloc((long)fabs(xm)+1,sizeof(long)); 
		prims(xm,1);
		}
	if((xm!=0)&&(thisfn!=2))
		{
		if(myv!=nil)
			free(myv);
		myv = calloc(fabs(xm)+1,sizeof(double _Complex)); 
		if ((thisfn==5)||(thisfn==3))
			{
			*(myv)=xm+I*xn;
		//	printf("%d %d\n",xm,xn);
		//	printf("%d %d\n",(int)(creal(*myv)),(int)(cimag(*myv)));
			}
			
		else
			chars(xm,xn);
		//xm=creal(*myv);
		//xn=cimag(*myv);
		}
	if ((thisfn==5)||((thisfn==3)&&(xm==9)))
		{
		old_threads = num_threads;
		num_threads = 1;
		[threadMenu selectItemAtIndex:0];
		}
	else
		{
		if (old_threads>1)
			{
			num_threads=old_threads;
            if (num_threads==2)
                thind=1;
            if (num_threads==4)
                thind=2;
            if (num_threads==8)
                thind=3;
            if (num_threads==16)
                thind=4;
            if (num_threads==64)
                thind=5;
            [threadMenu selectItemAtIndex:thind];
            //[threadMenu selectItemAtIndex:num_threads-1];
			thfl=FALSE;
			}		
		}
	if (thisfn==2) 
		{
		if(myv!=nil)
			free(myv);
		myv = calloc(1,sizeof(double _Complex)); 
		*myv=xm+I*xn;
		}
	//printf("%f \n",creal(*myv));
	[Xm setIntValue:xm];
	[Xn setIntValue:xn];
//	if ((xm==1)&&(xn==1))
//		dzet=1;
//    else
//		dzet=0;
    [ThdZeta selectItemAtIndex:dzet+1];
	doubsw=fullt+2*dzsw+4*mell;
 	oldfn=thisfn;
	[workLock unlock];
	//NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];

 	thrds=0;

  	//if ([clearSwitch state] == NSOnState)
	// {
	for (x=0; x < (frame.size.width * frame.size.height * 3); x++)
	{
	    bitmapData[x] = 255;
	}
   // }
    stbut=1;
    [self displayRect:frame];
    
    for (x = 0; x < height; x++) drawnTable[x] = 0;
    for (x = 0; x < height; x++) lineTable[x] = x;
	
	/*if ([randomizerSwitch state] == NSOnState) {
	for (x = 0; x < height; x++)
	{
	    randIndex = rand() % height;
	    tmp = lineTable[x];
	    lineTable[x] = lineTable[randIndex];
	    lineTable[randIndex] = tmp;
	}
    }*/
	/*if (myp!=nil)
		//{
		free(myp);
		//printf("free\n");
		//}*/
    for (x = 0; x < num_threads; x++)
        [NSThread detachNewThreadSelector:@selector(threadMain:) toTarget:self withObject:[currentSequence retain]];
    [currentSequence release];
	//[pool drain];

}

- (void)drawRect:(NSRect)rect
{
    // NSGraphicsContext *currentContext = [NSGraphicsContext currentContext];
    NSRect currentFrame;
    int needsStartButton = 0;
    // NSAffineTransform * myTransform;
    int x;
    
	//printf("Draw stbut=%d\n",stbut);
    currentFrame = [self bounds];
    [workLock lock];
	
    
 
    if ((myImage != nil) && ! (
	( currentFrame.size.width == frame.size.width ) &&
	( currentFrame.size.height == frame.size.height )
    )) // resized!
    {
	comp_sequence++; // invalidate any current work
	[myImage release];
	myImage = nil;
	viewX -= viewStep * ( currentFrame.size.width - frame.size.width ) / 2.0 ;
	viewY += viewStep * ( currentFrame.size.height - frame.size.height ) / 2.0 ;
	height = currentFrame.size.height ;
	needsStartButton = 1;
	stbut=1;
    }

	if (myImage != nil)
	{
		//printf("Release\n");
		[myImage release];
		myImage = nil;
	}

    if (myImage == nil)
		{	
		
		// printf("Init\n");
		frame = currentFrame;
        window = [self window];
		
        myImage = [NSBitmapImageRep alloc];
        [myImage
		 initWithBitmapDataPlanes:NULL
		 pixelsWide:frame.size.width pixelsHigh:frame.size.height
		 bitsPerSample:8 samplesPerPixel:3 hasAlpha:NO isPlanar:NO
		 colorSpaceName:NSCalibratedRGBColorSpace
		 bytesPerRow:(frame.size.width*3) bitsPerPixel:0
		 ];
		macbitmapData = [myImage bitmapData];
		if (stbut==1)
			{
			macbitmapData = [myImage bitmapData];
			stbut=0;
			for (x=0; x < (frame.size.width * frame.size.height * 3); x++)
				{
					macbitmapData[x] = 255;
				}			
			}
		else
			for (x=0; x < (frame.size.width * frame.size.height * 3); x++)
			{
				macbitmapData[x] = bitmapData[x];
			}
		}
    if (rect.size.height < height) // only pay attention to partial drawing
		{
			for(x=0; x < (int)rect.size.height; x++) drawnTable[(int)rect.origin.y + x] = 1;
		}
	[myImage drawInRect:currentFrame];
    if (isDragging)
    {
		[[[NSColor selectedTextBackgroundColor] colorWithAlphaComponent:0.35] set];
		NSRectFillUsingOperation (mouseDragRect, NSCompositeSourceOver);
		[[NSColor selectedTextBackgroundColor] set];
		NSFrameRect (mouseDragRect);
    }
    [workLock unlock];
    
    // [currentContext restoreGraphicsState];
    if (needsStartButton)
		[self startButton:nil];
}

- (BOOL) acceptsFirstMouse:(NSEvent *)theEvent { return NO; }
- (BOOL) acceptsFirstResponder { return YES; }
- (BOOL) isOpaque { return YES; }
- (BOOL) isFlipped { return NO; }


- (void)mouseDown:(NSEvent *)theEvent
{
	mouseDownPoint = [self convertPoint:[theEvent locationInWindow] fromView:nil];
	isSelecting = YES; isDragging = NO;
}

- (void)mouseUp:(NSEvent *)theEvent
{
	double newX, newY;
	int i;

	if (isDragging && mouseDragRect.size.width < kCollapseDrag )
	{
		isSelecting = NO; isDragging = NO;
		return;
	}

	if (isDragging)
	{
		newX = viewX + ( viewStep * mouseDragRect.origin.x );
		newY = viewY - ( viewStep * (frame.size.height - (mouseDragRect.origin.y + mouseDragRect.size.height)));
	}
	else
	{
		newX = viewX + ( viewStep * mouseDownPoint.x );
		newY = viewY - ( viewStep * (frame.size.height - mouseDownPoint.y ));
	}
	
	[workLock lock];
	{
		if (isDragging)
		{
			viewX = newX;
			viewY = newY;
			
			viewStep = viewStep * (mouseDragRect.size.width / frame.size.width);
			[RealPart setFloatValue:viewX+(double) frame.size.width * viewStep * 0.5];
			[ImagPart setFloatValue:viewY-(double) frame.size.height * viewStep * 0.5];
			[Scale setFloatValue:viewStep*frame.size.width];
		}
		else
		{
			//viewX = newX - ( viewStep * frame.size.width * 0.25 );
			//viewY = newY + ( viewStep * frame.size.height * 0.25 );
			originX=newX; originY=newY;
			//viewX = -2.5; viewStep = 4.0 / frame.size.width;
			//viewY = (double) frame.size.height * viewStep * 0.5;
			if ([randomizerSwitch state] == NSOnState) fill=1;
			else fill=0;
			if (mandel == 2) {
				mandel=1;
				//originX=Zrr; originY=0;
				if (fill==0)
					{
					viewX = -40.0; 
					viewStep = 80.0 / frame.size.width;
					viewY = (double) frame.size.height * viewStep * 0.5; }
			/*	else {
					viewXj = viewX; 
					viewStepj = viewStep;
					viewYj = viewY; 
				}*/

					}
			else if (mandel == 1) {
				mandel=0;
				//if (fill==0)
					//{
					viewXj = viewX; 
					viewStepj = viewStep;
					viewYj = viewY; 
					viewX = -40.0; 
					viewStep = 80.0 / frame.size.width;
					viewY = (double) frame.size.height * viewStep * 0.5; 
			
					for(i=1;i<2048*1536*3;i++)
						bitmapDatasav[i]=bitmapData[i];
			}
			//}
			else if (mandel== 0)
				{
				originX=0.0; originY=0.0;
				mandel=1;
				if (fill==0)
					{
					viewX = -40.0; 
					viewStep = 80.0 / frame.size.width;
					viewY = (double) frame.size.height * viewStep * 0.5;
					}
				else
					{
					viewX = viewXj; 
					viewStep = viewStepj;
					viewY = viewYj; 
					mandelrepeat=2;
					}
				}
				//viewStep = viewStep * 0.5 ;
		}
	}
	[workLock unlock];
	[self startButton:nil];
	if ((!isDragging)&&(mandel==1)&&(kk==0))
		{ 		
		originX=Zrr; 		
		originY=Zii;
		if (chold==NO)
			{
			[RealC setFloatValue:originX];
			[ImagC setFloatValue:originY];
			}
		}
	isSelecting = NO; isDragging = NO;
	//[RealC setFloatValue:originX];
	//[ImagC setFloatValue:originY];
	[RealPart setFloatValue:viewX+(double) frame.size.width * viewStep * 0.5];
	[ImagPart setFloatValue:viewY-(double) frame.size.height * viewStep * 0.5];
	[Scale setFloatValue:viewStep*frame.size.width];	

}

- (void)mouseDragged:(NSEvent *)theEvent
{
	if (isDragging)
		[self setNeedsDisplayInRect:mouseDragRect];
	isDragging = YES;
	mouseDragPoint = [self convertPoint:[theEvent locationInWindow] fromView:nil];
	mouseDragRect = [MTRectTools makeRectFromPoint:mouseDownPoint toPoint:mouseDragPoint];
	mouseDragRect = [MTRectTools constrainRect:mouseDragRect toAspect:frame.size collapseAt:kCollapseDrag];
	mouseDragRect = [MTRectTools scaleRect:mouseDragRect toFit:frame];
	mouseDragRect = [MTRectTools normalizeRect:mouseDragRect];
	[self setNeedsDisplayInRect:mouseDragRect];
}

/*- (void)keyDown:(NSEvent *)theEvent
{
    NSBezierPath * myPath;
    NSGraphicsContext *currentContext ;
        
    printf ("keydown\n");
    [self lockFocus];
    currentContext = [NSGraphicsContext currentContext];

    myPath = [NSBezierPath bezierPath];
    [myPath setLineWidth:20];
    [myPath moveToPoint:NSMakePoint(-100.0,-100.0)];
    [myPath lineToPoint:NSMakePoint(200.0,300.0)];
    [myPath stroke];
    [currentContext flushGraphics];
    [self unlockFocus];
    // printf ("keyDown\n");
}*/

/*- (void)keyUp:(NSEvent *)theEvent
{
     printf ("keyUp\n");
}*/

- (void) doThreadMenu:(id)sender
{
    num_threads = atoi([[sender titleOfSelectedItem] UTF8String]);
	old_threads=num_threads;
    // printf ("threads: %d\n", num_threads );
}

- (void) doDwellMenu:(id)sender
{
    max_dwells = atoi([[sender titleOfSelectedItem] UTF8String]);
    //printf ("max dwells: %d\n", max_dwells);
}


- (void)threadMain:(NSNumber *)currentSequence
{
    int w, h, i;
    double buf[16384]; // BUG!
    int update_dwells;
    double x, y, step, currentY;
    int idx, bitmapIdx;
    int working_sequence;
    int myLine;
    NSRect updateRect;
	double colfac=0.4;
	double colfac2=0.14;
	double colfac3=2*3.1415926535/3;
	double pw,hold;
	double cr,ci;
	double _Complex ch;
//double colfac3=pi;

	int idx3;
	//int altcol = 0;
	//const pi=3.14159;
    
    x = viewX; y = viewY;
    w = frame.size.width;
    h = frame.size.height;
    
    updateRect.origin.x = 0;
    updateRect.size.width = w;
    updateRect.size.height = 1;
    
    step = viewStep;
    // printf ("viewX: %f  viewY: %f  viewStep: %f\n", x, y, step );

    working_sequence = [currentSequence intValue];
    [currentSequence release];
    
    while (1)
    {
  [workLock lock];
	
		
	if (working_sequence != comp_sequence)
	{
		[workLock unlock];
		return;
	}
	myLine = lastLine++;
	[workLock unlock];
	if (myLine >= h)
	    break;
	currentY = y - (step * lineTable[myLine]);
	//printf("%d ",dzet);
	if (mandelrepeat==0)

	{
	update_dwells = mandelLine (kk, addc, dzet, thisfn, doubsw, crval, esconly, fill, (int)altcol, (int)orbtrap, attractorTerms, zetaTerms, altnGamma, mandel, originX, originY, escapeRadius, x, currentY, step, max_dwells, w, buf, myp, myv, myfl, myw,myh,dolog, domoib,flip,usxi);
	[workLock lock];
	if (working_sequence != comp_sequence)
	{
	    [workLock unlock];
	    return;
	}
	{
	total_dwells += update_dwells; acc_dwells += update_dwells;
		
        for (idx = 0, bitmapIdx = lineTable[myLine] * w * 3; idx < w; idx++, bitmapIdx += 3 )
        {
 			idx3=idx*3;
			if (mandel == 2)
				{
				switch (altcol)
				{
				case 1:
				{
			//	if (buf[idx3] == -1)
			//		bitmapData[bitmapIdx    ] = 0;
			//	else
					bitmapData[bitmapIdx    ] = (int)255*(1-cos(pi*buf[idx3]))/2;
					//bitmapData[bitmapIdx    ] = (int)255*(1-cos(pi*buf[idx3]))/2;
						if (sang)
						bitmapData[bitmapIdx + 1] = (int)255*(1-sin(buf[idx3+2]))/2;
						//bitmapData[bitmapIdx + 1] = (int)255*(1-cos(buf[idx3+2]))/2;
					
					else
						bitmapData[bitmapIdx + 1] = 0;
					bitmapData[bitmapIdx + 2] = (int)255*(1-cos(pi*buf[idx3+1]))/2;
					//bitmapData[bitmapIdx + 2] = (int)255*(1-cos(pi*buf[idx3+1]))/2;
					
					
				break;
				}
				case 2:
				{
				cr=buf[idx3+1]*ccos(buf[idx3+2]);
				ci=buf[idx3+1]*csin(buf[idx3+2]);
				pw=pow(10,attractorTerms);
				bitmapData[bitmapIdx    ] = (int)255*exp(-cr*cr/pw);
				if (sang)
					bitmapData[bitmapIdx + 1] = (int)127*exp(-ci*ci/pw)+(int)128*(1-sin(buf[idx3+2]))/2;
				else
					bitmapData[bitmapIdx + 1] = 0;
				bitmapData[bitmapIdx + 2] = (int)127*exp(-ci*ci*attractorTerms)+(int)128*(1+cos(buf[idx3+1]))/2;
				break;
				}
				case 3:
				{
				//if (buf[idx3] == -1)
				//		bitmapData[bitmapIdx] = 0;
				//else
					//bitmapData[bitmapIdx    ] = (int)255*(1-sin(pi*buf[idx3]))/2;
					//bitmapData[bitmapIdx + 1] = (int)255*(1-sin(buf[idx3+2]))/2;
					//bitmapData[bitmapIdx + 2] = (int)255*(1-sin(pi*buf[idx3+1]))/2;
					//buf[idx3+2]=0;
					if (sang)
						hold=buf[idx3+2];
					else
						hold=0;
					bitmapData[bitmapIdx    ] = (int)255*((hold<0)*(1-cos(colfac3*hold))/8+(buf[idx3]>=0)*(1-cos(colfac3*buf[idx3]))/4+(buf[idx3+1]<0)*(1-cos(colfac3*buf[idx3+1]))/8);
					bitmapData[bitmapIdx + 1] = (int)255*((buf[idx3]<0)*(1-cos(colfac3*buf[idx3]))/8+(buf[idx3+1]>=0)*(1-cos(colfac3*buf[idx3+1]))/4+(hold<0)*(1-cos(colfac3*hold))/8);
					bitmapData[bitmapIdx + 2] = (int)255*((buf[idx3+1]<0)*(1-cos(colfac3*buf[idx3+1]))/8+(hold>=0)*(1-cos(colfac3*hold))/4+(buf[idx3]<0)*(1-cos(colfac3*buf[idx3]))/8);
					break;
				}
				case 5:
				{
					zmap[bitmapIdx/3]=buf[idx3+1]*cexp(I*buf[idx3+2]);
					if (sang)
						{
						bitmapData[bitmapIdx] = (int)255*(1-cos(buf[idx3+2]))/2;
						bitmapData[bitmapIdx + 1] = (int)255*(1-sin(buf[idx3+2]))/2;
						}
					else
						{
						bitmapData[bitmapIdx    ] = 0;
						bitmapData[bitmapIdx + 1] = 0;
						}
					//bitmapData[bitmapIdx + 1] = (int)255*(pi+buf[idx3+2]/2/pi);
					bitmapData[bitmapIdx + 2] = (int)255*(buf[idx3+1]/(1+buf[idx3+1]));	
					break;			
				}				
				/*case 5:
				{
					if (sang)
						{
						bitmapData[bitmapIdx] = (int)255*(buf[idx3+1]/(1+buf[idx3+1]))*(1-cos(buf[idx3+2]))/2;
						bitmapData[bitmapIdx + 1] = (int)255*(buf[idx3+1]/(1+buf[idx3+1]))*(1-cos(buf[idx3+2]+2*pi/3))/2;
						bitmapData[bitmapIdx + 2] = (int)255*(buf[idx3+1]/(1+buf[idx3+1]))*(1-cos(buf[idx3+2]+4*pi/3))/2;
						}
					else
						{
						bitmapData[bitmapIdx    ] = 0;
						bitmapData[bitmapIdx + 1] = 0;
						bitmapData[bitmapIdx + 2] = (int)255*(buf[idx3+1]/(1+buf[idx3+1]));	
						}
					//bitmapData[bitmapIdx + 1] = (int)255*(pi+buf[idx3+2]/2/pi);
					//bitmapData[bitmapIdx + 2] = (int)255*(buf[idx3+1]/(1+buf[idx3+1]));	
					break;			
				}*/
				default:
				{
				//if (buf[idx3] == -1)
				//		bitmapData[bitmapIdx] = 0;
				//else
					//hold=log(1+log(1+buf[idx3+1]));
					if(altcol==4)
						{
						ch=buf[idx3+1]*cexp(buf[idx3+2]*I);
						if (usxi==0)
							ch=1/(1-ch);
					//	buf[idx3+2]=carg(ch);
						ch=exp(escapeRadius)/2*clog(ch);
						buf[idx3+1]=cabs(ch);
					//	buf[idx3+2]=carg(ch);
					//	buf[idx3+1]=creal(ch);
					//	buf[idx3+2]=cimag(ch);
						}
					//if (usxi!=0)
					//	buf[idx3+1]=1.0/buf[idx3+1];
					hold=log(1+buf[idx3+1]);
					bitmapData[bitmapIdx    ] = (int)255*hold/(1+hold);//(1-cos(pi*log(buf[idx3+1])))/2;
					if (sang)
						bitmapData[bitmapIdx + 1] = (int)255*(1-sin(buf[idx3+2]))/2;
					else
						bitmapData[bitmapIdx + 1] = 0;
					//bitmapData[bitmapIdx + 2] = (int)255*(1-(1-hold)*cos(pi*buf[idx3+1]))/(2-hold);
					bitmapData[bitmapIdx + 2] = (int)255*(1-cos(pi*buf[idx3+1]))/2;
					break;
				}
				}
				}
			else
			{
			switch (altcol)
			{
			case 5:
				if (mandel==0)
				{
				if (buf[idx3] == -1)
					bitmapData[bitmapIdx    ] = 0;
				else
				   {
				   hold=pow(buf[idx3],3)/1000;
				   bitmapData[bitmapIdx    ] = (int)255*(1-hold/(1+hold));
				 // bitmapData[bitmapIdx    ] = (int)(1+254*(1+cos(colfac2*buf[idx3]))/2);
				  }
				if (buf[idx3+1] == -1)
					bitmapData[bitmapIdx + 1] = 0;
				else
				{
					hold=pow(buf[idx3+1],3)/1000;
				   bitmapData[bitmapIdx + 1  ] = (int)255*(1-hold/(1+hold));						
				  // bitmapData[bitmapIdx + 1] = (int)(1+254*(1+cos(colfac2*buf[idx3+1]))/2);
				   }
				if (buf[idx3+2] == -1)
					bitmapData[bitmapIdx + 2] = 0;
				else if (buf[idx3+2] < -1)
					bitmapData[bitmapIdx + 2    ] = (int)255*(-buf[idx3+2]-1);
				else if (buf[idx3+2] >= 0)
				{
				  // hold=pow(buf[idx3+2],5)/100;
				  // bitmapData[bitmapIdx + 2    ] = (int)255*(hold/(1+hold));
						   bitmapData[bitmapIdx + 2] = (int)(1+254*(1-cos(colfac2*5.7*buf[idx3+2]))/2);
						   }
				break;
				}
				else
				{
				if (buf[idx3] == -1)
					{
					bitmapData[bitmapIdx    ] = 0;
					bitmapData[bitmapIdx + 1] = 0;
					bitmapData[bitmapIdx + 2] = 0;
					}
				if (buf[idx3] >= 0)
					{
					bitmapData[bitmapIdx    ] = (int)(255*((sin(colfac*buf[idx3]+pi)+1)/2));//(int)(255*((sin(colfac*buf[idx3])+1)/2));
					bitmapData[bitmapIdx + 1] = 128+(int)(127*((sin(colfac*buf[idx3])+1)/2));
					bitmapData[bitmapIdx + 2] = 0;//(int)(255*((sin(colfac*buf[idx3]+pi)+1)/2));
					}
				if (buf[idx3] < -1)
					{
					bitmapData[bitmapIdx    ] = (int)(255*((cos(colfac*buf[idx3+1]-3)+1)/2));
					bitmapData[bitmapIdx + 1] = 0;//(int)(255*((cos(colfac2*buf[idx3]-2)+1)/2));
					bitmapData[bitmapIdx + 2] = (int)(255*((max_dwells+buf[idx3]+2)/max_dwells))^4;
					}	
					break;			
				}
			case 3:
				{
				if (buf[idx3] < 0)
					{
					bitmapData[bitmapIdx    ] = 0;
					bitmapData[bitmapIdx + 1] = 0;
					bitmapData[bitmapIdx + 2] = 0;
					}
				if (buf[idx3] >= 0)
					{
					bitmapData[bitmapIdx    ] = (int)(255*((sin(colfac*buf[idx3])+1)/2));
					bitmapData[bitmapIdx + 1] = (int)(255*((sin(colfac*buf[idx3]+2*pi/3)+1)/2));
					bitmapData[bitmapIdx + 2] = (int)(255*((sin(colfac*buf[idx3]+4*pi/3)+1)/2));
					}
					break;
				}
			case 2:
				{
				if (buf[idx3] <= -1)
					{
					bitmapData[bitmapIdx    ] = 0;
					bitmapData[bitmapIdx + 1] = 0;
					bitmapData[bitmapIdx + 2] = 0;
					}
				else
					{
					bitmapData[bitmapIdx    ] = 64+(16-(int)(buf[idx3]) % 16) * 12;
					bitmapData[bitmapIdx + 1] = ((16-(int)(buf[idx3]) / 16 ) % 16 ) * 16;
					bitmapData[bitmapIdx + 2] = ((16-(int)(buf[idx3]) / 256 ) % 16 ) * 16;
					}
				break;
				}
			case 1:
				{
					if (buf[idx3] == -1) //bounded no periods
					{
						bitmapData[bitmapIdx    ] = 0;
						bitmapData[bitmapIdx + 1] = 0;
						bitmapData[bitmapIdx + 2] = 0;
					}
					if (buf[idx3] >= 0)					
					{
						bitmapData[bitmapIdx    ] = (int)(255*((sin(colfac*buf[idx3])+1)/2));
						bitmapData[bitmapIdx + 1] = (int)(255*((sin(colfac*buf[idx3])+1)/2));
						bitmapData[bitmapIdx + 2] = (int)(255*((sin(colfac*buf[idx3])+1)/2));
					}
					if (buf[idx3] < -1) //periods
					{
						hold=((max_dwells+buf[idx3]+2)/max_dwells);//((sin(colfac*buf[idx3])+1)/2);
						buf[idx3+1]=buf[idx3+1]-1;
						i=0;
						if (buf[idx3+1]>=17)
						{
							buf[idx3+1]=buf[idx3+1]-17;
							i=128;
							//printf("*");
						}
						if (buf[idx3+1]<3)
						{
							bitmapData[bitmapIdx    ] =	255*hold;
							bitmapData[bitmapIdx + 1] = (int)(255*hold*(1.0-cos(buf[idx3+1]*pi/3))/2);
							bitmapData[bitmapIdx + 2] = i;							
						}
						if ((buf[idx3+1]>=3)&&(buf[idx3+1]<6))
						{
							bitmapData[bitmapIdx    ] = (int)(255*hold*(1.0+cos((buf[idx3+1]-3)*pi/3))/2);					    
							bitmapData[bitmapIdx + 1] = 255*hold;
							bitmapData[bitmapIdx + 2] = i;																																	  
						}
						if ((buf[idx3+1]>=6)&&(buf[idx3+1]<9))
						{
							bitmapData[bitmapIdx    ] =	i;
							bitmapData[bitmapIdx + 1] = 255*hold;
							bitmapData[bitmapIdx + 2] = (int)(255*hold*(1.0-cos((buf[idx3+1]-6)*pi/3))/2);							
						}
						if ((buf[idx3+1]>=9)&&(buf[idx3+1]<12))
						{
							bitmapData[bitmapIdx    ] = i;					    
							bitmapData[bitmapIdx + 1] = (int)(255*hold*(1.0+cos((buf[idx3+1]-9)*pi/3))/2);
							bitmapData[bitmapIdx + 2] = 255*hold;																																	  
						}
						if ((buf[idx3+1]>=12)&&(buf[idx3+1]<15))
						{
							bitmapData[bitmapIdx    ] =	(int)(255*hold*(1.0-cos((buf[idx3+1]-12)*pi/3))/2);
							bitmapData[bitmapIdx + 1] = i;
							bitmapData[bitmapIdx + 2] = 255*hold;							
						}
						if ((buf[idx3+1]>=15)&&(buf[idx3+1]<17))
						{
							bitmapData[bitmapIdx    ] = 255*hold;					    
							bitmapData[bitmapIdx + 1] = i;
							bitmapData[bitmapIdx + 2] = (int)(255*hold*(1.0+cos((buf[idx3+1]-15)*pi/3))/2);																																  
						}
						/*if (buf[idx3+1]==17)
						{
							bitmapData[bitmapIdx    ] = 255*hold;					    
							bitmapData[bitmapIdx + 1] = 128*hold;
							bitmapData[bitmapIdx + 2] = 128*hold;																																  
						}*/
						
					}				
				break;
				}
			default:
				{
				if (buf[idx3] <= -1)
					{
					bitmapData[bitmapIdx    ] = 0;
					bitmapData[bitmapIdx + 1] = 0;
					bitmapData[bitmapIdx + 2] = 0;
					}
				if (altcol==4)
					if (buf[idx3] < -1)
						buf[idx3]=-buf[idx3]-2+20;
				if (buf[idx3] >= 0)
					{
				if (altcol==4)
					{
					
					bitmapData[bitmapIdx    ] = (int)(255*((sin(colfac*sqrt(buf[idx3]))+1)/2));
					bitmapData[bitmapIdx + 1] = (int)(255*((sin(4.0/3.0*colfac*sqrt(buf[idx3])+pi/4)+1)/2));
					bitmapData[bitmapIdx + 2] = (int)(255*((sin(3.0/2.0*colfac*sqrt(buf[idx3])+pi/2)+1)/2));
					}
				else
					{
					bitmapData[bitmapIdx    ] = (int)(255*((sin(colfac*buf[idx3])+1)/2));
					bitmapData[bitmapIdx + 1] = (int)(255*((sin(4.0/3.0*colfac*buf[idx3]+pi/4)+1)/2));
					bitmapData[bitmapIdx + 2] = (int)(255*((sin(3.0/2.0*colfac*buf[idx3]+pi/2)+1)/2));
					}
					}
				break;
				}
			}
		}
		}
	}
	/*
        if ( acc_dwells > 10000000 )
        {
            [self setNeedsDisplay:YES];
            acc_dwells = 0;
        }
	*/
	}
	else {
		[workLock lock];
		for (idx = 0, bitmapIdx = lineTable[myLine] * w * 3; idx < w; idx++, bitmapIdx += 3 )
		{
			bitmapData[bitmapIdx    ] = bitmapDatasav[bitmapIdx    ];
			bitmapData[bitmapIdx + 1] = bitmapDatasav[bitmapIdx + 1];
			bitmapData[bitmapIdx + 2] = bitmapDatasav[bitmapIdx + 2];	}
	}
		
	updateRect.origin.y = h - lineTable[myLine];
	[self setNeedsDisplayInRect:updateRect];
	[workLock unlock];
    }
    
    // [workLock lock];
   // [self setNeedsDisplay:YES];
    // [workLock unlock];
  //  sleep(1);
    [self setNeedsDisplay:YES];
    // printf ("exiting thread\n");
	thrds++;
    return;
}

// delegate of NSApplication
- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    // for some reason, app's window doesn't start out being key and front.  :(
   // printf ("applicationDidFinishLaunching\n");
    [window makeKeyAndOrderFront:nil];
    [window setInitialFirstResponder:self];
    num_threads = atoi([[threadMenu titleOfSelectedItem] UTF8String]);
    max_dwells = atoi([[dwellMenu titleOfSelectedItem] UTF8String]);
    lastLine = 0;
    height = frame.size.height;
    comp_sequence = 0;
    // viewX = -2.5; viewStep = 4.0 / frame.size.width;
    // viewY = (double) frame.size.height * viewStep * 0.5;
   // originX = 0.0;
    //originY = 0.0;
	//mandel=1;
    workLock = [[NSLock alloc] init];
    isSelecting = NO; isDragging = NO;
    [self resetButton:nil];
    //    [NSThread detachNewThreadSelector:@selector(threadMain) toTarget:self withObject:nil];

}

- (BOOL)applicationShouldTerminateAfterLastWindowClosed:(NSApplication *)theApplication
{
    return YES;
}

@end
